/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 2 "src/mup/gram.y" /* yacc.c:339  */


/*
 Copyright (c) 1995-2022  by Arkkra Enterprises.
 All rights reserved.

 Redistribution and use in source and binary forms,
 with or without modification, are permitted provided that
 the following conditions are met:

 1. Redistributions of source code must retain
 the above copyright notice, this list of conditions
 and the following DISCLAIMER.

 2. Redistributions in binary form must reproduce the above
 copyright notice, this list of conditions and
 the following DISCLAIMER in the documentation and/or
 other materials provided with the distribution.

 3. Any additions, deletions, or changes to the original files
 must be clearly indicated in accompanying documentation,
 including the reasons for the changes,
 and the names of those who made the modifications.

	DISCLAIMER

 THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS
 OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 THE IMPLIED WARRANTIES OF MERCHANTABILITY
 AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT,
 INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* This file contains the parser code for the Mup music publication program.
 * It uses lex to get the tokens.
 */


#include "rational.h"
#include "globals.h"
#include "defines.h"
#include "structs.h"
#include <errno.h>

#define YYDEBUG 1


/* how many items to allocate at a time for
 * "with" list, and location lists, etc */
#define ITEMS	(4)

/* Shorter way to refer to the current entry when building an entry from
 * accidentals context */
#define CURR_ACC_ENTRY	Acc_contexts_list_p->info[Curr_acc_index]

/* It user gives consecutive restoreparms with no intervening saveparms,
 * all but the last are pointless, as the last overwrites. So we have simple
 * state machine to catch this and print a warning. Even with an intervening
 * saveparms, multiple restoreparms is dubious, because really all you could
 * do is save something that you had already saved, but under a different
 * name. But we distinguish those cases. These value record what was
 * the previous control {Save|Restore}parms command type.
 * Once we see warn case, we stay in that state
 * to avoid duplicate warnings for the same issue.
 */
#define SR_SAVE		(0)
#define SR_RESTORE	(1)
#define SR_WARN	(2)


static struct MAINLL *Currstruct_p;	/* main list struct being filled in */
static struct BLOCKHEAD *Currblock_p;	/* current block, if non-zero */

static struct INPCOORD *Curr_loc_info_p; /* location info being collected */
static struct USER_SYMBOL *Curr_usym_p;	/* user-defined symbol being defined */


static short Saw_restoreparms;		/* Yes if we have seen a restoreparms
					 * in the current control context */
static short Prev_control_parms;	/* Previous {save|restore}parms */
static short Getting_tup_dur;		/* YES if currently collection tuplet
					 * duration rather than GRPSYL dur */

static struct GRPSYL *Curr_grpsyl_p;	/* current GRPSYL struct being filled in */
static struct GRPSYL *Last_grpsyl_p;	/* previous GRPSYL struct filled in (contains
					 * defaults for the current one */
static struct TIMELIST *Extra_time_p;	/* If user enters times to be added
					 * together, like 2.+16 this points to
					 * a linked list of the extra times */
static struct TIMELIST *Curr_timelist_p;/* current additive time, used to know
					 * where to link items to the list */
static struct TIMELIST *Last_alloced_timelist_p; /* Most recently allocated
					 * list. Keeping track of this lets us
					 * avoid trying to free the list
					 * when Extra_time_p is pointing
					 * to a list from an SSV. */
static struct GRPSYL *Prev_grpsyl_p;	/* Like Last_grpsyl_p except in the
					 * case of additive times,
					 * in which case it points to the
					 * first group. This is needed in case
					 * the following group is to get its
					 * time value by defaulting to that
					 * of its previous group. */
static int Extra_basictime;		/* for saving basictime, when doing
					 * additive times */
static int Doing_timeunit = NO;		/* YES if gathering timeunit param */
static short Doing_vcombine;		/* YES if gathering vcombine param */
static short Doing_samescore = NO;	/* YES if after samescorebegin */
static short Doing_samepage = NO;	/* YES if after samepagebegin */
static struct GRPSYL *Lyrics_p;		/* pointer to current list of lyrics */
static struct WITH_ITEM *Curr_marklist;	/* current "with" list */
static int Mark_start;			/* Index into Curr_marklist at which
					 * the currently-being-gathered list
					 * began, since user could do things
					 * like [with - above;with . below][with "sfz"]
					 * Since we don't know the place till
					 * the end of a list, this lets us
					 * know how far back in the list to
					 * update with above or below.
					 */
static struct PRINTDATA **Next_print_link_p_p;	/* points to where to attach next
						 * print command that we get */
static int Item_count;			/* items in current list */
static int Max_items;			/* current amount of space in lists
					 * "with" list, curve locations, etc) */

static int Plus_minus;			/* if 1 add, if -1 subtract offset */
static int Defining_multiple = NO;	/* if defining multiple voices at once */
static int Chord_at_a_time = NO;	/* YES for chord-at-a-time,
					 * NO for voice-at-a-time */
static short Meas_rpt_type;		/* Current MRT_* value */
static int EM_staff;			/* Staff number of most recent
					 * emptymeas parameter usage */
static short Endingloc;			/* if current bar starts or ends an
					 * ending, etc (STARTITEM, ENDITEM, etc) */
static short Endending_type;		/* EE_* value. Only relevent if
					 * Endingloc == ENDITEM */
static short Got_ending;		/* YES if got ending on this bar */

static int Til_bars;			/* number of bars in "til" clause */
static int Bar_between;                 /* YES or NO, if to put bar lines
                                         * between staffs rather than on then */
static struct SUBBAR_APPEARANCE *Subbar_app_p;	/* Info for subbartype parameter */
static double Dist;			/* dist for a specific STUFF */
static int Dist_usage;			/* meaning of Dist field */
static int Aligntag = NOALIGNTAG;	/* align tag number for STUFF */
static short User_meas_time;		/* YES if user specified a time for
					 * an 'm' item. Only valid on mr */
static int Order_place;			/* PL_* for markorder in SSV */
static int Order_prio;			/* value in markorder in SSV */
static int Start_gracebackup;		/* how many grace notes to back up
					 * before starting a "stuff" */
static int End_gracebackup;		/* how many grace notes to back up
					 * before ending a "stuff" */
static float Til_offset;		/* beat count in "til" clause */
static float Til_steps;			/* stepsize offset of "til" clause */
static int Linetype;			/* L_DOTTED, L_DASHED, or L_NORMAL */

static char *String1, *String2;		/* to temporarily keep track
					 * of labels and other temporary
					 * strings */
static char Tmpbuff[20];		/* temporary buffer for converting
					 * float numbers */
static char Stringbuff[100];		/* temporary string storage */
static int Titlefont, Titlesize;	/* font/size for title command */
static double Extra;			/* extra vertical space for prints */
static short Good_till_canceled = NO;	/* if [] things should be continued
					 * until turned off */
static short Curr_paratype = J_JUSTPARA; /* current paragraph type */
static char Curr_accs[2*MAX_ACCS];	/* list of current note's accidentals */
static int Acc_offset;			/* Current place in Curr_accs */
static int Curr_acc_index;		/* Current place in info array of
					 * current accidentals context */
static struct TIMEDSSV *Curr_tssv_p;	/* current mid-measure param change */
static char Timerep[MAXTSLEN];		/* Internal representation of time
					 * signature being collected */
static int Tsig_offset;			/* Current place in Timerep while
					 * collecting a time signature */
static struct TAG_REF *Curr_timeref_tag_p; /* Time offsets are relative
					 * to the most recent horizontal tag.
					 * This points to that tag,
					 * or is zero if no such tag yet */

/* Row index values must match the PS_* value definitions in defines.h.
 * Column [0] is height in portrait mode, and column [1] is height. */
double pagesztbl[7][2] = {
	{ 8.5, 11.0 },		/* PS_LETTER */
	{ 8.5, 14.0 },		/* PS_LEGAL */
	{ 8.5, 13.0 },		/* PS_FLSA */
	{ 5.5, 8.5 },		/* PS_HALFLETTER */
	{ 8.26, 11.69 },	/* PS_A4 */
	{ 5.84, 8.26 },		/* PS_A5 */
	{ 4.12, 5.84 }		/* PS_A6 */
};



/* static functions */
static char *stripquotes P((char *string));	/* rmv double quotes
						 * from string */
static void chkdup_headfoot P((int bit, char *which, struct BLOCKHEAD *block_p));
static void chkdup_topbot P((struct BLOCKHEAD **block_p_p, char *blocktype));
static void end_prev_context P((void));
static void clone_staff_ssvs P((struct MAINLL *insert_p));
static void clone_voice_ssvs P((struct MAINLL *insert_p));
static void clone1ssv P((struct SSV *clone_src_p, struct MAINLL *insert_p,
		int staffno, int voiceno));
static void chk_ssv_ranges P((UINT32B context));
static void var_valid P((void));	 /* check if okay to set location var */
static void proc_printcmd P((int justifytype, struct INPCOORD *inpc_p,
		char *str, int font, int size, int got_nl,
		int isPostScript, int ps_usage, int isfilename, 
		struct VAR_EXPORT *export_p, double extra));
static struct VAR_EXPORT *add_export P((char *varname, int index));
static double extra_needed P((int font, int size, char **string_p));
static void keyword_notes P((char *str));
static void free_extra_time P((void));
static void tsig_item P((int item));
static struct EXPR_NODE *newnode P((int op));
static void clear_curr_accs P((void));
static void add_acc P((char *acc_name));
static void new_acc_entry P((char *acc_name));
static void add_acc_offset P((int letter, double offset));
#ifdef __STDC__
static int comp_subbar P((const void *item1_p, const void *item2_p));
#else
static int comp_subbar P((char *item1_p, char *item2_p));
#endif
static int multiwhole2basictime P((int value));
static void parse_doremi_string P((char *str));



#line 309 "src/mup/ytab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "ytab.h".  */
#ifndef YY_YY_SRC_MUP_YTAB_H_INCLUDED
# define YY_YY_SRC_MUP_YTAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    T_1ARG_FUNC = 258,
    T_2ARG_FUNC = 259,
    T_2FNUMVAR = 260,
    T_ABM = 261,
    T_ACCIDENTALS = 262,
    T_ADDSUB_OP = 263,
    T_ALIGN = 264,
    T_ALIGNLABELS = 265,
    T_ALL = 266,
    T_ALT = 267,
    T_AMPERSAND = 268,
    T_ANY = 269,
    T_ARRAYVAR = 270,
    T_AUTO = 271,
    T_BARSTLISTVAR = 272,
    T_BARTYPE = 273,
    T_BBOX = 274,
    T_BLOCKHEAD = 275,
    T_BM = 276,
    T_BULGE = 277,
    T_BYMEAS = 278,
    T_CENTS = 279,
    T_CHORDTRANSLATION = 280,
    T_CLEF = 281,
    T_CLEFVAR = 282,
    T_COLON = 283,
    T_COMMA = 284,
    T_COMMON = 285,
    T_CONTROL = 286,
    T_CUE = 287,
    T_CURVE = 288,
    T_CUT = 289,
    T_DASH = 290,
    T_DBL = 291,
    T_DBLFLAT = 292,
    T_DIAM = 293,
    T_DEFAULTPHRASESIDE = 294,
    T_DOT = 295,
    T_DOWN = 296,
    T_DRUM = 297,
    T_EABM = 298,
    T_EBM = 299,
    T_EM_BEGIN = 300,
    T_EM_END = 301,
    T_ENDENDING = 302,
    T_ENDING = 303,
    T_ENDSTYLE = 304,
    T_ENDTYPE = 305,
    T_EPH = 306,
    T_EQUAL = 307,
    T_ESBM = 308,
    T_EVERY = 309,
    T_EXCLAM = 310,
    T_FAMILY = 311,
    T_FFAMILY = 312,
    T_FILE = 313,
    T_FIRSTPAGE = 314,
    T_FNUMVAR = 315,
    T_FONT = 316,
    T_FONTVAR = 317,
    T_GRACE = 318,
    T_GRIDS = 319,
    T_HAT = 320,
    T_HEADSHAPES = 321,
    T_HIDECHANGES = 322,
    T_HO = 323,
    T_HS = 324,
    T_INPUTDIR = 325,
    T_JUSTIFYTYPE = 326,
    T_KEY = 327,
    T_KEYMAP = 328,
    T_KEYMAPVAR = 329,
    T_LBRACE = 330,
    T_LBRACKET = 331,
    T_LEN = 332,
    T_LET = 333,
    T_LETTER = 334,
    T_LET_M = 335,
    T_LET_N = 336,
    T_LET_R = 337,
    T_LET_S = 338,
    T_LET_U = 339,
    T_LET_X = 340,
    T_LINE = 341,
    T_LINETYPE = 342,
    T_LPAREN = 343,
    T_LVAR = 344,
    T_LYRICS = 345,
    T_L_ANGLE = 346,
    T_L_DBLANGLE = 347,
    T_MEASNUM = 348,
    T_MIDDLE = 349,
    T_MIDI = 350,
    T_MNUM = 351,
    T_MODIFIER = 352,
    T_MULDIV_OP = 353,
    T_MULTIREST = 354,
    T_MULTIWHOLE = 355,
    T_MUSIC = 356,
    T_MUSSYM = 357,
    T_NEWLINE = 358,
    T_NL = 359,
    T_NONE = 360,
    T_NONNAT = 361,
    T_NOWHERE_SLIDE = 362,
    T_NUM = 363,
    T_NUMBER = 364,
    T_NUMVAR = 365,
    T_OCTAVE = 366,
    T_OPTSTRVAR = 367,
    T_ORDER = 368,
    T_ORIENTATION = 369,
    T_OTHERTEXT = 370,
    T_PAD = 371,
    T_PAGESIDE = 372,
    T_PAGESIZE = 373,
    T_PARAGRAPH = 374,
    T_PARATYPE = 375,
    T_PEDAL = 376,
    T_PEDSTAR = 377,
    T_PEDSTYLE = 378,
    T_PH = 379,
    T_PHRASE = 380,
    T_PITCH = 381,
    T_PLACE = 382,
    T_PLUS = 383,
    T_POSTSCRIPT = 384,
    T_PRINTTYPE = 385,
    T_PRINTEDTIME = 386,
    T_PSHOOKLOC = 387,
    T_PSVAR = 388,
    T_QUAD = 389,
    T_QUESTION = 390,
    T_RANGELISTVAR = 391,
    T_RATNUMLISTVAR = 392,
    T_RBRACE = 393,
    T_RBRACKET = 394,
    T_REHEARSAL = 395,
    T_REHTYPE = 396,
    T_REH_STYLE = 397,
    T_REPEATDOTS = 398,
    T_RESTOREPARMS = 399,
    T_ROLL = 400,
    T_RPAREN = 401,
    T_RPT = 402,
    T_R_ANGLE = 403,
    T_R_DBLANGLE = 404,
    T_SAMEPAGE = 405,
    T_SAMESCORE = 406,
    T_SAVEPARMS = 407,
    T_SCORE = 408,
    T_SCOREFEED = 409,
    T_SCOREPAD = 410,
    T_SCORESEP = 411,
    T_SEMICOLON = 412,
    T_SHAPES = 413,
    T_SHARP = 414,
    T_SHORTEN = 415,
    T_SLASH = 416,
    T_SLASHMARK = 417,
    T_SLOPE = 418,
    T_SLUR = 419,
    T_STAFF = 420,
    T_STAFFLINES = 421,
    T_STANDARD = 422,
    T_STAR = 423,
    T_STEMOFFSET = 424,
    T_STRING = 425,
    T_STRINGFUNC = 426,
    T_STRVAR = 427,
    T_SUBBARSTYLE = 428,
    T_SWINGUNIT = 429,
    T_SYMBOL = 430,
    T_TAB = 431,
    T_TICKS = 432,
    T_TIE = 433,
    T_TIL = 434,
    T_TILDE = 435,
    T_TIME = 436,
    T_TIMEUNIT = 437,
    T_TITLE = 438,
    T_TO = 439,
    T_TRANSPOSE = 440,
    T_TRANSUSAGE = 441,
    T_TUNINGTYPE = 442,
    T_TUNINGVAR = 443,
    T_UNARY_OP = 444,
    T_UNDERSCORE = 445,
    T_UNITS = 446,
    T_UNITTYPE = 447,
    T_UNSET = 448,
    T_UP = 449,
    T_USEACCS = 450,
    T_USING = 451,
    T_VCOMBINE = 452,
    T_VCOMBVAL = 453,
    T_VISVAR = 454,
    T_VOICE = 455,
    T_VVAR = 456,
    T_WHEREUSED = 457,
    T_WITH = 458,
    T_XNOTE = 459,
    T_XPOS_INT = 460,
    T_YESNOVAR = 461
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 248 "src/mup/gram.y" /* yacc.c:355  */

int	intval;		/* for tokens/nonterminals that return int values */
char	*stringval;	/* for tokens/nonterminals that return strings */
float	floatval;	/* for nonterminals that return floats */
RATIONAL ratval;	/* for nonterminals that return rational numbers */
struct INPCOORD *inpcoord_p;	/* for nonterminals that return coord info */
struct EXPR_NODE *expr_p;/* for nonterminals that return coord expression */
struct TAG_REF *tag_p;	/* for nonterminals that return a tag reference */
struct VAR_EXPORT *export_p;	/* for Mup variables to be passed to user PostScript */

#line 567 "src/mup/ytab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_SRC_MUP_YTAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 584 "src/mup/ytab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  248
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1760

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  207
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  348
/* YYNRULES -- Number of rules.  */
#define YYNRULES  816
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1245

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   461

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   605,   605,   608,   611,   614,   617,   620,   623,   626,
     629,   632,   635,   638,   641,   647,   659,   666,   670,   676,
     680,   684,   688,   692,   696,   700,   715,   724,   724,   744,
     744,   762,   764,   768,   773,   775,   778,   784,   790,   796,
    1049,  1054,  1060,  1065,  1070,  1112,  1120,  1128,  1138,  1142,
    1148,  1154,  1160,  1166,  1176,  1185,  1198,  1211,  1234,  1256,
    1264,  1273,  1282,  1285,  1291,  1301,  1307,  1310,  1313,  1316,
    1335,  1350,  1356,  1372,  1378,  1384,  1390,  1399,  1403,  1410,
    1416,  1426,  1432,  1438,  1450,  1460,  1468,  1471,  1477,  1483,
    1486,  1496,  1501,  1507,  1513,  1544,  1557,  1563,  1569,  1572,
    1578,  1608,  1608,  1623,  1635,  1640,  1645,  1656,  1677,  1705,
    1736,  1742,  1748,  1754,  1760,  1766,  1778,  1784,  1803,  1824,
    1844,  1856,  1872,  1883,  1888,  1894,  1899,  1914,  1927,  1933,
    1953,  1959,  1972,  1985,  1990,  1994,  1998,  2004,  2007,  2013,
    2017,  2017,  2022,  2080,  2099,  2104,  2109,  2114,  2120,  2126,
    2132,  2138,  2144,  2148,  2152,  2155,  2158,  2167,  2173,  2185,
    2191,  2198,  2204,  2210,  2214,  2220,  2224,  2227,  2230,  2233,
    2240,  2244,  2248,  2260,  2268,  2273,  2279,  2285,  2290,  2295,
    2312,  2322,  2330,  2333,  2342,  2361,  2367,  2372,  2378,  2381,
    2384,  2390,  2393,  2397,  2430,  2436,  2441,  2461,  2469,  2477,
    2484,  2496,  2502,  2508,  2514,  2533,  2539,  2545,  2551,  2557,
    2579,  2582,  2582,  2588,  2593,  2593,  2599,  2605,  2611,  2634,
    2646,  2654,  2657,  2660,  2679,  2684,  2690,  2695,  2704,  2714,
    2729,  2741,  2751,  2762,  2801,  2820,  2828,  2834,  2840,  2847,
    2853,  2859,  2869,  2876,  2881,  2887,  2897,  2902,  2914,  2920,
    2926,  2935,  2940,  2948,  2954,  2965,  2975,  2980,  2994,  3012,
    3022,  3037,  3055,  3067,  3071,  3077,  3081,  3093,  3099,  3105,
    3108,  3134,  3139,  3146,  3146,  3151,  3156,  3163,  3168,  3174,
    3182,  3187,  3195,  3200,  3207,  3213,  3222,  3228,  3234,  3239,
    3255,  3261,  3267,  3272,  3276,  3281,  3286,  3290,  3310,  3315,
    3321,  3326,  3331,  3336,  3342,  3351,  3372,  3397,  3492,  3499,
    3506,  3509,  3512,  3515,  3518,  3521,  3524,  3527,  3530,  3533,
    3536,  3539,  3542,  3545,  3548,  3551,  3554,  3557,  3560,  3563,
    3566,  3569,  3572,  3575,  3578,  3581,  3584,  3587,  3590,  3593,
    3596,  3599,  3602,  3605,  3608,  3611,  3614,  3617,  3620,  3623,
    3626,  3629,  3632,  3635,  3638,  3648,  3658,  3664,  3670,  3683,
    3702,  3737,  3743,  3747,  3753,  3759,  3762,  3765,  3768,  3773,
    3778,  3784,  3790,  3797,  3800,  3807,  3815,  3824,  3831,  3834,
    3840,  3849,  3855,  3865,  3883,  3909,  3913,  3920,  3923,  3927,
    3930,  3973,  3977,  3981,  3984,  3988,  3997,  4003,  4009,  4016,
    4019,  4023,  4033,  4050,  4066,  4071,  4075,  4091,  4097,  4102,
    4107,  4113,  4117,  4125,  4132,  4139,  4142,  4145,  4148,  4163,
    4166,  4169,  4172,  4189,  4206,  4217,  4244,  4255,  4280,  4286,
    4292,  4312,  4317,  4322,  4325,  4329,  4332,  4336,  4339,  4352,
    4380,  4392,  4403,  4418,  4432,  4443,  4448,  4454,  4459,  4466,
    4471,  4488,  4491,  4494,  4510,  4519,  4523,  4530,  4537,  4544,
    4550,  4562,  4574,  4584,  4595,  4601,  4607,  4635,  4641,  4647,
    4653,  4684,  4693,  4704,  4709,  4725,  4751,  4799,  4804,  4808,
    4823,  4844,  4849,  4863,  4868,  4874,  4881,  4886,  4892,  4912,
    4918,  4924,  4930,  4943,  4948,  4952,  4956,  4975,  4997,  5016,
    5057,  5075,  5088,  5107,  5130,  5133,  5136,  5140,  5147,  5152,
    5192,  5199,  5207,  5213,  5216,  5226,  5242,  5258,  5276,  5297,
    5304,  5316,  5327,  5339,  5351,  5359,  5364,  5376,  5386,  5396,
    5412,  5418,  5428,  5444,  5450,  5456,  5465,  5471,  5485,  5490,
    5507,  5514,  5520,  5525,  5530,  5534,  5540,  5545,  5550,  5555,
    5559,  5564,  5570,  5576,  5582,  5588,  5594,  5601,  5607,  5613,
    5620,  5627,  5633,  5639,  5651,  5661,  5667,  5673,  5679,  5686,
    5693,  5700,  5709,  5716,  5720,  5723,  5727,  5739,  5748,  5754,
    5762,  5769,  5776,  5783,  5790,  5797,  5804,  5811,  5818,  5825,
    5832,  5838,  5845,  5852,  5864,  5869,  5875,  5880,  5889,  5896,
    5903,  5907,  5919,  5923,  5928,  5938,  5944,  5951,  5958,  5965,
    5971,  5976,  5984,  5987,  5997,  6000,  6008,  6015,  6025,  6031,
    6035,  6035,  6039,  6044,  6055,  6060,  6065,  6073,  6079,  6085,
    6094,  6106,  6112,  6118,  6121,  6124,  6127,  6149,  6153,  6160,
    6166,  6172,  6175,  6179,  6190,  6195,  6304,  6307,  6311,  6310,
    6424,  6458,  6496,  6499,  6503,  6507,  6510,  6513,  6583,  6589,
    6595,  6607,  6610,  6613,  6616,  6620,  6623,  6626,  6681,  6687,
    6709,  6717,  6740,  6744,  6750,  6753,  6757,  6765,  6776,  6809,
    6823,  6830,  6845,  6851,  6856,  6873,  6882,  6897,  6907,  6915,
    6924,  6933,  6941,  6949,  6958,  6964,  6971,  6979,  6989,  7006,
    7012,  7020,  7028,  7042,  7050,  7058,  7065,  7107,  7129,  7146,
    7152,  7162,  7168,  7174,  7179,  7185,  7192,  7198,  7201,  7206,
    7209,  7231,  7238,  7243,  7248,  7253,  7258,  7271,  7284,  7287,
    7290,  7293,  7297,  7300,  7304,  7320,  7357,  7365,  7372,  7387,
    7397,  7404,  7407,  7414,  7423,  7447,  7459,  7465,  7471,  7477,
    7484,  7490,  7496,  7501,  7507,  7513,  7526,  7532,  7545,  7550,
    7556,  7561,  7572,  7575,  7579,  7587,  7597,  7602,  7608,  7613,
    7619,  7624,  7636,  7642,  7647,  7652,  7670,  7678,  7684,  7692,
    7699,  7703,  7708,  7715,  7722,  7726,  7733,  7739,  7742,  7749,
    7756,  7762,  7767,  7781,  7791,  7796,  7802,  7808,  7817,  7824,
    7829,  7835,  7838,  7850,  7857,  7864,  7878,  7884,  7893,  7899,
    7906,  7911,  7914,  7917,  7921,  7928,  7935
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_1ARG_FUNC", "T_2ARG_FUNC",
  "T_2FNUMVAR", "T_ABM", "T_ACCIDENTALS", "T_ADDSUB_OP", "T_ALIGN",
  "T_ALIGNLABELS", "T_ALL", "T_ALT", "T_AMPERSAND", "T_ANY", "T_ARRAYVAR",
  "T_AUTO", "T_BARSTLISTVAR", "T_BARTYPE", "T_BBOX", "T_BLOCKHEAD", "T_BM",
  "T_BULGE", "T_BYMEAS", "T_CENTS", "T_CHORDTRANSLATION", "T_CLEF",
  "T_CLEFVAR", "T_COLON", "T_COMMA", "T_COMMON", "T_CONTROL", "T_CUE",
  "T_CURVE", "T_CUT", "T_DASH", "T_DBL", "T_DBLFLAT", "T_DIAM",
  "T_DEFAULTPHRASESIDE", "T_DOT", "T_DOWN", "T_DRUM", "T_EABM", "T_EBM",
  "T_EM_BEGIN", "T_EM_END", "T_ENDENDING", "T_ENDING", "T_ENDSTYLE",
  "T_ENDTYPE", "T_EPH", "T_EQUAL", "T_ESBM", "T_EVERY", "T_EXCLAM",
  "T_FAMILY", "T_FFAMILY", "T_FILE", "T_FIRSTPAGE", "T_FNUMVAR", "T_FONT",
  "T_FONTVAR", "T_GRACE", "T_GRIDS", "T_HAT", "T_HEADSHAPES",
  "T_HIDECHANGES", "T_HO", "T_HS", "T_INPUTDIR", "T_JUSTIFYTYPE", "T_KEY",
  "T_KEYMAP", "T_KEYMAPVAR", "T_LBRACE", "T_LBRACKET", "T_LEN", "T_LET",
  "T_LETTER", "T_LET_M", "T_LET_N", "T_LET_R", "T_LET_S", "T_LET_U",
  "T_LET_X", "T_LINE", "T_LINETYPE", "T_LPAREN", "T_LVAR", "T_LYRICS",
  "T_L_ANGLE", "T_L_DBLANGLE", "T_MEASNUM", "T_MIDDLE", "T_MIDI", "T_MNUM",
  "T_MODIFIER", "T_MULDIV_OP", "T_MULTIREST", "T_MULTIWHOLE", "T_MUSIC",
  "T_MUSSYM", "T_NEWLINE", "T_NL", "T_NONE", "T_NONNAT", "T_NOWHERE_SLIDE",
  "T_NUM", "T_NUMBER", "T_NUMVAR", "T_OCTAVE", "T_OPTSTRVAR", "T_ORDER",
  "T_ORIENTATION", "T_OTHERTEXT", "T_PAD", "T_PAGESIDE", "T_PAGESIZE",
  "T_PARAGRAPH", "T_PARATYPE", "T_PEDAL", "T_PEDSTAR", "T_PEDSTYLE",
  "T_PH", "T_PHRASE", "T_PITCH", "T_PLACE", "T_PLUS", "T_POSTSCRIPT",
  "T_PRINTTYPE", "T_PRINTEDTIME", "T_PSHOOKLOC", "T_PSVAR", "T_QUAD",
  "T_QUESTION", "T_RANGELISTVAR", "T_RATNUMLISTVAR", "T_RBRACE",
  "T_RBRACKET", "T_REHEARSAL", "T_REHTYPE", "T_REH_STYLE", "T_REPEATDOTS",
  "T_RESTOREPARMS", "T_ROLL", "T_RPAREN", "T_RPT", "T_R_ANGLE",
  "T_R_DBLANGLE", "T_SAMEPAGE", "T_SAMESCORE", "T_SAVEPARMS", "T_SCORE",
  "T_SCOREFEED", "T_SCOREPAD", "T_SCORESEP", "T_SEMICOLON", "T_SHAPES",
  "T_SHARP", "T_SHORTEN", "T_SLASH", "T_SLASHMARK", "T_SLOPE", "T_SLUR",
  "T_STAFF", "T_STAFFLINES", "T_STANDARD", "T_STAR", "T_STEMOFFSET",
  "T_STRING", "T_STRINGFUNC", "T_STRVAR", "T_SUBBARSTYLE", "T_SWINGUNIT",
  "T_SYMBOL", "T_TAB", "T_TICKS", "T_TIE", "T_TIL", "T_TILDE", "T_TIME",
  "T_TIMEUNIT", "T_TITLE", "T_TO", "T_TRANSPOSE", "T_TRANSUSAGE",
  "T_TUNINGTYPE", "T_TUNINGVAR", "T_UNARY_OP", "T_UNDERSCORE", "T_UNITS",
  "T_UNITTYPE", "T_UNSET", "T_UP", "T_USEACCS", "T_USING", "T_VCOMBINE",
  "T_VCOMBVAL", "T_VISVAR", "T_VOICE", "T_VVAR", "T_WHEREUSED", "T_WITH",
  "T_XNOTE", "T_XPOS_INT", "T_YESNOVAR", "$accept", "song", "item",
  "context", "ssv_context", "$@1", "$@2", "ssv_stafflist",
  "ssv_staff_item", "ssv_sv_list", "ssv_sv_item", "alloc_ssv",
  "new_context", "blockhead_context", "music_context", "grid_context",
  "accidentals_context", "begin_acc_context", "acc_context_name",
  "acc_entry", "acc_name", "offsets_spec", "offsets_list", "acc_offset",
  "keymap_context", "control_context", "control_item", "stringpair",
  "headshape_context", "shapes_context", "symbol_context", "staffnum",
  "voicenum", "num", "value", "assignment", "terminator", "assign", "$@3",
  "visval", "opt_pageside", "opt_print_clef", "measnumval", "vschemetype",
  "allocbeamlist", "ratnumlist", "nonempty_ratnumlist", "subbeam", "$@4",
  "time_item", "swing_time", "opt_rs", "alloc_rangelist", "rangelist",
  "rangelistA", "rangeitem", "rangetail", "grplabel", "optlabel2",
  "glabel", "alloc_barstlist", "barstlist", "opt_between", "between",
  "barst_item", "subbar_check", "subbar_list", "alloc_subbar",
  "alloc_sb_barstlist", "sb_linetype", "sb_bartype", "sb_appearance",
  "line_ref", "line_offset", "sb_barstlist", "sb_timelist", "sb_count",
  "repeatdots_value", "mark_order", "orderlist", "orderitem", "marktype",
  "timesig", "tsiglist", "$@5", "meas_tsig", "$@6", "fraction",
  "numerator", "numerator_value", "opt_ts_visibility", "opt_n",
  "printed_timesig", "keyspec", "useaccs_value", "useaccs_qual",
  "stafflinedef", "prclef", "ch_tran_type", "tab_string_list", "tab_item",
  "opt_str_acc", "opt_ticks", "flagval", "minscsep", "maxscsep",
  "minscpad", "maxscpad", "shorten_opts", "shorten_range", "inputdir",
  "pagesize", "orientation", "vcombine_clause", "$@7", "vcombine_value",
  "vcombine_quals", "opt_vcombine_qualifier", "opt_bymeas", "end_type",
  "updown", "majmin", "pedstyle", "transpose_interval", "trans_usage",
  "title", "tfont", "title_font", "font_family", "title_size", "titleA",
  "paragraph", "opt_paratype", "paramname", "string", "string_part",
  "music_input", "noteinfo", "init_staff", "sv_spec", "sv_map_list",
  "sv_map_entry", "map_start", "map_finish", "sv_map_item_list",
  "voice_id", "sv_and", "sv_item", "notecolon", "grp_stafflist",
  "grp_staff_item", "grp_staff_range", "voice_spec", "voice_tail",
  "groupinfo", "groupdata", "mid_meas_param", "mid_meas_list",
  "mid_meas_item", "mm_context", "mm_params", "mm_param_item",
  "grp_attributes", "styleinfo", "gtc", "extra_styleinfo", "alloc_grpsyl",
  "marklist", "marklistA", "markitem", "hor_offset", "opt_plus_or_minus",
  "other_attr", "attr_list", "attr_item", "alloc_marklist", "mark_place",
  "opt_dir", "opt_to_voice", "marks", "mark", "mark_item",
  "shorthand_mark", "notetype", "dir", "beammark", "time_val", "crossbeam",
  "basic_time_val", "opt_more_time", "more_time_item", "alloc_timelist",
  "opt_m", "opt_dbl_or_quad", "dots", "padding", "padspec", "opt_minus",
  "group", "special_group", "extra_attr", "spec_grp_alloc", "extra_item",
  "note_opts", "notelist", "opt_other_staff", "css_with", "some_notes",
  "notedata", "notedata1", "opt_bend", "pitch", "opt_accidental",
  "opt_acc_list", "opt_octave", "acc_list", "begin_acc_list",
  "acc_list_tail", "note_acc", "acc_symbol", "octave", "minuslist",
  "pluslist", "slur_item", "start_slur", "slurlist", "fullslurlist",
  "slurnote", "grp_locsave", "loc_variable", "arraytag", "ntuplet",
  "printtup", "start_tuplet", "rbrace", "opt_side", "opt_time",
  "opt_tuplet_slope", "lyricinfo", "lyric_id", "lyr_opt_place", "using",
  "opt_place", "ph_opt_place", "staff_list", "staff_item", "staff_range",
  "more_lyric_ids", "$@8", "verse_spec", "verselist", "verse_item",
  "verse_range", "alloc_lyr_grpsyl", "lyricdata", "lyr_tlist",
  "lyrics_timelist", "lyr_time_item", "lyr_tm", "lyrtuplet", "opt_space",
  "lyr_verse", "verse_string", "os_directive", "$@9", "scorefeed_options",
  "scorefeed_item", "temp_margin", "margin_override", "temp_scoresep",
  "opt_equals", "opt_semi", "directive", "barinfo", "precbartype",
  "barline", "bartype", "emptymeas_input", "bar_items", "bar_opt",
  "ending_info", "chk_dup_reh", "rehearsal_mark", "location", "alloc_loc",
  "plus_or_minus", "xcoord", "ycoord", "coord_setup", "expression",
  "direction", "floatnum", "opt_decimal_part", "numstr", "variable",
  "line", "line_alloc", "linetype", "opt_line_str", "curve", "curve_alloc",
  "curve_tail", "loc_list", "bulgelist", "bulge_value", "curve_loc",
  "stuff_info", "stuff_header", "midi", "midi_staff", "stuff_id",
  "stuff_type", "opt_size", "opt_modifier", "opt_dist", "stuff_dist",
  "opt_exclam", "opt_align", "stufflist", "stuff_item", "beat_offset",
  "gracebackup", "steps_offset", "opt_string", "til_clause", "til_val",
  "til_suffix", "til_offset", "roll_cmd", "opt_roll_dir", "roll_extent",
  "roll_start", "roll_end", "roll_offsetlist", "printcmd", "postscript",
  "opt_file", "ps_opt_loc", "export_list", "export_var_list",
  "export_item", "aliased_var", "alias", "export_var",
  "alias_or_export_var", "printtype", "justifytype", "opt_loc", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461
};
# endif

#define YYPACT_NINF -1003

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1003)))

#define YYTABLE_NINF -807

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1361,     8,    74, -1003,    93,   215,   282,   196,   342,   430,
   -1003,   471,   475,   489,   493, -1003,   496,   510,   529, -1003,
   -1003,   532, -1003,   541,   287,   545, -1003,   343, -1003,   573,
   -1003,   517, -1003, -1003, -1003,   575, -1003,   577, -1003,   578,
   -1003, -1003,   582,   583, -1003,   584,   585,   586,   587,   589,
     591,   287,    11, -1003, -1003, -1003,   287, -1003, -1003,   592,
     597,    10,   598, -1003,   602,   603, -1003,   357,   605,   606,
     607,   287,   608,   611,   610,   612,   613,   618,  1554,   621,
     623,   626, -1003,   627,   629,  1164, -1003,   525, -1003, -1003,
   -1003, -1003, -1003, -1003,    52, -1003, -1003,   147, -1003, -1003,
   -1003, -1003, -1003,   147,   632, -1003,   625, -1003,   555,   159,
   -1003, -1003,   588,   198, -1003,   525,   590, -1003, -1003,   329,
   -1003, -1003,   660,    87,   604, -1003, -1003, -1003,   347,   413,
   -1003, -1003,    63,   287,   619, -1003,   661, -1003, -1003,   287,
     671,   540,   571,   207,   642,   517,   661,   639,    29,   393,
     574,   441, -1003,   507,   126, -1003,   457, -1003,   525,   109,
     441,   661,   112,   287,    91,   446, -1003, -1003,   566,    40,
     574, -1003, -1003,   517,   574, -1003, -1003,   661,    63,   441,
     574,    63, -1003,    -9,   661,   517,   287, -1003,   232,   574,
     398, -1003,   620,   651,    19,   527,   526, -1003, -1003, -1003,
   -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
   -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
   -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
   -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
   -1003, -1003,   540, -1003,    -1, -1003,   517,   540, -1003, -1003,
   -1003, -1003, -1003,   318, -1003,   616,   594,   318, -1003, -1003,
   -1003, -1003,   682, -1003,   610,   287,   294, -1003, -1003,   681,
   -1003,   693,   646, -1003,   517,   710, -1003,    37, -1003,   624,
   -1003,   502, -1003, -1003,   637,   604,   708,    63, -1003,   710,
   -1003,   517,   631, -1003, -1003, -1003, -1003,   528, -1003,   287,
     628,   692,   705, -1003,   574, -1003,    76, -1003,   706,   517,
   -1003,   574,   659, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
   -1003, -1003,   196,    63, -1003, -1003, -1003, -1003, -1003, -1003,
      58, -1003,    58, -1003,   574, -1003,   517,   711, -1003,   383,
     715, -1003,   517, -1003, -1003, -1003, -1003,   517, -1003,    63,
     630, -1003, -1003, -1003,   574, -1003, -1003, -1003, -1003,   617,
   -1003,   276, -1003, -1003,   159, -1003,   640,   517,   517,   208,
   -1003, -1003, -1003, -1003,   517,   712,   576, -1003,    -7,   726,
      63,   733, -1003, -1003,   734,   517,   478,    47, -1003,   737,
     738,   574, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
     688, -1003,   331,   617,   261,   517,   287, -1003, -1003, -1003,
   -1003,   568, -1003, -1003, -1003,   166, -1003,   517, -1003, -1003,
   -1003, -1003,   517,    22, -1003, -1003, -1003, -1003,    63,   633,
   -1003,   318, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
   -1003,   511, -1003, -1003,   620, -1003, -1003,   517, -1003, -1003,
     679, -1003,   310,   710, -1003,   517,   517,   567, -1003, -1003,
   -1003, -1003,   287,   450, -1003,   730,    64,   731,   661, -1003,
   -1003, -1003, -1003,   700,   700,   771,   343, -1003, -1003, -1003,
     702,    63, -1003,   716,   645, -1003,   343, -1003,   450,   741,
     574, -1003, -1003,   628,    63, -1003,   761,   772,   789,   517,
   -1003,   661, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
   -1003, -1003,   600,   600, -1003,   517,   269,   517,   517, -1003,
     517,   649, -1003, -1003, -1003, -1003, -1003,   444,   517,   574,
   -1003, -1003, -1003,   761, -1003,   773, -1003, -1003,   524,   779,
   -1003, -1003, -1003,    63,   517, -1003,   758,   758, -1003, -1003,
   -1003,   661, -1003, -1003,    63, -1003,    63, -1003,   710, -1003,
     782, -1003, -1003,   594, -1003, -1003, -1003, -1003,   661,   287,
     272, -1003,   774, -1003,   398, -1003, -1003, -1003,   666,   525,
     159, -1003,   517, -1003, -1003, -1003, -1003, -1003,    32,   710,
   -1003,    37, -1003, -1003, -1003,   792,    63, -1003,   682,   682,
     287, -1003,   290,   391, -1003,   498,   679, -1003, -1003,   517,
   -1003, -1003, -1003,   517,   517, -1003,   574, -1003, -1003, -1003,
   -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003,   778,   287,
     517,   517,   517,    63,   610, -1003,   635,   636,   667,   126,
     776,   790, -1003, -1003,   153,   441, -1003,   126,   797,   506,
   -1003,   778,   787,   801, -1003, -1003,   780, -1003,   781, -1003,
     287, -1003, -1003, -1003,   517, -1003,   704, -1003, -1003,   809,
   -1003, -1003, -1003, -1003, -1003,   764,   232, -1003,   106,   271,
   -1003,   683, -1003, -1003, -1003, -1003,   714,   398, -1003, -1003,
   -1003,   754,   517,   267,   760,   762, -1003,   267,   691,    63,
     517, -1003,   153,   661,    63, -1003,   816, -1003,   517,   330,
   -1003,    58, -1003,   316,   637, -1003,   229,   617, -1003,   746,
     159,   664,   654,   831, -1003, -1003,   517, -1003, -1003, -1003,
   -1003, -1003,   203, -1003, -1003, -1003,    31, -1003,   820,   200,
     232, -1003, -1003,   679, -1003,   710, -1003,   827,   517,   574,
   -1003, -1003, -1003, -1003,   651,   700,   700, -1003,    59,   466,
     517,    63,   678,    59,   506,   770,   775,   506,   506,    63,
      68, -1003,   819,   437,   450,   450,   574, -1003,   517, -1003,
     661,   156, -1003,   783,   399,   335,   106, -1003, -1003, -1003,
   -1003, -1003,   287, -1003, -1003,    48, -1003, -1003, -1003, -1003,
   -1003,   707, -1003,   266, -1003,    63, -1003,   661, -1003, -1003,
     543, -1003,   685, -1003, -1003,   847, -1003, -1003, -1003, -1003,
   -1003, -1003,   574, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
     766,   815,   818,   822,   823,   418, -1003,   732,   718,    69,
   -1003, -1003,   233, -1003,   300, -1003,   -23, -1003, -1003,   604,
      28,   669,    70, -1003,   832,   735,   743,    63,   720,   874,
     739,    68,   506,   506, -1003,    60, -1003,   506,   506,   437,
   -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
     855, -1003,   517, -1003, -1003, -1003,   851,   748,   859, -1003,
   -1003, -1003,   126,   860,   574, -1003, -1003, -1003, -1003, -1003,
   -1003,   861, -1003, -1003,   280, -1003,   165,   461, -1003,   865,
     517, -1003,   540, -1003,    31, -1003, -1003, -1003,   450,   661,
   -1003,   265,   287,    63,   517, -1003, -1003,   753,   740, -1003,
   -1003, -1003, -1003, -1003, -1003, -1003,   517,   696, -1003, -1003,
   -1003, -1003,   571,   661,    20,    20,   744,   867, -1003, -1003,
     233,   450,   -30,   287, -1003, -1003,    20,   287, -1003, -1003,
     373, -1003, -1003, -1003, -1003, -1003, -1003,   811,   594, -1003,
   -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003,   676,   777,
     303,   661,   700, -1003,   610, -1003,    63,   845, -1003, -1003,
   -1003, -1003,   491, -1003, -1003,   517, -1003, -1003,    75,    77,
   -1003,   804, -1003, -1003,   661,   877,   517, -1003,   287,   517,
     715,   287,   757,   661, -1003, -1003, -1003, -1003, -1003,   872,
     785,   190, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
   -1003, -1003,   517,   270,   293, -1003,    63,   574, -1003, -1003,
     201,   868,   718, -1003,   745, -1003, -1003,    63,   725, -1003,
     725, -1003,    69, -1003, -1003, -1003,   280,   574,   725,   574,
   -1003,   280,   763,   594, -1003, -1003,   769,   622,   233,   305,
     350,   574, -1003,   685,   114,    80, -1003,   517, -1003, -1003,
   -1003,   574,   856,    63,   888, -1003,   736, -1003,   620,   845,
   -1003, -1003,   -21,   716, -1003, -1003, -1003,   506, -1003,   261,
   -1003, -1003,   336, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
   -1003,   153,   136,   774, -1003, -1003, -1003, -1003, -1003, -1003,
     574,   131, -1003, -1003, -1003,   878, -1003, -1003,   796, -1003,
     719, -1003, -1003, -1003, -1003, -1003, -1003,    20, -1003, -1003,
   -1003, -1003,   784,   786,   280,   287,   372, -1003, -1003,   287,
   -1003, -1003, -1003, -1003,   594,   287, -1003,   340, -1003, -1003,
     661,   700,   287, -1003,    63,   716, -1003, -1003,    78, -1003,
   -1003,   742,    63, -1003, -1003,    27,   201, -1003, -1003,   884,
     849, -1003,   517,   725,   280,   287,   788, -1003,   305,   287,
     409,   114, -1003,   791, -1003, -1003, -1003, -1003,   877, -1003,
   -1003,   574,   702, -1003, -1003,   190, -1003,   517,    63, -1003,
   -1003,   718, -1003, -1003, -1003, -1003,   287, -1003,   793, -1003,
   -1003, -1003, -1003,   765,   716,   153, -1003,   898, -1003, -1003,
     794, -1003,   287,   661,   795, -1003,   798,    63, -1003, -1003,
      63, -1003, -1003, -1003, -1003
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,    43,     0,     0,     0,   123,     0,     0,
      55,     0,     0,     0,     0,   301,     0,     0,     0,    41,
      59,     0,   813,     0,     0,     0,   723,   608,   745,     0,
     740,     0,    40,   748,    14,     0,   749,     0,   196,     0,
     309,   747,     0,   794,   811,     0,     0,     0,     0,     0,
       0,     0,   781,   746,   651,   650,     0,    38,   648,     0,
       0,     0,     0,    38,     0,     0,   356,     0,     0,     0,
       0,     0,     0,     0,   300,     0,     0,     0,     0,     0,
       0,     0,    38,     0,     0,     0,     2,   663,    16,    18,
      38,    19,    22,    11,     0,    23,    17,     0,    10,    20,
      21,    24,     5,     0,     0,     6,     0,     7,     0,    46,
     354,     8,     0,     0,   361,   663,     0,   674,   646,   668,
     647,   665,     0,     0,   750,   743,   666,   652,   814,   814,
     812,    15,     0,     0,     0,   164,   490,   124,    39,   246,
       0,     0,   610,     0,     0,     0,   490,     0,     0,     0,
      54,   770,   609,   605,     0,   604,     0,    64,   663,    70,
     770,   490,     0,     0,   228,     0,   151,   133,     0,     0,
      57,   783,   782,     0,    56,    37,   653,   490,     0,   770,
      60,     0,    27,     0,   490,     0,     0,   174,   144,    61,
       0,   101,   302,   298,     0,     0,     0,   319,   341,   317,
     340,   352,   346,   342,   325,   351,   320,   318,   350,   321,
     336,   349,   327,   310,   347,   334,   316,   328,   338,   332,
     343,   326,   323,   331,   312,   353,   322,   313,   345,   333,
     315,   337,   314,   339,   348,   324,   335,   330,   344,   329,
     311,   100,     0,   273,     0,    29,     0,     0,     1,     3,
     664,     4,    25,     0,   540,     0,    48,     0,    68,    67,
      12,    66,     0,   744,   300,     0,     0,   358,   368,   381,
      62,     0,   364,   365,     0,   363,   372,   375,   378,     0,
       9,   645,   727,   721,   722,   750,     0,     0,   742,   741,
     739,     0,   752,   693,   815,   798,   816,   799,   797,     0,
       0,   713,     0,    42,    44,    96,   165,   491,     0,     0,
      95,   247,   125,   255,   256,   110,   611,    90,   285,   284,
     106,    93,   123,     0,    92,   267,   465,   464,    75,   268,
       0,    86,   541,   771,   772,   116,     0,     0,   613,   616,
     619,   612,     0,   127,   128,    99,   360,     0,   113,     0,
       0,   290,   292,   108,   117,   217,   216,   220,   223,   229,
     213,     0,   221,    89,   230,   269,   271,     0,   152,   134,
     107,   194,   195,    84,   785,     0,   787,    26,   649,   261,
       0,   258,   257,   114,   263,     0,   243,   226,    91,     0,
       0,   112,   177,   484,   475,   485,   476,   145,   103,   486,
       0,    88,   211,   210,   483,     0,     0,   299,   297,   287,
     286,     0,   115,   111,    87,   235,    77,   275,   121,   122,
     120,    98,     0,   130,    97,   695,   694,    47,     0,    52,
      45,     0,    49,   206,   205,   204,   201,   202,   203,   208,
     207,    85,   197,   200,   302,   355,    58,     0,   380,   377,
     391,   366,     0,   370,   374,     0,     0,   385,    63,   376,
      13,   686,     0,     0,   679,     0,     0,     0,   490,   687,
     676,   675,   678,     0,     0,     0,   608,   671,   667,   672,
     766,   736,   762,   768,     0,   753,   608,   698,     0,   795,
     792,   718,   715,   716,     0,   172,   157,    82,     0,   171,
     166,   490,    65,   126,    94,    71,    72,   558,   561,   559,
     560,   557,   288,   288,   542,   606,   629,     0,     0,   615,
       0,   603,   129,    69,    78,   291,   214,     0,     0,   231,
     272,    76,   270,   157,    81,   153,   154,   140,   146,   135,
     137,   136,   786,     0,     0,   784,   661,   661,   654,   655,
     656,   490,   105,   260,     0,   104,     0,    74,    37,    31,
      33,   245,   244,     0,   241,   240,   227,   239,   490,     0,
      83,   175,   477,   143,     0,   209,   225,   102,     0,   663,
     304,   293,     0,   237,   236,   238,   234,   274,   277,    37,
      34,     0,   132,   131,    79,     0,     0,    50,     0,     0,
       0,   382,     0,   391,   387,   413,   392,   393,   369,     0,
     367,   373,   379,     0,     0,   383,   685,   588,   578,   580,
     584,   581,   582,   583,   585,   586,   579,   677,     0,     0,
       0,     0,     0,     0,   300,   735,     0,     0,     0,     0,
     670,     0,   765,   763,     0,   770,   751,     0,     0,     0,
     719,   807,   809,   800,   801,   804,     0,   803,   808,   796,
       0,   714,   717,    73,     0,   173,   170,   169,   168,     0,
     289,   232,   233,   607,   594,   629,   471,   602,     0,   629,
     633,     0,   637,   618,   617,   614,     0,     0,   219,   222,
     218,   159,     0,   483,   150,   149,    80,   483,     0,   780,
     788,   662,   431,   490,     0,   259,   265,    28,     0,     0,
     248,   251,   119,     0,   722,   487,   481,   212,   303,     0,
     305,   294,   280,   282,   276,    30,     0,    36,    51,    53,
     199,   198,   663,   396,   397,   398,     0,   388,   413,   511,
     471,   406,   389,   391,   394,   371,   386,   385,     0,   682,
     680,   681,   683,   489,   298,     0,     0,   669,   754,   362,
       0,     0,   773,   754,     0,     0,     0,     0,     0,     0,
     696,   705,     0,     0,     0,     0,   793,   158,     0,   171,
     490,   629,   472,   639,     0,     0,   630,   641,   634,   635,
     620,   215,     0,   156,   155,     0,   147,   148,   139,   138,
     790,     0,   789,     0,   432,     0,   262,   490,   264,    32,
     243,   249,   253,   252,   357,     0,   179,   482,   478,   142,
     480,   296,   306,   295,   109,   281,   279,   283,   278,    35,
       0,     0,     0,     0,     0,     0,   399,     0,   414,   433,
     493,   505,     0,   492,   508,   405,   391,   384,   587,   750,
       0,   724,     0,   738,     0,     0,     0,     0,     0,   760,
       0,   697,     0,     0,   702,     0,   707,     0,     0,     0,
     708,   711,   712,   709,   710,   810,   802,   805,   808,   167,
       0,   595,     0,   640,   636,   623,   627,     0,   622,   624,
     643,   642,     0,   161,   163,   141,   791,   659,   657,   658,
     660,     0,   242,   254,   545,   180,   181,     0,   307,     0,
       0,   273,     0,   395,     0,   413,   460,   462,     0,   490,
     461,   431,     0,     0,     0,   444,   463,     0,   415,   416,
     420,   422,   421,   488,   419,   467,     0,   473,   468,   470,
     441,   469,   610,   490,   447,   447,     0,   434,   435,   437,
     494,     0,     0,     0,   570,   497,   447,     0,   495,   504,
     571,   518,   523,   520,   519,   514,   515,     0,     0,   521,
     522,   517,   524,   510,   507,   511,   505,   513,   538,   596,
       0,   490,     0,   726,   300,   720,     0,   758,   755,   673,
     767,   769,   766,   774,   764,     0,   737,   692,     0,     0,
     699,   700,   701,   706,   490,   598,     0,   626,     0,     0,
     621,     0,     0,   490,   565,   567,   562,   250,   546,   563,
     564,     0,   182,   178,   486,   401,   402,   404,   403,   400,
     407,   577,     0,   429,   428,   424,     0,   425,   426,   427,
       0,   409,     0,   439,     0,   466,   440,     0,   449,   448,
     449,   390,     0,   506,   499,   501,   545,   502,   449,   503,
     572,   545,     0,   573,   574,   516,     0,     0,   512,   548,
     545,   539,   526,   253,     0,   543,   597,     0,   691,   689,
     690,   688,   754,     0,   729,   732,   728,   730,   302,   758,
     759,   756,   766,   768,   775,   761,   703,     0,   118,   483,
     638,   628,     0,   625,   162,   160,   266,   566,   568,   184,
     185,   186,     0,   479,   423,   430,   457,   456,   459,   458,
     455,   445,   451,   453,   454,     0,   411,   417,     0,   438,
       0,   442,   443,   436,   500,   498,   576,   447,   575,   525,
     509,   529,     0,     0,     0,   538,   545,   552,   555,     0,
     553,   554,   551,   549,   548,   538,   544,   590,   684,   734,
     490,     0,     0,   757,     0,   768,   777,   776,     0,   599,
     644,     0,     0,   190,   188,     0,     0,   446,   418,     0,
     408,   474,     0,   449,   545,   538,     0,   533,     0,   538,
       0,   547,   537,     0,   535,   593,   591,   592,   598,   733,
     731,   725,   766,   778,   704,     0,   187,     0,     0,   452,
     410,   414,   450,   569,   527,   528,   538,   532,     0,   530,
     556,   550,   536,   600,   768,   186,   189,   176,   191,   193,
       0,   534,   538,   490,     0,   779,     0,     0,   412,   531,
       0,   589,   183,   192,   601
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1003, -1003,   844, -1003, -1003, -1003, -1003, -1003,   223, -1003,
     209,  -449,   387, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
   -1003, -1003, -1003,  -211, -1003, -1003, -1003, -1003, -1003, -1003,
   -1003,  -146,  -344,   -31,  -176, -1003,   833, -1003, -1003, -1003,
     634, -1003, -1003, -1003, -1003, -1003,   245,   243, -1003,  -185,
   -1003, -1003, -1003, -1003, -1003,   249,   410, -1003, -1003,   -69,
   -1003, -1003,   283,  -627,  -492, -1003, -1003,   376, -1003, -1003,
   -1003, -1003,  -257,  -274, -1003, -1003,  -287, -1003, -1003, -1003,
      15, -1003, -1003, -1003, -1003,  -165, -1003,   268, -1003,   426,
   -1003, -1003, -1003, -1003, -1003, -1003, -1003,   144, -1003, -1003,
     248, -1003,  -114,  -232, -1003, -1003, -1003, -1003, -1003, -1003,
   -1003, -1003, -1003,    49, -1003, -1003, -1003, -1003, -1003, -1003,
   -1003,   448, -1003, -1003, -1003, -1003,  -259,   211,    12,  -435,
   -1003, -1003, -1003, -1003,    23,   697,   204, -1003, -1003, -1003,
   -1003,   694, -1003, -1003, -1003,  -105,  -275,   512, -1003,  -357,
     513, -1003,  -375,   221,   227,  -566, -1003, -1003,   366, -1003,
   -1003,    65, -1003, -1003, -1003, -1003,  -689,  -238, -1003,   -68,
   -1003,    61, -1003, -1003,   -71, -1003, -1003,  -897,  -986, -1003,
    -193, -1003, -1003, -1003,  -144, -1003,   244, -1003,    79, -1003,
   -1003, -1003, -1003, -1003,   -39, -1003,   709,  -145, -1003, -1003,
   -1003, -1003,   145,    13, -1003, -1003, -1003,    16, -1003,    24,
    -409,   -92, -1003, -1003,  -807,  -776, -1003, -1003,  -203,  -306,
    -933, -1003, -1003, -1003, -1003, -1003, -1003,   -70, -1003,  -446,
    -455, -1003, -1003,   389,   149, -1003,  -202, -1003, -1003, -1003,
   -1003, -1003,    66,    55,  -603,   479, -1003, -1003, -1003, -1003,
   -1003,   -11, -1003, -1003, -1003, -1003,   325,  -577, -1003, -1003,
   -1003, -1003,   216, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
     458,  -104, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
   -1003, -1003, -1003,  -109, -1003,  -460, -1003, -1003, -1003,  -733,
     135,   -28, -1003,   514,  -447, -1003, -1003,  -262, -1003, -1003,
   -1003, -1003, -1003, -1003,  -154,  -731, -1003, -1003, -1003, -1003,
   -1003, -1003,  -272, -1003,  -734, -1003,   -80, -1003, -1003,   530,
   -1003,  -954, -1002,  -139, -1003, -1003, -1003, -1003, -1003, -1003,
   -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003, -1003,
     236, -1003, -1003,   237,   238, -1003,   880,   887
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    85,    86,    87,    88,   385,   422,   558,   559,   589,
     590,   377,   175,    89,    90,    91,    92,   133,   303,    93,
      94,   255,   256,   427,    95,    96,    97,    98,    99,   100,
     101,   269,   457,   301,   308,   102,   260,   103,   404,   421,
     138,   504,   345,   594,   369,   538,   539,   540,   693,   541,
     398,   696,   368,   534,   535,   536,   665,   793,  1012,   893,
     306,   497,   498,   499,   500,   392,   570,   571,  1112,   815,
     906,  1023,  1111,  1171,  1175,  1227,  1228,   373,   104,   441,
     442,   443,   401,   402,   574,   359,   687,   360,   361,   362,
     575,   567,   363,   331,   414,   586,   388,   564,   310,   709,
     710,   812,   904,   315,   381,   555,   379,   552,   557,   808,
     328,   366,   531,   416,   417,   587,   724,   826,   828,   320,
     411,   671,   353,   582,   824,   105,   192,   408,   193,   406,
     579,   107,   108,   241,  1071,   110,   111,   112,   113,   271,
     272,   273,   274,   610,   452,   275,   455,   276,   450,   277,
     278,   448,   459,   615,   603,   604,   605,   606,   607,   736,
     835,   836,   739,   740,  1126,  1180,   741,   927,   928,   929,
    1035,   803,   946,   947,   948,  1040,  1178,  1048,  1131,  1121,
    1122,  1123,  1124,   930,  1049,   949,   783,  1045,   399,   716,
     818,   907,   819,   400,   572,   932,   933,   309,   839,   840,
     841,   842,  1053,   950,   843,   974,   975,   844,   976,   977,
    1072,   978,   513,  1155,  1017,  1073,  1074,  1191,  1153,   512,
    1018,  1019,  1020,   959,   960,  1062,  1063,  1064,   934,   650,
     628,   742,  1198,   675,   882,  1077,  1100,  1234,   114,   153,
     154,   337,   155,   317,   340,   341,   519,   521,   892,   887,
     888,   889,  1007,   676,   677,   678,   679,   680,   681,   682,
     884,   786,   787,   115,   176,   378,   548,   549,   898,   550,
     702,   251,   116,   117,   286,   478,   479,   640,   281,   471,
     472,   634,  1082,   635,   487,   428,   648,   860,   649,   770,
     875,   771,   661,   492,   772,   118,   474,   119,   985,   120,
     473,   983,  1086,  1084,  1085,   636,   121,   122,   123,   290,
     124,   125,   292,   486,   853,   988,  1091,   996,   481,   482,
     483,   642,   645,   335,   858,   993,  1094,  1166,   126,   173,
     375,   376,   545,   699,   127,   128,   660,   297,   489,   653,
     654,   655,   656,   657,   658,   129,   130,   298
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     158,   323,   257,   397,   329,   444,   631,   668,   389,   600,
     415,   279,   106,   476,   347,   424,   349,   627,   289,   296,
     296,   348,   475,   109,   850,   403,   514,   374,   560,   859,
     542,   861,   380,   651,   864,   865,   758,   737,  1093,   779,
     383,   652,   588,   325,   763,  1075,   432,   150,  1050,   838,
     981,   371,   171,   546,   346,   722,  1207,   332,   831,  1058,
     409,   326,   179,   253,  1132,   591,   456,   641,   867,   602,
     326,   507,  1135,   367,   170,   935,   867,   697,   418,   174,
     419,   936,   270,   867,   180,   867,   867,  -170,   520,   565,
     937,  1167,   270,  -548,   189,   508,   254,   106,   288,   425,
     157,   592,   788,   300,   302,   986,  1097,  1164,   109,   707,
     300,   131,   938,   939,   322,   881,   630,  -548,   330,   852,
     940,   355,   941,   339,   350,   356,   132,  1147,   566,   998,
     999,  1055,   266,   358,  1001,  1002,  1143,   338,  1165,   509,
     725,   832,   270,   510,   307,   134,   157,  1173,   593,   547,
     382,  1148,   387,   384,   390,  -548,   304,   396,   868,   358,
    1176,  -548,   311,  1203,   431,  -548,   868,   386,  1154,   453,
     576,   673,   157,   868,   334,   868,   868,   583,   254,   157,
      66,    67,   784,   334,   761,   157,   354,   364,   425,  1149,
     515,   357,   426,   942,   895,  1150,   157,  1213,   351,  1151,
     157,   420,   334,   495,   788,   172,  1000,   372,  1208,   391,
    1109,  1186,   982,   410,   327,   423,   727,   511,  -490,   577,
     597,  1096,  1235,   327,  1204,   429,  1030,   318,   833,   429,
     723,   674,   943,   944,   352,   157,  1116,   834,   746,  -548,
    1183,  1117,   804,   270,   393,   157,   458,   945,  1224,  1134,
     258,  1087,  -496,  1021,  1136,  1218,   820,   319,  1177,   480,
     484,    66,    67,  1145,   425,  -496,  1118,   135,   393,  -496,
     747,   584,   585,  1152,   268,   496,    66,    67,   502,  1022,
     737,   426,   897,   708,  1110,   951,   879,   265,  -483,  1010,
    -177,  -496,   495,  1142,   881,   506,   537,   393,   952,  1156,
    1033,   601,   953,   393,   259,   270,   300,   157,   394,   817,
    -695,   522,  -483,   137,   726,  1014,   523,   157,   961,   651,
     651,   524,   490,   633,   954,   669,   962,   652,   652,    66,
      67,   265,   394,  -694,   136,  -496,   532,   533,   396,  1189,
    1014,   157,   395,   458,   674,  -631,   674,  -632,  1158,  1119,
     963,   560,   553,   425,   270,   537,   802,   426,   300,  -177,
     250,   394,   282,   964,  1168,   637,   395,   394,   955,   591,
     157,    66,    67,   396,   578,   157,   157,  1214,  1193,  -695,
    -496,  1078,   965,   966,   967,  1014,   458,   529,   968,   157,
    -496,   270,   712,  1034,   139,   395,   517,   446,   700,  1079,
     595,   395,  -694,   429,   527,   813,   704,  1014,  1015,   717,
     313,  1080,   314,   956,   157,   283,   270,   284,   518,  1195,
     969,  1196,   265,   957,   270,   270,   254,   157,   355,   580,
    1200,   254,   356,  1015,  -224,   293,   970,   528,  1144,  -631,
    -631,  -632,  -632,   733,   265,   185,   426,   971,  1197,   608,
     182,   294,   816,   480,   285,   734,   254,    66,    67,   157,
    1188,   804,   814,   265,   265,   617,   663,   609,   496,   245,
     152,   711,  1031,    66,    67,   719,   810,   252,  1015,   295,
    1060,   157,   140,   602,   458,   616,   683,   684,  -224,   339,
     735,   782,   890,  1170,  -359,   972,   358,   690,   357,   254,
    1015,   293,   157,   973,   745,  1054,   762,   157,   157,   765,
     766,   342,   799,   270,   767,   698,   870,   294,   871,   254,
     872,   617,   873,   141,   598,   885,   705,   142,   706,   618,
     619,   620,   621,   622,   623,   624,   343,   265,   344,   625,
     599,   143,   639,   358,   688,   144,   300,  1220,   145,   461,
     462,   721,   647,   157,   463,   782,    27,   561,   805,   562,
     458,   394,   146,   874,   365,    31,   563,   913,   729,   464,
     157,  1092,   254,   674,   738,   914,   626,   980,   270,   641,
     465,   147,   458,   458,   148,   618,   619,   620,   621,   622,
     623,   624,   713,   149,   768,   625,   613,   151,   466,   750,
     751,   752,   614,   720,   880,   753,   694,   695,   339,   333,
     467,    66,    67,   730,   731,   157,   339,   711,   468,   313,
    1174,   314,   561,   732,   562,   156,   157,   159,   830,   160,
     161,   901,   626,   777,   162,   163,   164,   165,   166,   167,
     961,   168,   469,   169,   177,   396,   754,   851,   962,   178,
     181,  1172,   749,  1162,   183,   184,   358,   186,   187,   188,
     190,   533,   396,   191,   194,   195,   396,    15,   334,   458,
     196,   801,   963,   242,   264,   243,   806,   270,   244,   246,
    1028,   247,   250,   776,   262,   964,   263,   769,   287,  -548,
      22,   267,   291,   280,   931,   270,   307,   312,   316,   321,
     324,   785,   265,   336,   965,   966,   967,   370,   405,   396,
     968,  1014,   407,  -548,   412,  1226,   447,   848,   413,   430,
     254,   449,   268,   454,    26,  1088,   477,   460,   485,   855,
     433,   488,   493,   856,   494,   501,  1187,   491,   503,   516,
     543,   866,   969,   822,   520,   526,  1194,   496,   254,  1140,
     916,  -548,   525,   886,   530,   551,   917,  -548,   970,   326,
     544,  -548,   554,   556,  1069,  1172,   568,   569,   573,   971,
     918,   602,   434,   581,  1032,   899,  1215,   900,   919,   435,
    1219,   920,   629,   632,   436,   157,   921,   922,   293,   638,
     641,   646,   644,   437,   596,   923,   664,   438,  1047,   659,
     667,   666,   692,   439,  1015,   670,   686,  1231,   697,   785,
     701,   456,   718,   757,   715,   894,   728,   972,   748,   755,
     756,   759,   440,  1239,   987,   760,   764,   773,  1098,   992,
     774,   495,   775,  -806,   468,  -548,  1083,  1106,   780,   674,
     789,   790,   792,   796,   797,   807,    66,    67,   800,   821,
     823,  1005,   825,  1070,   827,   837,   613,   857,   862,   869,
    1056,   339,   903,   863,   896,   905,   883,   909,  1061,   908,
     910,   915,   984,  1016,   911,   912,   396,   994,   989,  1026,
     924,   990,   991,   995,  1004,   997,  1006,  1008,  1009,  1011,
    1013,  1025,  1041,  1039,  1065,  1038,  1052,  1042,   931,  1044,
    1090,  1051,   868,  1105,  1076,  1043,  1099,  1107,  1125,  1130,
    1128,  1137,   327,  1108,  1169,  1139,   852,  1160,  1179,  1182,
    1161,   925,   926,  1181,  1210,  1211,  1205,  1237,  1233,   249,
    1184,   809,  1185,  1238,  1216,   829,   261,  1222,   795,  1232,
     798,   794,  1104,   691,  1242,  1037,   714,  1016,  1225,   778,
    1243,  1236,  1241,   689,   902,   791,   505,   811,  1089,  1146,
    1027,   672,   445,   854,  1095,   849,   451,   611,   847,   612,
     846,  1061,   744,  1230,  1127,  1101,  1057,  1141,   886,  1029,
    1059,  1133,  1036,  1209,   845,  1113,  1024,   958,  1221,  1068,
     470,  1067,  1066,  1138,   743,   979,  1223,  1046,  1103,   685,
     781,  1114,   891,  1081,  1003,   703,  1199,   662,  1115,  1163,
     876,   643,   877,   878,   305,  1083,   299,     0,     0,  1129,
       0,     0,     0,     0,     0,  1016,     0,     0,     0,     0,
    1016,  1102,     0,     0,   894,     0,     0,     0,  1016,  1016,
       0,     0,     0,     0,     0,     0,  1157,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,     0,     0,     0,     0,
       0,     0,  1192,  1120,     0,     0,     0,   931,   396,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   496,     0,     0,     0,     0,     0,     0,  1240,     0,
       0,     0,     0,     0,     0,     0,  1217,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1016,     0,  1016,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1202,     0,     0,     0,
       0,     0,     0,     0,  1206,     0,     0,     0,     0,     0,
       0,  1212,     0,  1016,     0,     0,     0,  1016,     0,     0,
       0,     0,     0,     0,   248,     1,     0,     0,     0,     2,
       0,     3,  1190,     0,     4,     0,   496,     0,     0,     0,
    1229,     5,  -722,     6,     7,  1201,     0,     0,     0,     8,
       0,     9,     0,     0,     0,    10,    11,  -722,     0,  1120,
       0,     0,     0,    12,     0,     0,     0,     0,     0,  1229,
       0,     0,  1244,    13,     0,     0,     0,     0,     0,     0,
      14,    15,     0,    16,    17,  -300,    18,     0,    19,     0,
      20,     0,     0,     0,    21,    22,    23,    24,    25,     0,
    -362,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -722,    26,  -722,     0,    27,    28,     0,    29,     0,    30,
       0,     0,     0,    31,     0,    32,    33,    34,     0,     0,
       0,     0,     0,  -362,    35,    36,    37,    38,     0,     0,
      39,     0,     0,  -308,    40,    41,     0,    42,     0,  -722,
       0,     0,     0,    43,    44,    45,     0,    46,     0,     0,
      47,    48,     0,     0,     0,     0,    49,    50,    51,    52,
       0,     0,    53,     0,    54,    55,    56,    57,    58,    59,
      60,     0,    61,     0,    62,     0,     0,     0,     0,    63,
      64,     0,     0,    65,    66,    67,    68,    69,    70,    71,
       0,     0,     0,     0,     0,    72,    73,    74,     0,    75,
       0,     0,    76,     0,     0,    77,     0,    78,     0,    79,
       0,    80,     1,    81,    82,    83,     2,     0,     3,     0,
      84,     4,     0,     0,     0,     0,     0,     0,     5,  -722,
       6,     7,     0,     0,     0,     0,     8,     0,     9,     0,
       0,     0,    10,    11,  -722,     0,     0,     0,     0,     0,
      12,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      13,     0,     0,     0,     0,     0,     0,    14,    15,     0,
      16,    17,  -300,    18,     0,    19,     0,    20,     0,     0,
       0,    21,    22,    23,    24,    25,     0,  -362,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -722,    26,  -722,
       0,    27,    28,     0,    29,     0,    30,     0,     0,     0,
      31,     0,    32,    33,    34,     0,     0,     0,     0,     0,
    -362,    35,    36,    37,    38,     0,     0,    39,     0,     0,
    -308,    40,    41,     0,    42,     0,  -722,     0,     0,     0,
      43,    44,    45,     0,    46,     0,     0,    47,    48,     0,
       0,     0,     0,    49,    50,    51,    52,     0,     0,    53,
       0,    54,    55,    56,    57,    58,    59,    60,     0,    61,
       0,    62,     0,     0,     0,     0,    63,    64,     0,     0,
      65,    66,    67,    68,    69,    70,    71,     0,     0,     0,
       0,     0,    72,    73,    74,     0,    75,     0,     0,    76,
       0,     0,    77,     0,    78,     0,    79,     0,    80,   197,
      81,    82,    83,     0,   198,     0,     0,    84,     0,     0,
       0,   199,     0,     0,     0,     0,     0,     0,     0,   200,
       0,   201,     0,     0,     0,     0,   202,     0,     0,     0,
       0,     0,     0,   203,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   204,     0,     0,     0,     0,     0,     0,
     205,     0,     0,   206,   207,     0,   208,     0,     0,     0,
       0,     0,     0,     0,   209,     0,   210,     0,   211,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   212,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   213,     0,   214,   215,     0,     0,
     216,     0,     0,     0,     0,     0,     0,   217,     0,     0,
       0,     0,     0,     0,     0,   218,     0,     0,     0,     0,
     219,   220,     0,     0,     0,     0,   221,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,     0,   226,     0,     0,     0,     0,     0,
     227,     0,     0,     0,     0,     0,   228,   229,   230,     0,
       0,     0,     0,     0,     0,   231,   232,     0,     0,   233,
       0,     0,   234,     0,     0,   235,     0,     0,     0,   236,
       0,   237,     0,   238,     0,   239,     0,     0,     0,     0,
     240
};

static const yytype_int16 yycheck[] =
{
      31,   146,    94,   188,   148,   264,   466,   499,   184,   444,
     242,   115,     0,   285,   159,   247,   161,   463,   123,   128,
     129,   160,   284,     0,   755,   190,   332,   173,   385,   763,
     374,   764,   177,   488,   767,   768,   639,   603,   992,   666,
     179,   488,   417,    14,   647,   978,   257,    24,   945,   738,
      22,    11,    41,    60,   158,    23,    29,   149,    27,   956,
      41,    41,    52,    11,  1050,   422,    29,    88,     8,    92,
      41,    13,  1058,   165,    51,     6,     8,    29,    79,    56,
      81,    12,   113,     8,    61,     8,     8,    11,    29,    42,
      21,  1093,   123,    13,    71,    37,   126,    85,    11,    35,
     109,    79,   679,    40,   132,    35,    29,   128,    85,   558,
      40,   103,    43,    44,   145,   138,    52,    37,   149,    60,
      51,    30,    53,   154,    12,    34,    52,    13,    81,   862,
     863,   161,   109,   164,   867,   868,  1069,    11,  1092,    81,
     589,   110,   173,    85,    35,    52,   109,    11,   126,   156,
     178,    37,   183,   181,   185,    75,   133,   188,    98,   190,
      29,    81,   139,  1165,   256,    85,    98,   176,    88,   274,
     402,   515,   109,    98,   151,    98,    98,    11,   126,   109,
     170,   171,    76,   160,   644,   109,   163,   164,    35,    75,
     336,   100,   128,   124,   146,    81,   109,  1183,    86,    85,
     109,   202,   179,   127,   781,   194,   146,   167,   181,   186,
      20,  1144,   184,   194,   194,   246,   591,   159,   109,   404,
     431,   146,  1224,   194,   146,   253,   915,    20,   197,   257,
     198,    75,   163,   164,   122,   109,    35,   206,   613,   159,
    1137,    40,   702,   274,    36,   109,   277,   178,  1202,  1056,
     103,   982,    52,    88,  1061,  1188,   716,    50,   127,   287,
     291,   170,   171,  1070,    35,    65,    65,    52,    36,    69,
     614,   105,   106,   159,    76,   306,   170,   171,   309,   906,
     846,   128,    16,   558,    94,    52,   778,   128,    80,   892,
      18,    91,   127,  1069,   138,   323,    88,    36,    65,  1075,
      35,   447,    69,    36,   157,   336,    40,   109,   100,    80,
      40,   342,    80,   117,   589,    35,   347,   109,    18,   774,
     775,   349,   299,   468,    91,   501,    26,   774,   775,   170,
     171,   128,   100,    40,    52,   135,   367,   368,   369,  1146,
      35,   109,   134,   374,    75,    76,    75,    76,  1082,   148,
      50,   708,   380,    35,   385,    88,   700,   128,    40,    87,
     157,   100,    33,    63,  1097,   474,   134,   100,   135,   726,
     109,   170,   171,   404,   405,   109,   109,  1184,  1154,   109,
     180,    78,    82,    83,    84,    35,   417,   364,    88,   109,
     190,   422,   568,   128,    52,   134,    13,   103,   544,    96,
     428,   134,   109,   431,   128,   711,   551,    35,   128,   574,
      79,   108,    81,   180,   109,    86,   447,    88,    35,    79,
     120,    81,   128,   190,   455,   456,   126,   109,    30,   406,
    1161,   126,    34,   128,   103,    88,   136,   161,    88,   170,
     171,   170,   171,   153,   128,    88,   128,   147,   108,   139,
      63,   104,   714,   481,   125,   165,   126,   170,   171,   109,
      88,   921,   146,   128,   128,    15,   494,   157,   499,    82,
     127,   563,   918,   170,   171,   579,   146,    90,   128,   132,
     107,   109,    52,    92,   515,   462,   517,   518,   157,   520,
     200,   676,   157,   157,   103,   195,   527,   528,   100,   126,
     128,    88,   109,   203,   609,   951,   645,   109,   109,     3,
       4,    54,   697,   544,     8,   543,    79,   104,    81,   126,
      83,    15,    85,    52,    13,   126,   554,    52,   556,    79,
      80,    81,    82,    83,    84,    85,    79,   128,    81,    89,
      29,    52,   476,   574,   100,    52,    40,   138,    52,    47,
      48,   582,   486,   109,    52,   740,    90,    79,   703,    81,
     591,   100,    52,   126,   118,    99,    88,   149,   596,    67,
     109,    80,   126,    75,    76,   157,   126,   849,   609,    88,
      78,    52,   613,   614,    52,    79,    80,    81,    82,    83,
      84,    85,   569,    52,    88,    89,    29,    52,    96,   630,
     631,   632,    35,   580,   780,   633,    82,    83,   639,   168,
     108,   170,   171,   598,   599,   109,   647,   709,   116,    79,
    1112,    81,    79,   600,    81,    52,   109,    52,   732,    52,
      52,   807,   126,   664,    52,    52,    52,    52,    52,    52,
      18,    52,   140,    52,    52,   676,   634,   756,    26,    52,
      52,  1111,   629,  1088,    52,    52,   687,    52,    52,    52,
      52,   692,   693,    52,    52,    52,   697,    57,   645,   700,
      52,   699,    50,    52,   119,    52,   704,   708,    52,    52,
     912,    52,   157,   660,    52,    63,    61,   181,    28,    13,
      71,   103,    88,   103,   838,   726,    35,    26,   127,    57,
      61,   678,   128,   196,    82,    83,    84,   141,    88,   740,
      88,    35,    61,    37,   187,  1207,    35,   748,   192,   103,
     126,    28,    76,    13,    87,   984,    18,   103,    97,   760,
      48,   203,    40,   761,    29,    29,  1145,   109,    79,    28,
      28,   769,   120,   720,    29,   128,  1155,   778,   126,   127,
      32,    75,   122,   784,   114,    29,    38,    81,   136,    41,
     184,    85,    29,    29,    88,  1225,    29,    29,    80,   147,
      52,    92,    90,   205,   919,   803,  1185,   805,    60,    97,
    1189,    63,    52,    52,   102,   109,    68,    69,    88,    18,
      88,   146,    76,   111,   161,    77,    35,   115,   943,    58,
      11,    29,    29,   121,   128,   205,   157,  1216,    29,   786,
      52,    29,   146,   146,    40,   792,    24,   195,    40,   184,
     184,    45,   140,  1232,   852,    35,    29,    40,  1004,   857,
      29,   127,    52,    52,   116,   159,   981,  1013,    29,    75,
     157,   127,    88,    83,    82,    29,   170,   171,   157,   103,
     186,   882,   198,   177,    23,    35,    29,   179,    88,    40,
     952,   892,   177,    88,   157,    18,    83,    52,   960,   103,
      52,   139,   203,   904,    52,    52,   907,   157,    46,   910,
     162,   146,   139,     9,    29,   146,    35,   139,    29,    29,
      29,    26,   139,   924,    83,   923,    29,   157,  1042,   203,
      55,   157,    98,   146,   127,   936,    29,    35,    40,   184,
     165,   148,   194,   128,  1099,   146,    60,    29,    40,   200,
     184,   203,   204,   127,    40,    76,   184,    29,   163,    85,
     146,   708,   146,   139,   146,   726,   103,   146,   693,   146,
     697,   692,  1011,   533,   146,   922,   570,   978,  1205,   666,
    1237,  1225,   157,   527,   810,   687,   322,   709,   986,  1073,
     911,   513,   265,   759,   995,   754,   272,   455,   747,   456,
     743,  1063,   606,  1211,  1042,  1006,   953,  1069,  1009,   914,
     957,  1052,   921,  1176,   740,  1024,   907,   842,  1191,   976,
     281,   975,   968,  1063,   605,   846,  1198,   942,  1009,   520,
     675,  1032,   786,   980,   869,   547,  1160,   493,  1036,  1089,
     774,   481,   775,   775,   134,  1160,   129,    -1,    -1,  1047,
      -1,    -1,    -1,    -1,    -1,  1056,    -1,    -1,    -1,    -1,
    1061,  1008,    -1,    -1,  1011,    -1,    -1,    -1,  1069,  1070,
      -1,    -1,    -1,    -1,    -1,    -1,  1077,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1083,    -1,    -1,    -1,    -1,
      -1,    -1,  1154,  1040,    -1,    -1,    -1,  1211,  1099,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1112,    -1,    -1,    -1,    -1,    -1,    -1,  1233,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1188,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1144,    -1,  1146,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1164,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1172,    -1,    -1,    -1,    -1,    -1,
      -1,  1182,    -1,  1184,    -1,    -1,    -1,  1188,    -1,    -1,
      -1,    -1,    -1,    -1,     0,     1,    -1,    -1,    -1,     5,
      -1,     7,  1149,    -1,    10,    -1,  1207,    -1,    -1,    -1,
    1208,    17,    18,    19,    20,  1162,    -1,    -1,    -1,    25,
      -1,    27,    -1,    -1,    -1,    31,    32,    33,    -1,  1176,
      -1,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,  1237,
      -1,    -1,  1240,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      56,    57,    -1,    59,    60,    61,    62,    -1,    64,    -1,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    74,    -1,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      86,    87,    88,    -1,    90,    91,    -1,    93,    -1,    95,
      -1,    -1,    -1,    99,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,    -1,    -1,
     116,    -1,    -1,   119,   120,   121,    -1,   123,    -1,   125,
      -1,    -1,    -1,   129,   130,   131,    -1,   133,    -1,    -1,
     136,   137,    -1,    -1,    -1,    -1,   142,   143,   144,   145,
      -1,    -1,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,    -1,    -1,   165,
     166,    -1,    -1,   169,   170,   171,   172,   173,   174,   175,
      -1,    -1,    -1,    -1,    -1,   181,   182,   183,    -1,   185,
      -1,    -1,   188,    -1,    -1,   191,    -1,   193,    -1,   195,
      -1,   197,     1,   199,   200,   201,     5,    -1,     7,    -1,
     206,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    27,    -1,
      -1,    -1,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    56,    57,    -1,
      59,    60,    61,    62,    -1,    64,    -1,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    74,    -1,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    87,    88,
      -1,    90,    91,    -1,    93,    -1,    95,    -1,    -1,    -1,
      99,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
     109,   110,   111,   112,   113,    -1,    -1,   116,    -1,    -1,
     119,   120,   121,    -1,   123,    -1,   125,    -1,    -1,    -1,
     129,   130,   131,    -1,   133,    -1,    -1,   136,   137,    -1,
      -1,    -1,    -1,   142,   143,   144,   145,    -1,    -1,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,    -1,    -1,   165,   166,    -1,    -1,
     169,   170,   171,   172,   173,   174,   175,    -1,    -1,    -1,
      -1,    -1,   181,   182,   183,    -1,   185,    -1,    -1,   188,
      -1,    -1,   191,    -1,   193,    -1,   195,    -1,   197,     5,
     199,   200,   201,    -1,    10,    -1,    -1,   206,    -1,    -1,
      -1,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,
      -1,    27,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    59,    60,    -1,    62,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    -1,    72,    -1,    74,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,    -1,   112,   113,    -1,    -1,
     116,    -1,    -1,    -1,    -1,    -1,    -1,   123,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,
     136,   137,    -1,    -1,    -1,    -1,   142,   143,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,    -1,    -1,    -1,
     166,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,    -1,
      -1,    -1,    -1,    -1,    -1,   181,   182,    -1,    -1,   185,
      -1,    -1,   188,    -1,    -1,   191,    -1,    -1,    -1,   195,
      -1,   197,    -1,   199,    -1,   201,    -1,    -1,    -1,    -1,
     206
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,     5,     7,    10,    17,    19,    20,    25,    27,
      31,    32,    39,    49,    56,    57,    59,    60,    62,    64,
      66,    70,    71,    72,    73,    74,    87,    90,    91,    93,
      95,    99,   101,   102,   103,   110,   111,   112,   113,   116,
     120,   121,   123,   129,   130,   131,   133,   136,   137,   142,
     143,   144,   145,   148,   150,   151,   152,   153,   154,   155,
     156,   158,   160,   165,   166,   169,   170,   171,   172,   173,
     174,   175,   181,   182,   183,   185,   188,   191,   193,   195,
     197,   199,   200,   201,   206,   208,   209,   210,   211,   220,
     221,   222,   223,   226,   227,   231,   232,   233,   234,   235,
     236,   237,   242,   244,   285,   332,   335,   338,   339,   341,
     342,   343,   344,   345,   445,   470,   479,   480,   502,   504,
     506,   513,   514,   515,   517,   518,   535,   541,   542,   552,
     553,   103,    52,   224,    52,    52,    52,   117,   247,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
     341,    52,   127,   446,   447,   449,    52,   109,   240,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
     341,    41,   194,   536,   341,   219,   471,    52,    52,    52,
     341,    52,   219,    52,    52,    88,    52,    52,    52,   341,
      52,    52,   333,   335,    52,    52,    52,     5,    10,    17,
      25,    27,    32,    39,    49,    56,    59,    60,    62,    70,
      72,    74,    93,   110,   112,   113,   116,   123,   131,   136,
     137,   142,   143,   155,   156,   158,   160,   166,   172,   173,
     174,   181,   182,   185,   188,   191,   195,   197,   199,   201,
     206,   340,    52,    52,    52,   219,    52,    52,     0,   209,
     157,   478,   219,    11,   126,   228,   229,   418,   103,   157,
     243,   243,    52,    61,   119,   128,   341,   103,    76,   238,
     240,   346,   347,   348,   349,   352,   354,   356,   357,   478,
     103,   485,    33,    86,    88,   125,   481,    28,    11,   352,
     516,    88,   519,    88,   104,   132,   490,   544,   554,   554,
      40,   240,   498,   225,   341,   553,   267,    35,   241,   404,
     305,   341,    26,    79,    81,   310,   127,   450,    20,    50,
     326,    57,   240,   404,    61,    14,    41,   194,   317,   391,
     240,   300,   418,   168,   341,   530,   196,   448,    11,   240,
     451,   452,    54,    79,    81,   249,   478,   404,   530,   404,
      12,    86,   122,   329,   341,    30,    34,   100,   240,   292,
     294,   295,   296,   299,   341,   118,   318,   418,   259,   251,
     141,    11,   167,   284,   238,   537,   538,   218,   472,   313,
     404,   311,   498,   530,   498,   212,   176,   240,   303,   241,
     240,   341,   272,    36,   100,   134,   240,   256,   257,   395,
     400,   289,   290,   292,   245,    88,   336,    61,   334,    41,
     194,   327,   187,   192,   301,   310,   320,   321,    79,    81,
     202,   246,   213,   240,   310,    35,   128,   230,   492,   498,
     103,   418,   230,    48,    90,    97,   102,   111,   115,   121,
     140,   286,   287,   288,   333,   342,   103,    35,   358,    28,
     355,   348,   351,   352,    13,   353,    29,   239,   240,   359,
     103,    47,    48,    52,    67,    78,    96,   108,   116,   140,
     403,   486,   487,   507,   503,   504,   519,    18,   482,   483,
     498,   525,   526,   527,   240,    97,   520,   491,   203,   545,
     341,   109,   500,    40,    29,   127,   240,   268,   269,   270,
     271,    29,   240,    79,   248,   247,   498,    13,    37,    81,
      85,   159,   426,   419,   426,   238,    28,    13,    35,   453,
      29,   454,   240,   240,   498,   122,   128,   128,   161,   341,
     114,   319,   240,   240,   260,   261,   262,    88,   252,   253,
     254,   256,   239,    28,   184,   539,    60,   156,   473,   474,
     476,    29,   314,   498,    29,   312,    29,   315,   214,   215,
     356,    79,    81,    88,   304,    42,    81,   298,    29,    29,
     273,   274,   401,    80,   291,   297,   310,   256,   240,   337,
     341,   205,   330,    11,   105,   106,   302,   322,   359,   216,
     217,   356,    79,   126,   250,   498,   161,   230,    13,    29,
     336,   238,    92,   361,   362,   363,   364,   365,   139,   157,
     350,   354,   357,    29,    35,   360,   341,    15,    79,    80,
      81,    82,    83,    84,    85,    89,   126,   436,   437,    52,
      52,   492,    52,   404,   488,   490,   512,   490,    18,   449,
     484,    88,   528,   526,    76,   529,   146,   449,   493,   495,
     436,   437,   501,   546,   547,   548,   549,   550,   551,    58,
     543,   499,   500,   498,    35,   263,    29,    11,   271,   241,
     205,   328,   328,   239,    75,   440,   460,   461,   462,   463,
     464,   465,   466,   240,   240,   452,   157,   293,   100,   296,
     240,   263,    29,   255,    82,    83,   258,    29,   498,   540,
     238,    52,   477,   477,   404,   498,   498,   218,   353,   306,
     307,   418,   241,   341,   274,    40,   396,   292,   146,   478,
     341,   240,    23,   198,   323,   218,   353,   359,    24,   498,
     287,   287,   341,   153,   165,   200,   366,   362,    76,   369,
     370,   373,   438,   440,   365,   352,   359,   239,    40,   341,
     240,   240,   240,   498,   335,   184,   184,   146,   451,    45,
      35,   492,   530,   451,    29,     3,     4,     8,    88,   181,
     496,   498,   501,    40,    29,    52,   341,   240,   269,   270,
      29,   463,   256,   393,    76,   341,   468,   469,   464,   157,
     127,   294,    88,   264,   262,   253,    83,    82,   254,   256,
     157,   498,   239,   378,   492,   404,   498,    29,   316,   215,
     146,   307,   308,   426,   146,   276,   504,    80,   397,   399,
     492,   103,   341,   186,   331,   198,   324,    23,   325,   217,
     478,    27,   110,   197,   206,   367,   368,    35,   373,   405,
     406,   407,   408,   411,   414,   393,   361,   360,   240,   334,
     512,   490,    60,   521,   343,   240,   498,   179,   531,   521,
     494,   496,    88,    88,   496,   496,   498,     8,    98,    40,
      79,    81,    83,    85,   126,   497,   547,   550,   551,   271,
     241,   138,   441,    83,   467,   126,   240,   456,   457,   458,
     157,   469,   455,   266,   341,   146,   157,    16,   475,   498,
     498,   241,   304,   177,   309,    18,   277,   398,   103,    52,
      52,    52,    52,   149,   157,   139,    32,    38,    52,    60,
      63,    68,    69,    77,   162,   203,   204,   374,   375,   376,
     390,   391,   402,   403,   435,     6,    12,    21,    43,    44,
      51,    53,   124,   163,   164,   178,   379,   380,   381,   392,
     410,    52,    65,    69,    91,   135,   180,   190,   409,   430,
     431,    18,    26,    50,    63,    82,    83,    84,    88,   120,
     136,   147,   195,   203,   412,   413,   415,   416,   418,   441,
     519,    22,   184,   508,   203,   505,    35,   498,   522,    46,
     146,   139,   498,   532,   157,     9,   524,   146,   496,   496,
     146,   496,   496,   497,    29,   240,    35,   459,   139,    29,
     451,    29,   265,    29,    35,   128,   240,   421,   427,   428,
     429,    88,   270,   278,   395,    26,   240,   320,   310,   368,
     373,   436,   404,    35,   128,   377,   378,   341,   498,   240,
     382,   139,   157,   240,   203,   394,   450,   404,   384,   391,
     384,   157,    29,   409,   436,   161,   418,   341,   384,   341,
     107,   418,   432,   433,   434,    83,   416,   414,   410,    88,
     177,   341,   417,   422,   423,   427,   127,   442,    78,    96,
     108,   341,   489,   404,   510,   511,   509,   512,   333,   498,
      55,   523,    80,   528,   533,   240,   146,    29,   241,    29,
     443,   240,   341,   458,   266,   146,   241,    35,   128,    20,
      94,   279,   275,   401,   240,   498,    35,    40,    65,   148,
     341,   386,   387,   388,   389,    40,   371,   376,   165,   498,
     184,   385,   385,   381,   421,   385,   421,   148,   434,   146,
     127,   418,   422,   427,    88,   421,   309,    13,    37,    75,
      81,    85,   159,   425,    88,   420,   422,   240,   521,   498,
      29,   184,   336,   523,   128,   528,   534,   529,   496,   256,
     157,   280,   492,    11,   271,   281,    29,   127,   383,    40,
     372,   127,   200,   384,   146,   146,   427,   417,    88,   421,
     341,   424,   418,   422,   417,    79,    81,   108,   439,   511,
     512,   341,   498,   529,   146,   184,   498,    29,   181,   387,
      40,    76,   240,   385,   421,   417,   146,   418,   427,   417,
     138,   425,   146,   443,   528,   279,   271,   282,   283,   498,
     374,   417,   146,   163,   444,   529,   280,    29,   139,   417,
     404,   157,   146,   283,   498
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   207,   208,   208,   209,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   210,   210,   210,   210,
     210,   210,   210,   210,   210,   210,   211,   212,   211,   213,
     211,   214,   214,   215,   216,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   228,   229,
     229,   230,   230,   230,   231,   232,   233,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   243,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   245,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     246,   246,   246,   247,   247,   248,   248,   249,   249,   249,
     250,   250,   250,   251,   252,   252,   253,   253,   253,   253,
     255,   254,   256,   256,   257,   257,   258,   258,   258,   258,
     258,   259,   260,   260,   261,   261,   262,   263,   263,   264,
     264,   265,   265,   266,   267,   268,   268,   268,   268,   268,
     269,   269,   270,   271,   272,   273,   273,   274,   275,   276,
     277,   278,   278,   278,   279,   279,   280,   280,   281,   281,
     281,   282,   282,   283,   284,   284,   285,   286,   286,   286,
     287,   288,   288,   288,   288,   288,   288,   288,   288,   289,
     290,   291,   290,   292,   293,   292,   294,   294,   294,   294,
     294,   295,   295,   296,   297,   297,   298,   298,   299,   299,
     299,   299,   300,   300,   301,   302,   302,   302,   302,   303,
     303,   303,   303,   304,   304,   304,   305,   305,   306,   306,
     307,   308,   308,   309,   309,   310,   310,   311,   312,   312,
     313,   314,   314,   315,   315,   316,   316,   317,   317,   318,
     318,   319,   319,   321,   320,   322,   322,   323,   323,   323,
     324,   324,   325,   325,   326,   326,   327,   327,   328,   328,
     329,   329,   329,   330,   331,   331,   332,   333,   334,   334,
     335,   335,   336,   336,   337,   337,   337,   338,   339,   339,
     340,   340,   340,   340,   340,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   341,   341,   342,   342,   343,   344,
     344,   344,   345,   346,   346,   347,   347,   348,   349,   350,
     351,   351,   352,   352,   353,   354,   354,   355,   356,   356,
     357,   358,   358,   359,   359,   360,   360,   361,   361,   362,
     362,   363,   363,   364,   364,   365,   366,   366,   366,   367,
     367,   368,   368,   368,   368,   369,   370,   370,   370,   371,
     371,   372,   372,   373,   374,   374,   375,   375,   376,   376,
     376,   376,   376,   376,   376,   376,   376,   376,   377,   377,
     377,   378,   378,   379,   379,   380,   380,   381,   381,   381,
     381,   381,   381,   381,   382,   383,   383,   384,   384,   385,
     385,   386,   386,   387,   388,   388,   389,   389,   389,   389,
     390,   390,   390,   390,   391,   391,   392,   392,   392,   392,
     392,   393,   393,   394,   394,   395,   395,   396,   396,   397,
     398,   399,   399,   400,   400,   400,   401,   401,   402,   403,
     404,   404,   405,   405,   406,   407,   408,   409,   409,   409,
     409,   409,   409,   409,   409,   410,   410,   411,   412,   412,
     413,   414,   414,   415,   415,   415,   415,   415,   415,   415,
     415,   415,   415,   415,   415,   415,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   417,   417,
     418,   419,   419,   420,   420,   421,   421,   422,   423,   424,
     424,   425,   425,   425,   425,   425,   425,   426,   426,   426,
     426,   426,   427,   427,   427,   428,   428,   429,   429,   430,
     431,   432,   432,   432,   433,   433,   434,   435,   436,   436,
     436,   436,   436,   436,   436,   436,   436,   436,   437,   438,
     439,   439,   439,   439,   440,   441,   442,   442,   443,   443,
     444,   444,   445,   446,   447,   448,   448,   448,   449,   449,
     450,   450,   451,   451,   451,   452,   453,   453,   453,   454,
     455,   454,   456,   456,   457,   457,   458,   459,   459,   460,
     461,   462,   462,   463,   463,   464,   465,   465,   466,   467,
     467,   468,   468,   469,   469,   470,   470,   470,   471,   470,
     470,   470,   470,   472,   472,   473,   473,   474,   475,   475,
     476,   477,   477,   478,   478,   479,   479,   480,   481,   481,
     482,   483,   484,   484,   485,   485,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   487,   487,   488,   489,   489,
     489,   489,   490,   491,   492,   492,   493,   494,   495,   496,
     496,   496,   496,   496,   496,   496,   496,   496,   497,   497,
     497,   497,   497,   498,   498,   498,   499,   499,   500,   501,
     502,   503,   504,   504,   505,   505,   506,   507,   508,   508,
     509,   509,   510,   510,   511,   512,   513,   514,   514,   514,
     515,   516,   516,   517,   518,   518,   518,   518,   518,   518,
     519,   519,   520,   520,   521,   521,   522,   522,   523,   523,
     524,   524,   525,   525,   526,   527,   528,   528,   529,   529,
     530,   530,   530,   531,   531,   532,   533,   533,   534,   534,
     535,   536,   536,   536,   537,   538,   538,   539,   539,   539,
     540,   540,   541,   541,   542,   543,   543,   544,   544,   545,
     545,   546,   546,   547,   547,   548,   549,   550,   550,   551,
     551,   552,   552,   553,   554,   554,   554
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     1,     1,     1,     1,     2,
       1,     1,     2,     3,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     3,     0,     5,     0,
       5,     1,     3,     1,     1,     3,     2,     0,     0,     2,
       1,     1,     3,     0,     1,     3,     1,     2,     1,     2,
       3,     3,     1,     3,     2,     1,     2,     2,     3,     1,
       2,     2,     1,     1,     1,     2,     2,     1,     1,     4,
       2,     4,     4,     5,     4,     3,     4,     3,     4,     4,
       5,     4,     4,     4,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     3,     3,     3,     3,     3,
       2,     0,     4,     3,     4,     4,     3,     3,     3,     6,
       3,     3,     3,     3,     3,     3,     3,     3,     9,     5,
       1,     1,     1,     0,     1,     0,     1,     1,     1,     2,
       0,     1,     1,     0,     0,     1,     1,     1,     3,     3,
       0,     4,     4,     2,     0,     1,     0,     2,     2,     1,
       1,     0,     0,     1,     1,     3,     3,     0,     2,     0,
       4,     0,     2,     1,     0,     0,     1,     4,     2,     2,
       0,     1,     1,     2,     0,     1,     9,     0,     0,     1,
       1,     0,     1,     7,     1,     1,     0,     2,     1,     3,
       1,     1,     3,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     0,     3,     1,     0,     4,     1,     1,     3,     3,
       1,     1,     3,     1,     0,     1,     0,     1,     0,     1,
       1,     2,     3,     3,     2,     0,     1,     1,     1,     2,
       2,     2,     5,     0,     1,     1,     0,     1,     1,     2,
       4,     0,     1,     0,     1,     1,     1,     1,     0,     2,
       2,     0,     3,     0,     3,     0,     4,     1,     1,     1,
       2,     0,     1,     0,     2,     0,     2,     0,     2,     2,
       0,     1,     0,     1,     1,     1,     1,     1,     0,     1,
       1,     2,     1,     1,     0,     1,     6,     2,     0,     1,
       0,     1,     0,     3,     1,     2,     3,     7,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     6,     2,     4,
       3,     1,     0,     1,     1,     1,     2,     3,     1,     1,
       1,     3,     1,     3,     1,     1,     2,     1,     1,     3,
       2,     0,     2,     2,     4,     0,     2,     1,     2,     2,
       5,     0,     1,     1,     2,     4,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     2,     1,     4,     6,     0,
       3,     0,     4,     0,     0,     1,     1,     3,     4,     1,
       1,     1,     1,     3,     2,     2,     2,     2,     1,     1,
       2,     0,     1,     0,     1,     1,     3,     1,     3,     2,
       2,     1,     3,     3,     0,     0,     1,     0,     1,     0,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     0,     1,     0,     3,     1,     1,     0,     2,     4,
       0,     0,     1,     0,     1,     1,     0,     2,     1,     3,
       0,     1,     1,     1,     2,     2,     0,     1,     3,     2,
       3,     2,     2,     2,     1,     0,     2,     2,     0,     3,
       1,     0,     3,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     2,     5,     5,     3,
       5,     7,     5,     4,     6,     4,     5,     4,     0,     1,
       1,     0,     1,     0,     1,     0,     1,     3,     0,     0,
       2,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     2,     5,
       1,     0,     1,     1,     1,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     9,
       0,     1,     1,     1,     1,     1,     0,     1,     0,     2,
       0,     3,     5,     3,     1,     0,     2,     3,     0,     1,
       0,     1,     1,     1,     3,     2,     0,     2,     2,     0,
       0,     5,     1,     1,     1,     3,     2,     0,     2,     0,
       2,     0,     1,     1,     2,     2,     3,     1,     5,     0,
       1,     1,     2,     2,     5,     2,     1,     1,     0,     3,
       1,     1,     1,     0,     2,     1,     1,     4,     1,     1,
       4,     0,     1,     0,     1,     1,     1,     3,     0,     4,
       2,     1,     0,     4,     0,     2,     1,     2,     1,     1,
       3,     3,     3,     3,     7,     2,     1,     0,     1,     1,
       1,     1,     6,     0,     1,     1,     2,     1,     0,     3,
       3,     3,     2,     4,     6,     1,     3,     2,     1,     1,
       1,     1,     1,     1,     3,     2,     0,     1,     1,     1,
       7,     0,     0,     1,     0,     4,     7,     0,     2,     2,
       1,     3,     1,     3,     2,     1,     3,     7,     6,     2,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       0,     3,     0,     1,     0,     2,     2,     3,     0,     1,
       0,     2,     1,     2,     5,     2,     0,     4,     0,     4,
       0,     1,     1,     0,     2,     2,     2,     2,     2,     4,
       5,     0,     1,     1,     2,     1,     2,     0,     2,     3,
       2,     3,     3,     5,     1,     0,     1,     1,     1,     0,
       2,     1,     3,     1,     1,     3,     1,     1,     1,     1,
       3,     1,     1,     1,     0,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 14:
#line 642 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* for blank lines -- nothing to do */
	}
#line 2835 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 648 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* to keep going after stumbling on an input error */
		Getting_tup_dur = NO;
		Good_till_canceled = NO;
		Defining_multiple = NO;
		Doing_vcombine = NO;
		Curr_grpsyl_p = (struct GRPSYL *) 0;
		Last_grpsyl_p = (struct GRPSYL *) 0;
		Prev_grpsyl_p = (struct GRPSYL *) 0;
	}
#line 2850 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 660 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* fill in context field of the SSV struct */
		Currstruct_p->u.ssv_p->context = (short) Context;
	}
#line 2859 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 667 "src/mup/gram.y" /* yacc.c:1646  */
    {}
#line 2865 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 671 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_family = Score.fontfamily;
	}
#line 2873 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 677 "src/mup/gram.y" /* yacc.c:1646  */
    {}
#line 2879 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 681 "src/mup/gram.y" /* yacc.c:1646  */
    {}
#line 2885 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 685 "src/mup/gram.y" /* yacc.c:1646  */
    {}
#line 2891 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 689 "src/mup/gram.y" /* yacc.c:1646  */
    {}
#line 2897 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 693 "src/mup/gram.y" /* yacc.c:1646  */
    {}
#line 2903 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 697 "src/mup/gram.y" /* yacc.c:1646  */
    {}
#line 2909 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 701 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* have lots of separate structs in music context, so
		 * mark that we have no current struct */
		Currstruct_p = (struct MAINLL *) 0;

		/* make sure at least 1 staff is visible. Not good to
		 * check when user sets visible, because it would be
		 * nice to first set everything invisible and later
		 * turn one on. So if we wait till now to check,
		 * user doesn't have to switch back and forth from
		 * score to staff to get 1 voice visible. */
		check_at_least1visible();
	}
#line 2927 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 716 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Context = C_SCORE;
		Curr_font = svpath(0, FONT)->font;
		Curr_family = svpath(0, FONTFAMILY)->fontfamily;
		Curr_size = svpath(0, SIZE)->size;
	}
#line 2938 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 724 "src/mup/gram.y" /* yacc.c:1646  */
    { begin_range(PL_UNKNOWN); }
#line 2944 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 725 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Make sure all the staffs are in range */
		chk_ssv_ranges(C_STAFF);

		/* Set current SSV's staff to the first one on the list.
		 * If there is more than one, we will clone the SSV later.
		 * Note that it is possible that the staff number the user
		 * specified is actually illegal, but we will use it anyway,
		 * because it keeps the code simpler to pretend all is well,
		 * and ssv.c code will ignore such illegal SSVs anyway.
		 */
		if (Svrangelist_p != 0 && Svrangelist_p->stafflist_p != 0) {
			Currstruct_p->u.ssv_p->staffno
					= Svrangelist_p->stafflist_p->begin;
		}
		Context = C_STAFF;
	}
#line 2966 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 744 "src/mup/gram.y" /* yacc.c:1646  */
    { begin_range(PL_UNKNOWN); }
#line 2972 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 745 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Make sure all the staffs and voices are in range */
		chk_ssv_ranges(C_VOICE);

		/* Set current SSV's staff/voice to the first one on the list.
		 * If there are more than, we will clone the SSV later */
		if (Svrangelist_p != 0 && Svrangelist_p->stafflist_p != 0) {
			Currstruct_p->u.ssv_p->staffno
					= Svrangelist_p->stafflist_p->begin;
		}
		if (Svrangelist_p != 0 && Svrangelist_p->vnolist_p != 0) {
			Currstruct_p->u.ssv_p->voiceno
					= Svrangelist_p->vnolist_p->begin;
		}
		Context = C_VOICE;
	}
#line 2993 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 769 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_to_sv_list();
	}
#line 3001 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 779 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_to_sv_list();
	}
#line 3009 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 784 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* allocate an SSV struct */
		Currstruct_p = newMAINLLstruct(S_SSV, yylineno);
	}
#line 3018 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 790 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* entering new context, if we have a current struct,
		 * we were in a different context, so add its info to the list */
		end_prev_context();
	}
#line 3028 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 797 "src/mup/gram.y" /* yacc.c:1646  */
    {
		struct FEED *feed_p;		/* where to attach blocks */
		int calloced;			/* YES if dynamically alloced */

		end_prev_context();
		Context = (yyvsp[-1].intval);
		calloced = NO;

		switch ((yyvsp[-1].intval)) {
		case C_HEADER:
			switch ((yyvsp[0].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_HEADER, "header", &Header);
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LHEADER,
					"header leftpage", &Leftheader);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RHEADER,
					"header rightpage", &Rightheader);
				break;
			}
			break;

		case C_HEAD2:
			switch ((yyvsp[0].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_HEADER2,
					"header2", &Header2);
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LHEADER2,
					"header2 leftpage", &Leftheader2);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RHEADER2,
					"header2 rightpage", &Rightheader2);
				break;
			}
			break;
		case C_FOOTER:
			switch ((yyvsp[0].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_FOOTER,
					"footer", &Footer); 
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LFOOTER,
					"footer leftpage", &Leftfooter);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RFOOTER,
					"footer rightpage", &Rightfooter);
				break;
			}
			break;
		case C_FOOT2:
			switch ((yyvsp[0].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_FOOTER2,
					"footer2", &Footer2);
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LFOOTER2,
					"footer2 leftpage", &Leftfooter2);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RFOOTER2,
					"footer2 rightpage", &Rightfooter2);
				break;
			}
			break;
		case C_TOP:
		case C_TOP2:
		case C_BOT:
		case C_BOT2:
		case C_BLOCK:
			CALLOC(BLOCKHEAD, Currblock_p, 1);
			calloced = YES;
			break;
		default:
			pfatal("Unknown block-type context");
			/*NOTREACHED*/
			break;
		}
		set_win_coord(Currblock_p->c);
		/* Remember where to start attaching "print" commands */
		Next_print_link_p_p = &(Currblock_p->printdata_p);

		/* The dynamically allocated blocks
		 * (not the static head/foot blocks)
		 * need extra processing to populate
		 * the main list properly with FEEDs.
		 */
		if (calloced == YES) {
			if (Mainlltc_p == 0 || Mainlltc_p->str != S_FEED) {
				/* User had not specified a feed
				 * right before this block, so we need
				 * to add one for them implicitly.
				 * Create a new FEED and add it
				 * to the end of the main list.
				 */
				insertMAINLL(newMAINLLstruct(S_FEED, yylineno),
							Mainlltc_p);
			}
			feed_p = Mainlltc_p->u.feed_p;

			/* Normally, top/top2/bot/bot2 result in a pagefeed.
			 * But we have a special case for backward
			 * compatibility and for flexibility.
			 * User can get a separate
			 * "title" page if they really want to,
			 * by using an explicit newpage at the beginning.
			 * But in the normal case, they'd want to declare
			 * top/bot that will go on the first page without
			 * that causing a newpage. So if there hasn't been
			 * any music or block yet, we won't set newpage=YES
			 * for top/top2/bot/bot2, but otherwise we will.
			 */
			if (Context & (C_TOP|C_TOP2|C_BOT|C_BOT2)) {
				struct MAINLL *m_p;
				for (m_p = Mainlltc_p->prev; m_p != 0;
							m_p = m_p->prev) {
					if (m_p->str == S_BAR ||
							m_p->str == S_BLOCKHEAD) {
						/* There was music or block,
						 * so this is not
						 * at very beginning,
						 * so no special case:
						 * there will be new page.
						 */
						feed_p->pagefeed = YES;
						break;
					}
				}
			}

			/* Now check for redefined blocks and
			 * attach the BLOCKHEAD onto the FEED or the
			 * main list, as appropriate.
			 */
			switch (Context) {
			case C_TOP:
				switch ((yyvsp[0].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->top_p),
							"top" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->lefttop_p),
							"top leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->righttop_p),
							"top rightpage" );
					break;
				}
				break;
			case C_TOP2:
				switch ((yyvsp[0].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->top2_p),
							"top2" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->lefttop2_p),
							"top2 leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->righttop2_p),
							"top2 rightpage" );
					break;
				}
				break;
			case C_BOT:
				switch ((yyvsp[0].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->bot_p),
							"bot" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->leftbot_p),
							"bot leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->rightbot_p),
							"bot rightpage" );
					break;
				}
				break;
			case C_BOT2:
				switch ((yyvsp[0].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->bot2_p),
							"bot2" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->leftbot2_p),
							"bot2 leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->rightbot2_p),
							"bot2 rightpage" );
					break;
				}
				break;
			case C_BLOCK:
				if (Doing_samescore == YES) {
					l_yyerror(Curr_filename, yylineno,
						"cannot have a block inside a samescore zone");
				}
				insertMAINLL(newMAINLLstruct(S_BLOCKHEAD, yylineno),
						Mainlltc_p);
				Mainlltc_p->u.blockhead_p = Currblock_p;
				Currblock_p->samepage = Doing_samepage;
				if ((yyvsp[0].intval) != PGSIDE_NOT_SET) {
					l_warning(Curr_filename, yylineno,
						"leftpage/rightpage cannot be used on blocks; ignoring");
				}
				/* These blocks count like "music" for purposes
				 * of things that can only be set
				 * before any "music"
				 */
				Got_some_data = YES;
				break;
			case C_HEADER:
			case C_HEAD2:
			case C_FOOTER:
			case C_FOOT2:
				/* These are static, not in main list,
				 * so nothing needs to be done with them.
				 */
				break;
			default:
				pfatal("unexpected context (0x%x) for block", Context);
				/*NOTREACHED*/
				break;
			}

			/* We need a feed after a block.
			 * Use -1 as lineno to mark it as internally generated.
			 * That way if user puts their own explicit feed
			 * next in the input, we can know we can
			 * discard this internally generated one.
			 */
			if (Context & C_BLOCK) {
				insertMAINLL(newMAINLLstruct(S_FEED, -1), Mainlltc_p);
			}
		}
	}
#line 3284 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 1050 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Context = C_MUSIC;
	}
#line 3292 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 1055 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_prev_context();
		Context = C_GRIDS;
	}
#line 3301 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 1061 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 3308 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 1065 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_prev_context();
		Context = C_ACCIDENTALS;
	}
#line 3317 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 1071 "src/mup/gram.y" /* yacc.c:1646  */
    {
		struct ACCIDENTALS *acc_name_map_p;

		/* Make sure not already in list */
		for (acc_name_map_p = Acc_contexts_list_p; acc_name_map_p != 0;
					acc_name_map_p = acc_name_map_p->next) {
			if (strcmp(acc_name_map_p->name, (yyvsp[0].stringval)) == 0) {
				l_warning(Curr_filename, yylineno,
				"accidental context name %s re-defined; using last", (yyvsp[0].stringval));
				/* We'll free the table, since that is
				 * potentially big, and is easy to do.
				 * We'll leave the ACCIDENTALS struct itself,
				 * because it doesn't seem worth the trouble
				 * to keep track of the "prev" to free up a
				 * little memory in a rare error case.
				 * And we'll leave the name, so future loops
				 * though the list can strcmp it, even though
				 * it will never really be used. We will put
				 * the replacement at the head of the list,
				 * so we'll always see that copy first and
				 * never bother to come down to this one.
				 */
				if (acc_name_map_p->info != 0) {
					FREE(acc_name_map_p->info);
					acc_name_map_p->info = 0;
					acc_name_map_p->size = 0;
				}
				/* If redefined multiple times, don't
				 * bother giving multiple errors. */
				break;
			}
		}

		MALLOC(ACCIDENTALS, acc_name_map_p, 1);
		acc_name_map_p->name = strdup((yyvsp[0].stringval) + 2);
		MALLOC(ACCINFO, acc_name_map_p->info, ITEMS);
		acc_name_map_p->size = 0;
		acc_name_map_p->next = Acc_contexts_list_p;
		Acc_contexts_list_p = acc_name_map_p;
	}
#line 3362 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 1113 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Context != C_ACCIDENTALS) {
			yyerror("something like looks like an accidentals entry when not in accidentals context");
		}
	}
#line 3372 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 1121 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Context == C_ACCIDENTALS) {
			new_acc_entry((yyvsp[0].stringval) + 2);
		}
	}
#line 3382 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 1129 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* A single value to use for all notes a-g */
		int i;
		for (i = 0; i < 7; i++) {
			add_acc_offset('a' + i, (yyvsp[0].floatval));
		}
	}
#line 3394 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 1143 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc_offset((yyvsp[-1].intval), (yyvsp[0].floatval));
	}
#line 3402 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 1149 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc_offset((yyvsp[-1].intval), (yyvsp[0].floatval));
	}
#line 3410 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 1155 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (float) cents2value( (double) ((yyvsp[-2].intval) * (yyvsp[-1].floatval)));
	}
#line 3418 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 1161 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (yyvsp[0].floatval);
	}
#line 3426 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 1167 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].floatval) == 0.0) {
			yyerror("denominator cannot be zero");
		}
		else {
			(yyval.floatval) = (yyvsp[-2].floatval) / (yyvsp[0].floatval);
		}
	}
#line 3439 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 1177 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_prev_context();
		Context = C_KEYMAP;
		new_keymap((yyvsp[0].stringval) + 2);
	}
#line 3449 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 1186 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_prev_context();
		Context = C_CONTROL;
		Saw_restoreparms = NO;
		Prev_control_parms = SR_SAVE;	/* really means "not restore"
						 * but didn't seem worth
						 * having separate state
						 * for that. */

	}
#line 3464 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 1199 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_CONTROL, "saveparms") == YES) {
			/* Associate the user's name with the current place
			 * in the main list */
			add_saveparms((yyvsp[0].stringval) + 2);
			if (Prev_control_parms != SR_WARN) {
				Prev_control_parms = SR_SAVE;
			}
		}
	}
#line 3479 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 1212 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_CONTROL, "restoreparms") == YES) {
			if (do_restoreparms((yyvsp[0].stringval) + 2) == YES) {
				if (Saw_restoreparms == YES) {
					if (Prev_control_parms == SR_RESTORE) {
						l_warning(Curr_filename, yylineno,
						"consecutive instances of 'restoreparms' in the same control context; only the last is effective");
					}
					else if (Prev_control_parms != SR_WARN) {
						l_warning(Curr_filename, yylineno,
						"multiple instances of 'restorparms is of dubious usefulness");
					}
					Prev_control_parms = SR_WARN;
				}
				if (Prev_control_parms != SR_WARN) {
					Prev_control_parms = SR_RESTORE;
				}
			}
		}
	}
#line 3504 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 1235 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Context == C_GRIDS) {
			add_grid((yyvsp[-2].stringval), (yyvsp[-1].stringval));
		}
		else if (Context == C_HEADSHAPES) {
			/* skip past the font/size bytes */
			add_shape((yyvsp[-2].stringval) + 2, (yyvsp[-1].stringval) + 2);
		}
		else if (Context == C_SHAPES) {
			add_shape_map_entry((yyvsp[-2].stringval) + 2, (yyvsp[-1].stringval) + 2);
		}
		else if (Context == C_KEYMAP) {
			add_to_keymap((yyvsp[-2].stringval), (yyvsp[-1].stringval));
		}
		else {
			l_warning(Curr_filename, yylineno - 1,
				"unexpected pair of text strings (possibly intended to be in grids, headshapes, shapes, or keymap context, or missing + for concatenation?)");
		}
	}
#line 3528 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 1257 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_prev_context();
		Context = C_HEADSHAPES;
	}
#line 3537 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 1265 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_prev_context();
		Context = C_SHAPES;
		init_new_shape_map((yyvsp[0].stringval) + 2);
	}
#line 3547 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 1274 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_prev_context();
		Context = C_SYMBOL;
		/* The +2 to skip font/size */
		Curr_usym_p = alloc_usym((yyvsp[0].stringval) + 2);
	}
#line 3558 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 1286 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
		/* later on we check for being within current range */
	}
#line 3567 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 1292 "src/mup/gram.y" /* yacc.c:1646  */
    {
		errno = 0;
		(yyval.intval) = strtol(yytext, 0, 10);
		if (errno == ERANGE) {
			l_yyerror(Curr_filename, yylineno,
				"Number %s is beyond the range of numbers that can be handled", yytext);
		}
	}
#line 3580 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 1302 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[-1].intval) * (yyvsp[0].intval);
	}
#line 3588 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 1317 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Only a few things are allowed to have a negative number.
		 * Other code assumes that that restriction is enforced here,
		 * so we only honor the minus if it is legal. */
		if ((yyvsp[-1].intval) == -1) {
			if ((yyvsp[-3].intval) != SYLPOSITION) {
				yyerror("negative value not allowed");
			}
			else {
				assign_int((yyvsp[-3].intval), -((yyvsp[0].intval)), Currstruct_p);
			}
		}
		else {
			assign_int((yyvsp[-3].intval), (yyvsp[0].intval), Currstruct_p);
		}
	}
#line 3609 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 1336 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only restcombine and gridfret can be set to empty */
		if ((yyvsp[-1].intval) == RESTCOMBINE) {
			assign_int((yyvsp[-1].intval), NORESTCOMBINE, Currstruct_p);
		}
		else if ((yyvsp[-1].intval) == GRIDFRET) {
			assign_int((yyvsp[-1].intval), NOGRIDFRET, Currstruct_p);
		}
		else {
			yyerror("parameter value required");
		}
	}
#line 3626 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 1351 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_firstpage((yyvsp[-1].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3634 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1357 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].intval) == -1) {
			if ((yyvsp[-3].intval) != STAFFPAD) {
				yyerror("negative value not allowed");
			}
			else {
				assign_float((yyvsp[-3].intval), -((yyvsp[0].floatval)), Currstruct_p);
			}
		}
		else {
			assign_float((yyvsp[-3].intval), (yyvsp[0].floatval), Currstruct_p);
		}
	}
#line 3652 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1373 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_2floats((yyvsp[-4].intval), (yyvsp[-2].floatval), (yyvsp[0].floatval), Currstruct_p);
	}
#line 3660 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1379 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_float((yyvsp[-3].intval), (yyvsp[-1].floatval), Currstruct_p);
	}
#line 3668 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1385 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_direction((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3676 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1391 "src/mup/gram.y" /* yacc.c:1646  */
    {
		double multiplier;
		multiplier = (Score.units == INCHES ? 1.0 : CMPERINCH);
		assign_float(PAGEWIDTH, pagesztbl[(yyvsp[-1].intval)][(yyvsp[0].intval)] * multiplier, Currstruct_p);
		assign_float(PAGEHEIGHT, pagesztbl[(yyvsp[-1].intval)][(yyvsp[0].intval) ^ 1] * multiplier, Currstruct_p);
	}
#line 3687 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1400 "src/mup/gram.y" /* yacc.c:1646  */
    { }
#line 3693 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 1404 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* specified in stepsizes, stored in inches */
		assign_float(PAD, (yyvsp[-1].intval) * (yyvsp[0].floatval) * STEPSIZE, Currstruct_p);
	}
#line 3702 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1411 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_vscheme ((yyvsp[-1].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3710 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1417 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_beamlist(Currstruct_p);
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			Currstruct_p->u.ssv_p->beamrests = ((yyvsp[0].intval) & 0x1);
			Currstruct_p->u.ssv_p->beamspaces = (((yyvsp[0].intval) >> 1) & 0x1);
		}
	}
#line 3722 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1427 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_staffset((yyvsp[-3].intval), Currstruct_p);
	}
#line 3730 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1433 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_barstlist(Currstruct_p, 0);
	}
#line 3738 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1439 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Put them in time order */
		if (Currstruct_p != 0) {
			qsort((char *)(Currstruct_p->u.ssv_p->subbarlist),
				Currstruct_p->u.ssv_p->nsubbar,
				sizeof(struct SUBBAR_INSTANCE),
				comp_subbar);
		}
	}
#line 3752 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1451 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_SCORE|C_STAFF, "repeatdots") == YES
					&& Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->repeatdots = (yyvsp[0].intval);
			Currstruct_p->u.ssv_p->used[REPEATDOTS] = YES;
		}
	}
#line 3764 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1461 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			chk_order(Currstruct_p->u.ssv_p, Order_place);
		}
	}
#line 3774 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1472 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_int((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3782 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1478 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* all the work for this is done in timesig */
	}
#line 3790 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1487 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_SCORE|C_STAFF|C_VOICE, "defaultphraseside") == YES
					&& Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->defaultphraseside = (yyvsp[0].intval);
			Currstruct_p->u.ssv_p->used[DEFAULTPHRASESIDE] = YES;
		}
	}
#line 3802 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1497 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 3809 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1502 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_font((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3817 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1508 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_font((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3825 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1514 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_SCORE|C_STAFF,"clef parameter") == YES) {
			used_check(Currstruct_p, CLEF, "clef");
			if (Context == C_STAFF && has_tab_staff()) {
				/* We used to be able to make this just a
				 * warning, but now that is hard, because
				 * we'd want to let it assign for any
				 * non-tab, but it is hard to know at this
				 * point which SSVs will be tab and which					 * non-tab, because we may not have created
				 * them all yet. We cannot let the tab ones
				 * get assigned, because later code would
				 * get confused by clef not being TABCLEF.
				 * While we could figure this all out with
				 * enough code, it really is a user error,
				 * so not worth bending over backwards
				 * to try to keep it just a warning.
				 */
				l_yyerror(Curr_filename, yylineno,
					"can't set clef on tab staff");
			}
			if (Currstruct_p != 0) {
				Currstruct_p->u.ssv_p->clef = (yyvsp[-1].intval);
				Currstruct_p->u.ssv_p->forceprintclef = (yyvsp[0].intval);
				Currstruct_p->u.ssv_p->used[CLEF] = YES;
				asgnssv(Currstruct_p->u.ssv_p);
			}
		}
	}
#line 3858 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1545 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_SCORE | C_STAFF, "chordtranslation parameter") == YES
						&& (Currstruct_p != 0) ) {
			if (Currstruct_p->u.ssv_p->used[(yyvsp[-2].intval)] == YES) {
				warning("setting chordtranslation parameter overrides previous setting");
			}
			Currstruct_p->u.ssv_p->chordtranslation = (yyvsp[0].intval);
			Currstruct_p->u.ssv_p->used[CHORDTRANSLATION] = YES;
		}
	}
#line 3873 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1558 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_int((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3881 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1564 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_int((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3889 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1573 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_int((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3897 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1579 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_STAFF|C_VOICE, "unset") == YES
					&& Currstruct_p != 0) {
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) >= NUMFLDS) {
				pfatal("invalid parameter index %d on line %d", (yyvsp[0].intval), yylineno);
			}
			if (Currstruct_p->u.ssv_p->used[(yyvsp[0].intval)] == YES) {
				warning("unsetting parameter overrides previous setting");
			}
			/* Note that if user tries to unset something that
			 * can't be set in the current context, we silently
			 * ignore that. We figure that since it's already unset,
			 * it doesn't hurt anything to unset it again,
			 * and it's easier to not bother to check.
			 */

			Currstruct_p->u.ssv_p->used[(yyvsp[0].intval)] = UNSET;

			/* special case: scoresep controls two fields */
			if ((yyvsp[0].intval) == MINSCSEP) {
				Currstruct_p->u.ssv_p->used[MAXSCSEP] = UNSET;
			}

			/* Assign, just in case there are new interactions */
			asgnssv(Currstruct_p->u.ssv_p);
		}
	}
#line 3929 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1608 "src/mup/gram.y" /* yacc.c:1646  */
    { Doing_timeunit = YES; }
#line 3935 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1609 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ( contextcheck(C_SSV, "timeunit parameter") == YES ) {
			used_check(Currstruct_p, TIMEUNIT, "timeunit");
			if (Currstruct_p != 0) {
				Currstruct_p->u.ssv_p->timeunit = (yyvsp[0].ratval);
				Currstruct_p->u.ssv_p->timelist_p = Extra_time_p;
				Currstruct_p->u.ssv_p->used[TIMEUNIT] = YES;
			}
			Extra_time_p = 0;
			Doing_timeunit = NO;
		}
	}
#line 3952 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1624 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ( contextcheck(C_SSV, "swingunit parameter") == YES ) {
			used_check(Currstruct_p, SWINGUNIT, "swingunit");
			if (Currstruct_p != 0) {
				Currstruct_p->u.ssv_p->swingunit = (yyvsp[0].ratval);
				Currstruct_p->u.ssv_p->used[SWINGUNIT] = YES;
			}
		}
	}
#line 3966 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1636 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 3973 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1641 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 3980 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1646 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ( contextcheck(C_SCORE, "endingstyle parameter") == YES
					&& Currstruct_p != 0 ) {
			used_check(Currstruct_p, ENDINGSTYLE, "endingstyle");
			Currstruct_p->u.ssv_p->endingstyle = (yyvsp[0].intval);
			Currstruct_p->u.ssv_p->used[ENDINGSTYLE] = YES;
		}
	}
#line 3993 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1657 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			if ((yyvsp[-2].intval) == REHSTYLE) {
				if (contextcheck(C_SCORE | C_STAFF, "rehstyle parameter") == YES ) {
					used_check(Currstruct_p, REHSTYLE, "rehstyle");
					Currstruct_p->u.ssv_p->rehstyle = (yyvsp[0].intval);
					Currstruct_p->u.ssv_p->used[REHSTYLE] = YES;
				}
			}
			else if ((yyvsp[-2].intval) == MEASNUMSTYLE) {
				if (contextcheck(C_SCORE, "measnumstyle parameter") == YES) {
					used_check(Currstruct_p, MEASNUMSTYLE, "measnumstyle");
					Currstruct_p->u.ssv_p->measnumstyle = (yyvsp[0].intval);
					Currstruct_p->u.ssv_p->used[MEASNUMSTYLE] = YES;
				}
			}
		}
	}
#line 4016 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1678 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_SCORE | C_STAFF, "pedstyle parameter") == YES
					&& Currstruct_p != 0) {
			used_check(Currstruct_p, PEDSTYLE, "pedstyle");
			Currstruct_p->u.ssv_p->pedstyle = (yyvsp[0].intval);
			Currstruct_p->u.ssv_p->used[PEDSTYLE] = YES;
			/* Since Ped_stop is a predefined string that
			 * doesn't go through fix_string(), we wouldn't
			 * realize that font ZD1 was used until printing
			 * phase after we ought to have emitted the
			 * encoding vector code, which is too late,
			 * so mark it here. If the user sets the
			 * parameter to pedstar but then never actually uses
			 * a star, this will just cause a few extraenous
			 * but otherwise harmless lines of output. It is
			 * less important the ZI gets marked as used,
			 * since we don't change its encoding vector,
			 * so don't need to emit special code, but might as
			 * well mark that here as well. */
			if ((yyvsp[0].intval) != P_LINE) {
				Fontinfo[font_index(FONT_ZD1)].was_used = YES;
				Fontinfo[font_index(FONT_ZI)].was_used = YES;
			}
		}
	}
#line 4046 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1706 "src/mup/gram.y" /* yacc.c:1646  */
    {
		char *trans_name;
		trans_name = ((yyvsp[-5].intval) == TRANSPOSITION ?
			"transpose" : "addtranspose");
		if (contextcheck(C_SCORE|C_STAFF, trans_name) == YES) {
			if (Context == C_STAFF && has_tab_staff() == YES) {
				l_warning(Curr_filename, yylineno,
					"%s not allowed on tablature staff; ignoring",
					trans_name);
			}
			chk_interval((yyvsp[-2].intval), (yyvsp[-1].intval));
			if (Currstruct_p != 0) {
				used_check(Currstruct_p, (yyvsp[-5].intval), trans_name);
				if ((yyvsp[-5].intval) == TRANSPOSITION) {
					Currstruct_p->u.ssv_p->inttype = (yyvsp[-2].intval);
					Currstruct_p->u.ssv_p->intnum = (yyvsp[-3].intval) * (yyvsp[-1].intval);
					Currstruct_p->u.ssv_p->trans_usage = (yyvsp[0].intval);
				}
				else {
					Currstruct_p->u.ssv_p->addinttype = (yyvsp[-2].intval);
					Currstruct_p->u.ssv_p->addintnum = (yyvsp[-3].intval) * (yyvsp[-1].intval);
					Currstruct_p->u.ssv_p->addtrans_usage = (yyvsp[0].intval);
				}
				Currstruct_p->u.ssv_p->used[(yyvsp[-5].intval)] = YES;
				asgnssv(Currstruct_p->u.ssv_p);
			}
		}
	}
#line 4079 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1737 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_int(CUE, (yyvsp[0].intval), Currstruct_p);
	}
#line 4087 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1743 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_unit((yyvsp[0].intval), Currstruct_p);
	}
#line 4095 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1749 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_string((yyvsp[-2].intval), (yyvsp[0].stringval), Currstruct_p);
	}
#line 4103 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1755 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_string((yyvsp[-2].intval), (yyvsp[0].stringval), Currstruct_p);
	}
#line 4111 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1761 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_string((yyvsp[-2].intval), (yyvsp[0].stringval), Currstruct_p);
	}
#line 4119 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1767 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_SCORE, "tuning") == YES
				&& Currstruct_p != 0) {
			used_check(Currstruct_p, TUNING, "tuning");
			Currstruct_p->u.ssv_p->used[TUNING] = YES;
			Currstruct_p->u.ssv_p->tuning = (yyvsp[0].intval);
			Tuning_used = YES;
		}
	}
#line 4133 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1779 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_keymap((yyvsp[-2].intval), (yyvsp[0].stringval), Currstruct_p);
	}
#line 4141 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1785 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_usym_p == 0) {
			l_yyerror(Curr_filename, yylineno,
				"postscript= only valid in symbol context; maybe you meant without '=' ?");
		}
		else {
			if (Curr_usym_p->flags & US_POSTSCRIPT) {
				l_warning(Curr_filename, yylineno,
					"Multiple postscript definitions given for symbol '%s'; using last",
					Curr_usym_p->name);
				FREE(Curr_usym_p->postscript);
			}
			Curr_usym_p->postscript = (yyvsp[0].stringval);
			Curr_usym_p->flags |= US_POSTSCRIPT;
		}
	}
#line 4162 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1804 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_usym_p == 0) {
			l_yyerror(Curr_filename, yylineno,
				"bbox= only valid in symbol context");
		}
		else {
			if (Curr_usym_p->flags & US_BBOX) {
				l_warning(Curr_filename, yylineno,
					"Multiple bbox definitions given for symbol %s; using last",
					Curr_usym_p->name);
			}
			Curr_usym_p->llx = (yyvsp[-6].intval);
			Curr_usym_p->lly = (yyvsp[-4].intval);
			Curr_usym_p->urx = (yyvsp[-2].intval);
			Curr_usym_p->ury = (yyvsp[0].intval);
			Curr_usym_p->flags |= US_BBOX;
		}
	}
#line 4185 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1825 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_usym_p == 0) {
			l_yyerror(Curr_filename, yylineno,
				"stemoffset= only valid in symbol context");
		}
		else {
			if (Curr_usym_p->flags & US_STEMOFFSET) {
				l_warning(Curr_filename, yylineno,
					"Multiple stemoffset definitions given for %s; last used",
					Curr_usym_p->name);
			}
			Curr_usym_p->upstem_y = (yyvsp[-2].intval);
			Curr_usym_p->downstem_y = (yyvsp[0].intval);
			Curr_usym_p->flags |= US_STEMOFFSET;
		}
	}
#line 4206 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1845 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* whereused is not allowed on voice, just score and staff */
		if (contextcheck(C_SCORE|C_STAFF, "visible=whereused") == YES) {
			assign_int(VISIBLE, YES, Currstruct_p);
			if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
				Currstruct_p->u.ssv_p->hidesilent = YES;
			}
		}
	}
#line 4220 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1857 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid letter is y */
		if (*yytext != 'y') {
			yyerror("visible value must be y, n, or whereused");
		}
		else if (contextcheck(C_SSV, "visible parameter")
								== YES) {
			assign_int(VISIBLE, YES, Currstruct_p);
			if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
				Currstruct_p->u.ssv_p->hidesilent = NO;
			}
		}
	}
#line 4238 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1873 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_SSV, "visible parameter") == YES) {
			assign_int(VISIBLE, NO, Currstruct_p);
			if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
				Currstruct_p->u.ssv_p->hidesilent = NO;
			}
		}
	}
#line 4251 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1883 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = PGSIDE_NOT_SET;
	}
#line 4259 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1889 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 4267 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1894 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
	}
#line 4275 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1900 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid letter is y */
		if (*yytext == 'y') {
			(yyval.intval) = YES;
		}
		else {
			/* Our yyerror will end up making this into a
			 * nice error message that gives the offending token */
			yyerror("syntax error");
			(yyval.intval) = NO;
		}
	}
#line 4292 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1915 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid letter is y */
		if (*yytext != 'y') {
			yyerror("measnum value must be y, n, or every N");
			(yyval.intval) = MN_NONE;
		}
		else {
			(yyval.intval) = MN_SCORE;
		}
	}
#line 4307 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1928 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MN_NONE;
	}
#line 4315 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1934 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) < MINEVERYMEASNUM || (yyvsp[0].intval) > MAXEVERYMEASNUM) {
			/* We have to do range check here rather than let
			 * assign_int() do it, because internally we use
			 * additional values, and it would be confusing to
			 * the user to include those internal values in the
			 * valid range. */
			l_yyerror(Curr_filename, yylineno,
				"for measnum=every N, N must be between %d and %d",
				MINEVERYMEASNUM, MAXEVERYMEASNUM);
			(yyval.intval) = MN_NONE;
		}
		else {
			(yyval.intval) = (yyvsp[0].intval);
		}
	}
#line 4336 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1953 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* none specified */
		(yyval.intval) = V_1;
	}
#line 4345 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1960 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid value here is 'f'  */
		if (*yytext == 'f') {
			(yyval.intval) = V_2FREESTEM;
		}
		else {
			yyerror("invalid voice qualifier: must be f or o");
			(yyval.intval) = V_1;
		}
	}
#line 4360 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1973 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid value here is 'o' */
		if (*yytext == 'o') {
			(yyval.intval) = V_2OPSTEM;
		}
		else {
			yyerror("invalid voice qualifier: must be f or o");
			(yyval.intval) = (int) V_1;
		}
	}
#line 4375 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1985 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* NULL token for allocating a new beamlist */
		new_beamlist();
	}
#line 4384 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1999 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_beamlist((yyvsp[0].ratval));
	}
#line 4392 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 2008 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_beamlist((yyvsp[0].ratval));
	}
#line 4400 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 2017 "src/mup/gram.y" /* yacc.c:1646  */
    { begin_subbeam(); }
#line 4406 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 2018 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_subbeam();
	}
#line 4414 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 2023 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.ratval) = calcfulltime((yyvsp[-3].ratval), (yyvsp[-2].intval));

		/* If filling in a GRPSYL struct,
		 * need to fill in dots and basictime.
		 * Could also be here due to beamstyle
		 * or timeunit or location time offset,
		 * in which case the Curr_grpsyl_p will be NULL,
		 * or while getting tuplet duration. */
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
						&& Getting_tup_dur == NO) {
			Curr_grpsyl_p->dots = (yyvsp[-2].intval);
			Curr_grpsyl_p->basictime = reconstruct_basictime((yyval.ratval));
		}
		else {
			struct TIMELIST *timelist_p;	/* walk thru list */
			struct TIMELIST *next_p;/* save next to delete curr */
			RATIONAL totaltime;	/* sum of extra times */

			/* Start with first time value (which was calculated
			 * above and is now in $$), then add on the added
			 * times, if any. */
			totaltime = (yyval.ratval);
			for (timelist_p = Extra_time_p; timelist_p != 0;
						timelist_p = next_p) {
				next_p = timelist_p->next;
				totaltime = radd(totaltime, timelist_p->fulltime);
				if (Doing_timeunit == NO) {
					/* For things like swingunit
					 * or tuplet time, we just need the
					 * resulting time, not the individual
					 * time units and arithmetic. */
					FREE(timelist_p);
				}
			}
			if (Extra_time_p != 0 && LE(totaltime, Zero)) {
				yyerror("Time values must add up to more than zero");
			}
			/* Current timelist is finished; can't append any
			 * more items to it. */
			Curr_timelist_p = 0;
			if (Doing_timeunit == YES) {
				/* For timeunit, we return the initial
				 * timeunit, but also preserve
				 * Extra_time_p for putting in SSV.
				 */
				(yyval.ratval) = calcfulltime((yyvsp[-3].ratval), (yyvsp[-2].intval));
			}
			else {
				/* the list has been freed above */
				Extra_time_p = 0;
				(yyval.ratval) = totaltime;
			}
		}
	}
#line 4474 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 2081 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.ratval).n = (svpath(1, TIME))->time.n;
		(yyval.ratval).d = (svpath(1, TIME))->time.d;
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			/* use whole note symbol as default */
			Curr_grpsyl_p->basictime = 1;
			Curr_grpsyl_p->is_meas = YES;
			Meas_rpt_type = (yyvsp[-1].intval);
			User_meas_time = NO;
		}
		else {
			yyerror("'m' is not valid here");
		}
	}
#line 4494 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 2099 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.ratval) = Zero;
	}
#line 4502 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 2109 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
	}
#line 4510 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 2115 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (YES | (YES << 1));
	}
#line 4518 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 2121 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = ((YES << 1) | YES);
	}
#line 4526 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 2127 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (YES << 1);
	}
#line 4534 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 2133 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = YES;
	}
#line 4542 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 2138 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* null token for the purpose of allocating a new rangelist
		 * to be filled in with user data */
		new_staffset();
	}
#line 4552 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 2159 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save information about this range in the list */
		/* if only a single number, not a range, rangetail will be
		 * 0, so use num as both beginning and end of range */
		add_staffset( (yyvsp[-2].intval), ((yyvsp[-1].intval) > 0 ? (yyvsp[-1].intval) : (yyvsp[-2].intval)), String1, String2);
	}
#line 4563 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 2167 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no end of range, so return 0 as flag that there was only 1 number */
		(yyval.intval) = 0;
	}
#line 4572 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 2174 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* make sure isn't 0, because that it illegal and would be used
		 * later as though there were no range. Other error checking
		 * on this number will be done later. */
		if ((yyvsp[0].intval) == 0) {
			yyerror("second number of range may not be zero");
		}
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 4586 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 2185 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no labels */
		String1 = String2 = (char *) 0;
	}
#line 4595 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 2192 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save label */
		String1 = (yyvsp[-2].stringval);
	}
#line 4604 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 2198 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no second label */
		String2 = (char *) 0;
	}
#line 4613 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 2205 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save label2 for later use */
		String2 = (yyvsp[0].stringval);
	}
#line 4622 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 2214 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* NULL token for allocating space for a bar style list */
		new_barstlist();
		Bar_between = NO;
	}
#line 4632 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 2234 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_barst(1, MAXSTAFFS, Bar_between, YES);
	}
#line 4640 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 2240 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 4647 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 2249 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) != PL_BETWEEN) {
			yyerror("barstyle range place can only be between");
		}
		else {
			Bar_between = YES;
		}
	}
#line 4660 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 2261 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* if only 1 number, not range, rangetail will be 0, so use
		 * same number for beginning and end */
		add_barst((yyvsp[-1].intval), ((yyvsp[0].intval) == 0 ? (yyvsp[-1].intval) : (yyvsp[0].intval)), Bar_between, NO);
	}
#line 4670 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 2268 "src/mup/gram.y" /* yacc.c:1646  */
    {
		used_check(Currstruct_p, SUBBARSTYLE, "subbarstyle");
		Bar_between = NO;
	}
#line 4679 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 2274 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_barstlist(Currstruct_p, Subbar_app_p);
	}
#line 4687 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 2280 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_barstlist(Currstruct_p, Subbar_app_p);
	}
#line 4695 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 2285 "src/mup/gram.y" /* yacc.c:1646  */
    {
		MALLOC(SUBBAR_APPEARANCE, Subbar_app_p, 1);
	}
#line 4703 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 2290 "src/mup/gram.y" /* yacc.c:1646  */
    {
		new_barstlist();
	}
#line 4711 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 2296 "src/mup/gram.y" /* yacc.c:1646  */
    {
		switch ((yyvsp[0].intval)) {
		case L_NORMAL:
		case L_DASHED:
		case L_DOTTED:
			break;
		default:
			l_yyerror(Curr_filename, yylineno,
				"subbar linetype, if specified, can only be dashed or dotted");
			break;
		}

		Subbar_app_p->linetype = (yyvsp[0].intval);
	}
#line 4730 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 2313 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) != SINGLEBAR && (yyvsp[0].intval) != DOUBLEBAR) {
			l_yyerror(Curr_filename, yylineno,
				"subbar type can only be bar or dblbar");
		}
		Subbar_app_p->bartype = (yyvsp[0].intval);
	}
#line 4742 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 2322 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Subbar_app_p->upper_ref_line = LR_TOP;
		Subbar_app_p->upper_offset = 0.0;
		Subbar_app_p->lower_ref_line = LR_BOTTOM;
		Subbar_app_p->lower_offset = 0.0;
	}
#line 4753 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 2334 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Subbar_app_p->upper_ref_line = (yyvsp[-5].intval);
		Subbar_app_p->upper_offset = (yyvsp[-4].floatval);
		Subbar_app_p->lower_ref_line = (yyvsp[-2].intval);
		Subbar_app_p->lower_offset = (yyvsp[-1].floatval);
	}
#line 4764 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 2343 "src/mup/gram.y" /* yacc.c:1646  */
    {
		switch ((yyvsp[0].intval)) {
		case C_TOP:
			(yyval.intval) = LR_TOP;
			break;
		case C_BOT:
			(yyval.intval) = LR_BOTTOM;
			break;
		default:
			/* our yyerror will turn this into more helpful msg */
			yyerror("syntax error");
			/* return some valid value */
			(yyval.intval) = LR_MIDDLE;
			break;
		}
	}
#line 4785 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 2362 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = LR_MIDDLE;
	}
#line 4793 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 2367 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = 0.0;
	}
#line 4801 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 2373 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (yyvsp[-1].intval) * (yyvsp[0].floatval);
	}
#line 4809 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 2385 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_barst(1, MAXSTAFFS, Bar_between, YES);
	}
#line 4817 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 2398 "src/mup/gram.y" /* yacc.c:1646  */
    {
		struct SSV *ssv_p;
		int n;		/* to loop for checking for duplicates */

		if (Currstruct_p != 0) {
			ssv_p = Currstruct_p->u.ssv_p;
			if (ssv_p->nsubbar == 0) {
				MALLOC(SUBBAR_INSTANCE, ssv_p->subbarlist, 1);
			}
			else {
				REALLOC(SUBBAR_INSTANCE, ssv_p->subbarlist,
							ssv_p->nsubbar+1);
			}

			if ((yyvsp[0].floatval) <= 1.0 || (yyvsp[0].floatval) >= (double) Score.timenum + 1.0) {
				l_yyerror(Curr_filename, yylineno,
					"subbar time must be greater than 1.0 and less than %.3f",
							Score.timenum + 1.0);
			}
			for (n = 0; n < ssv_p->nsubbar; n++) {
				if (ssv_p->subbarlist[n].count == (yyvsp[0].floatval)) {
					l_warning(Curr_filename, yylineno,
						"time %f specified more than once for same subbar instance", (yyvsp[0].floatval));
				}
			}
			ssv_p->subbarlist[ssv_p->nsubbar].count = (yyvsp[0].floatval);
			ssv_p->subbarlist[ssv_p->nsubbar].appearance_p = Subbar_app_p;
			(ssv_p->nsubbar)++;
		}
	}
#line 4852 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 2431 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = RD_ALL;
	}
#line 4860 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 2437 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = RD_STANDARD;
	}
#line 4868 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 2442 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Order_place = (yyvsp[0].intval);
		Order_prio = 1;
		if (Currstruct_p != 0) {
			switch ((yyvsp[0].intval)) {
			case PL_ABOVE:
				Currstruct_p->u.ssv_p->used[ABOVEORDER] = YES;
				break;
			case PL_BELOW:
				Currstruct_p->u.ssv_p->used[BELOWORDER] = YES;
				break;
			case PL_BETWEEN:
				Currstruct_p->u.ssv_p->used[BETWEENORDER] = YES;
				break;
			}
		}
	}
#line 4890 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 2462 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[0].intval)] = Order_prio;
		}
	}
#line 4900 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 2470 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[0].intval)] = ++Order_prio;
		}
	}
#line 4910 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 2478 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[0].intval)] = Order_prio;
		}
	}
#line 4920 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 2485 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[0].intval)] != 0) {
				l_yyerror(Curr_filename, yylineno,
					"order item %s specified more than once", (yyvsp[0].intval));
			}
		}
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 4934 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 2497 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MK_MUSSYM;
	}
#line 4942 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 2503 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MK_OCTAVE;
	}
#line 4950 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 2509 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MK_OTHERTEXT;
	}
#line 4958 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 2515 "src/mup/gram.y" /* yacc.c:1646  */
    {
		switch ((yyvsp[0].intval)) {
		case TM_CHORD:
			(yyval.intval) = MK_CHORD;
			break;
		case TM_DYN:
			(yyval.intval) = MK_DYN;
			break;
		default:
			yyerror("invalid text modifier in order list");
			/* set to something valid, since $$ will be used
			 * as an array subscript. */
			(yyval.intval) = MK_CHORD;
			break;
		}
	}
#line 4979 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 2534 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MK_LYRICS;
	}
#line 4987 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 2540 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MK_ENDING;
	}
#line 4995 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 2546 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MK_REHEARSAL;
	}
#line 5003 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 2552 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MK_PEDAL;
	}
#line 5011 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 2558 "src/mup/gram.y" /* yacc.c:1646  */
    {
		tsig_item(TSR_END);
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			MALLOCA(char, Currstruct_p->u.ssv_p->timerep, Tsig_offset);
			strcpy(Currstruct_p->u.ssv_p->timerep, Timerep);
			assign_timesig(Currstruct_p, (yyvsp[0].intval), &Next_alt_timesig);
			Tsig_visibility = (yyvsp[0].intval);
			/* If there are alternating time signatures,
			 * need to save pointer to this list */
			if (Next_alt_timesig != 0) {
				Alt_timesig_list = Currstruct_p->u.ssv_p->timerep;
			}
			else {
				Alt_timesig_list = 0;
			}
		}
		/* Reset for next time signature usage, if any */
		Tsig_offset = 0;
	}
#line 5035 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 2582 "src/mup/gram.y" /* yacc.c:1646  */
    { tsig_item(TSR_ALTERNATING); }
#line 5041 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 2583 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* this is for alternating time signature */
	}
#line 5049 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 2589 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 5056 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 2593 "src/mup/gram.y" /* yacc.c:1646  */
    { tsig_item(TSR_ADD); }
#line 5062 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 2594 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* This would be for things like 2/4 + 3/8 */
	}
#line 5070 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 2600 "src/mup/gram.y" /* yacc.c:1646  */
    {
		tsig_item(TSR_CUT);
	}
#line 5078 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 2606 "src/mup/gram.y" /* yacc.c:1646  */
    {
		tsig_item(TSR_COMMON);
	}
#line 5086 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 2612 "src/mup/gram.y" /* yacc.c:1646  */
    {
		tsig_item(TSR_SLASH);
		if ((yyvsp[0].intval) < MINDENOMINATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature denominator cannot be less than %d",
				MINDENOMINATOR);
			(yyvsp[0].intval) = MINDENOMINATOR;
		}
		else if ((yyvsp[0].intval) > MAXDENOMINATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature denominator cannot be greater than %d",
				MAXDENOMINATOR);
			(yyvsp[0].intval) = MAXDENOMINATOR;
		}
		else if (power_of2check((yyvsp[0].intval), "time signature denominator") == NO) {
			(yyvsp[0].intval) = 1 << drmo((yyvsp[0].intval));
		}

		tsig_item((yyvsp[0].intval));
	}
#line 5111 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 2635 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* this is something like 3+1/4 where the 1/4 get interpreted
		 * by lexer as quadwhole, but it's really 1 for numerator
		 * and 4 for denominator. 
		 */
		tsig_item(1);
		tsig_item(TSR_SLASH);
		tsig_item((yyvsp[0].intval));
	}
#line 5125 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 2647 "src/mup/gram.y" /* yacc.c:1646  */
    {
		tsig_item(1);
		tsig_item(TSR_SLASH);
		tsig_item((yyvsp[0].intval));
	}
#line 5135 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 2661 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) < MINNUMERATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature numerator cannot be less than %d",
				MINNUMERATOR);
			(yyvsp[0].intval) = MINNUMERATOR;
		}
		else if ((yyvsp[0].intval) > MAXNUMERATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature numerator cannot be greater than %d",
				MAXNUMERATOR);
			(yyvsp[0].intval) = MAXNUMERATOR;
		}
		tsig_item((yyvsp[0].intval));
	}
#line 5155 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 2679 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = PTS_ONCE;
	}
#line 5163 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 2685 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = ((yyvsp[0].intval) == YES ? PTS_ALWAYS : PTS_NEVER);
	}
#line 5171 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 2690 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
	}
#line 5179 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 2696 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* 'n' is used in various places to mean do NOT
		 * print something that would normally be printed,
		 * so YES means we do want to inhibit the normal printing. */
		(yyval.intval) = YES;
	}
#line 5190 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 2704 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			Currstruct_p->u.ssv_p->prtime_str1 = 0;
			Currstruct_p->u.ssv_p->prtime_str2 = 0;
			Currstruct_p->u.ssv_p->prtime_is_arbitrary = NO;
			Currstruct_p->u.ssv_p->used[PRINTEDTIME] = YES;
		}
	}
#line 5203 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 2715 "src/mup/gram.y" /* yacc.c:1646  */
    {
		tsig_item(TSR_END);
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			MALLOCA(char, Currstruct_p->u.ssv_p->prtime_str1, Tsig_offset);
			strcpy(Currstruct_p->u.ssv_p->prtime_str1, Timerep);
			Currstruct_p->u.ssv_p->prtime_str2 = 0;
			Currstruct_p->u.ssv_p->prtime_is_arbitrary = NO;
			Currstruct_p->u.ssv_p->used[PRINTEDTIME] = YES;
		}
		/* Reset for next time signature usage, if any */
		Tsig_offset = 0;
	}
#line 5220 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 2730 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			Currstruct_p->u.ssv_p->prtime_str1 = (yyvsp[0].stringval);
			Currstruct_p->u.ssv_p->prtime_str2 = 0;
			Currstruct_p->u.ssv_p->prtime_is_arbitrary = YES;
			Currstruct_p->u.ssv_p->used[PRINTEDTIME] = YES;

		}
	}
#line 5234 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 2742 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			Currstruct_p->u.ssv_p->prtime_str1 = (yyvsp[-1].stringval);
			Currstruct_p->u.ssv_p->prtime_str2 = (yyvsp[0].stringval);
			Currstruct_p->u.ssv_p->prtime_is_arbitrary = YES;
			Currstruct_p->u.ssv_p->used[PRINTEDTIME] = YES;
		}
	}
#line 5247 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 2752 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ( ((yyvsp[-1].intval) != '#') && ((yyvsp[-1].intval) != '&') ) {
			yyerror("key signature must include # or &");
		}
		else {
			assign_key((yyvsp[-2].intval), (yyvsp[-1].intval), (yyvsp[0].intval), Currstruct_p);
		}
	}
#line 5260 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 2763 "src/mup/gram.y" /* yacc.c:1646  */
    {
		int sharps;

		/* Get number of sharps for the pitch letter */
		sharps = strchr(Circle, (yyvsp[-2].intval)) - Circle - 1;

		/* adjust for sharp/flat */
		if ((yyvsp[-1].intval) == '#') {
			sharps += 7;
		}
		else if ((yyvsp[-1].intval) == '&') {
			sharps -= 7;
		}
		else if ((yyvsp[-1].intval) != 0) {
			yyerror("key letter can only be followed by # or &");
			/* set to some ridiculous value, so will fail below */
			sharps = 999;
		}

		/* Adjust if needed for minor */
		if ((yyvsp[0].intval) == YES) {
			sharps -= 3;
		}

		/* disallow illegal keys, like f& */
		if (abs(sharps) > 7) {
			/* print error unless already printed one above */
			if (sharps < 100) {
				yyerror("invalid key--too many sharps or flats");
			}
		}
		else {
			assign_key(abs(sharps), (sharps >= 0 ? '#' : '&'),
							(yyvsp[0].intval), Currstruct_p);
		}
	}
#line 5301 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 2802 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].intval) == NO) {
			if ((yyvsp[0].intval) != -1) {
				l_warning(Curr_filename, yylineno,
					"can't use useaccs qualifier with n; ignoring the qualifier");
			}
			(yyval.intval) = UA_N;
		}
		else {
			if ((yyvsp[0].intval) == -1) {
				(yyvsp[0].intval) = UA_Y_NONE;
			}
			(yyval.intval) = (yyvsp[0].intval);
		}
	}
#line 5321 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 2820 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Empty means UA_Y_NONE when used with 'y', but we need
		 * to distinguish temporarily, in case user erroneously
		 * tries to use std with 'n' */
		(yyval.intval) = -1;
	}
#line 5332 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 2829 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 5340 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 2835 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = UA_Y_ALL;
	}
#line 5348 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 2841 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = UA_Y_NONNAT;
	}
#line 5356 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 2848 "src/mup/gram.y" /* yacc.c:1646  */
    {
		asgn_stafflines((yyvsp[-1].intval), (yyvsp[0].intval) == YES ? SS_NOTHING : SS_NORMAL, Currstruct_p);
	}
#line 5364 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 2854 "src/mup/gram.y" /* yacc.c:1646  */
    {
		asgn_stafflines((yyvsp[-1].intval), SS_DRUM, Currstruct_p);
	}
#line 5372 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 2860 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* use default tablature */
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->strinfo = Guitar;
			asgn_stafflines(DEFTABLINES, (yyvsp[0].intval), Currstruct_p);
		}
	}
#line 5384 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 2870 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* user-specified tablature */
		asgn_stafflines((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 5393 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 2876 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = PTC_FIRST;
	}
#line 5401 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 2882 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = PTC_NEVER;
	}
#line 5409 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 2888 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid letter is y */
		if (*yytext != 'y') {
			yyerror("flag value must be y or n");
		}
		(yyval.intval) = PTC_ALWAYS;
	}
#line 5421 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 2897 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = CT_NONE;
	}
#line 5429 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 2903 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (strcmp((yyvsp[0].stringval) + 2, "German") == 0) {
			(yyval.intval) = CT_GERMAN;
		}
		else {
			parse_doremi_string((yyvsp[0].stringval) + 2);
			(yyval.intval) = CT_DOREMI;
		}
	}
#line 5443 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 2915 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 1;
	}
#line 5451 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 2921 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* count up the number of strings */
		(yyval.intval) = (yyvsp[-1].intval) + 1;
	}
#line 5460 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 2927 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save info about this tablature string */
		if (Currstruct_p != 0) {
			add_tab_string_info((yyvsp[-3].intval), (yyvsp[-2].intval), (yyvsp[-1].intval), (yyvsp[0].intval), Currstruct_p->u.ssv_p);
		}
	}
#line 5471 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 2935 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 0;
	}
#line 5479 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 2941 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) != '&' && (yyvsp[0].intval) != '#') {
			yyerror("accidental on string can only be & or #");
		}
	}
#line 5489 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 2948 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no ticks */
		(yyval.intval) = 0;
	}
#line 5498 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 2955 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* limit number of ticks. Has to match the number of bits
		 * used by TMP_NTICKS in grpsyl.c */
		if ((yyvsp[0].intval) > MAXTICKS) {
			l_yyerror(Curr_filename, yylineno,
				"too many ' marks (%d max)", MAXTICKS);
			(yyvsp[0].intval) = MAXTICKS;
		}
	}
#line 5512 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 2966 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid letter is y */
		if (*yytext != 'y') {
			yyerror("flag value must be y or n");
		}
		(yyval.intval) = YES;
	}
#line 5524 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 2976 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
	}
#line 5532 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 2981 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p == 0) {
			l_warning(Curr_filename, yylineno,
				"wrong context for setting scoresep; ignoring");
		}
		else {
			/* Assign the value of minimum vertical space
			 * between scores. */
			assign_float(MINSCSEP, (yyvsp[0].floatval), Currstruct_p);
		}
	}
#line 5548 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 2994 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			/* if user set minimum greater than default maximum,
			 * adjust maximum to equal the minimum
			 * they specified. */
			if (Currstruct_p->u.ssv_p->minscsep
					> Currstruct_p->u.ssv_p->maxscsep) {
				Currstruct_p->u.ssv_p->maxscsep
					= Currstruct_p->u.ssv_p->minscsep;
			}
			else {
				/* fill in default */
				assign_float(MAXSCSEP, DEFMAXSCSEP, Currstruct_p);
			}
		}
	}
#line 5569 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 3013 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.ssv_p->minscsep > (yyvsp[0].floatval)) {
				yyerror("scoresep maximum smaller than minimum");
			}
			assign_float(MAXSCSEP, (yyvsp[0].floatval), Currstruct_p);
		}
	}
#line 5582 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 3023 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p == 0) {
			l_warning(Curr_filename, yylineno,
				"wrong context for setting scorepad; ignoring");
		}
		else {
			/* Assign the value of minimum vertical space
			 * between scores. */
			assign_float(MINSCPAD, (yyvsp[-1].intval) * (yyvsp[0].floatval), Currstruct_p);
		}
	}
#line 5598 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 3037 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			/* If user set minimum greater than default maximum,
			 * adjust maximum to equal the minimum
			 * they specified. */
			if (Currstruct_p->u.ssv_p->minscpad
					> Currstruct_p->u.ssv_p->maxscpad) {
				Currstruct_p->u.ssv_p->maxscpad
					= Currstruct_p->u.ssv_p->minscpad;
			}
			else {
				/* fill in default */
				assign_float(MAXSCPAD, DEFMAXSCPAD, Currstruct_p);
			}
		}
	}
#line 5619 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 3056 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.ssv_p->minscpad > (yyvsp[-1].intval) * (yyvsp[0].floatval)) {
				yyerror("scorepad maximum smaller than minimum");
			}
			assign_float(MAXSCPAD, (yyvsp[-1].intval) * (yyvsp[0].floatval), Currstruct_p);
		}
	}
#line 5632 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 3067 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 5639 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 3072 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_float(MAXPROSHORT, (yyvsp[-1].floatval), Currstruct_p);
	}
#line 5647 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 3077 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 5654 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 3082 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].intval) > (yyvsp[0].intval)) {
			l_warning(Curr_filename, yylineno,
				"distance to begin shortening protruding stems cannot be greater than ending distance; making them equal");
			(yyvsp[0].intval) = (yyvsp[-2].intval);
		}
		assign_int(BEGPROSHORT, (yyvsp[-2].intval), Currstruct_p);
		assign_int(ENDPROSHORT, (yyvsp[0].intval), Currstruct_p);
	}
#line 5668 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 3094 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = UNKNOWN;
	}
#line 5676 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 3100 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 5684 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 3109 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].intval) == (int) 'a' && (yyvsp[0].intval) >= 4 && (yyvsp[0].intval) <= 6) {
			switch ((yyvsp[0].intval)) {
			case 4:
				(yyval.intval) = PS_A4;
				break;
			case 5:
				(yyval.intval) = PS_A5;
				break;
			case 6:
				(yyval.intval) = PS_A6;
				break;
			default:
				pfatal("impossible pagesize");
				break;
			}
		}
		else {
			yyerror("unsupported pagesize");
		}
	}
#line 5710 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 3134 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 0;
	}
#line 5718 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 3140 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = ((yyvsp[0].intval) == O_PORTRAIT ? 0 : 1);
	}
#line 5726 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 3146 "src/mup/gram.y" /* yacc.c:1646  */
    { VCrange_p = 0; Doing_vcombine = YES; }
#line 5732 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 3146 "src/mup/gram.y" /* yacc.c:1646  */
    { Doing_vcombine = NO; }
#line 5738 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 3151 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_vcombine(VC_NOOVERLAP, NO, Currstruct_p, Curr_tssv_p);
	}
#line 5746 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 3157 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Defining_multiple = NO;
	}
#line 5754 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 3163 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_vcombine(VC_NOOVERLAP, NO, Currstruct_p, Curr_tssv_p);
	}
#line 5762 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 3169 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_vcombine((yyvsp[-1].intval), (yyvsp[0].intval), Currstruct_p, Curr_tssv_p);
	}
#line 5770 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 3175 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_vcombine((yyvsp[0].intval), YES, Currstruct_p, Curr_tssv_p);
	}
#line 5778 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 3182 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = VC_NOOVERLAP;
	}
#line 5786 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 3188 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 5794 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 3195 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
	}
#line 5802 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 3201 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = YES;
	}
#line 5810 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 3208 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 5818 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 3214 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) != C_TOP) {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
		(yyval.intval) = ENDING_TOP;
	}
#line 5830 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 3223 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 1;
	}
#line 5838 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 3229 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = -1;
	}
#line 5846 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 3234 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
	}
#line 5854 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 3240 "src/mup/gram.y" /* yacc.c:1646  */
    {
		switch ((yyvsp[0].intval)) {
		case MINOR:
			(yyval.intval) = YES;
			break;
		case MAJOR:
			(yyval.intval) = NO;
			break;
		default:
			(yyval.intval) = NO;
			yyerror("must be major or minor");
			break;
		}
	}
#line 5873 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 3256 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = P_LINE;
	}
#line 5881 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 3262 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = P_ALTPEDSTAR;
	}
#line 5889 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 3268 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = P_PEDSTAR;
	}
#line 5897 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 3276 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = TR_BOTH;
	}
#line 5905 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 3282 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 5913 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 3287 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 5920 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 3291 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == FONT_UNKNOWN) {
			(yyvsp[0].intval) = Curr_font;
		}
		if ((yyvsp[-1].intval) == FAMILY_DFLT) {
			/* user didn't specify a family. Use the current
			 * family, unless we don't have one yet, in which
			 * case look it up */
			if (Curr_family == FAMILY_DFLT) {
				Curr_family = Score.fontfamily;
			}
			Titlefont =  Curr_family + (yyvsp[0].intval);
		}
		else {
			Titlefont = (yyvsp[-1].intval) + (yyvsp[0].intval);
		}
	}
#line 5942 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 3310 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = FONT_UNKNOWN;
	}
#line 5950 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 3316 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 5958 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 3321 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = FAMILY_DFLT;
	}
#line 5966 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 3326 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 5974 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 3331 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Titlesize = Curr_size;
	}
#line 5982 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 3337 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Titlesize = (yyvsp[-1].intval);
	}
#line 5990 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 3343 "src/mup/gram.y" /* yacc.c:1646  */
    {
		String1 = (yyvsp[0].stringval);
		Extra = extra_needed(Titlefont, Titlesize, &String1);
		proc_printcmd(J_CENTER, (struct INPCOORD *) 0, String1,
			Titlefont, Titlesize, YES, NO, PU_NORMAL, NO, 0, Extra);
	}
#line 6001 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 3352 "src/mup/gram.y" /* yacc.c:1646  */
    {
		double tmp_extra;

		/* If one is taller than the default for the font/size,
		 * figure out how much more to add on. */
		String1 = (yyvsp[-1].stringval);
		Extra = extra_needed(Titlefont, Titlesize, &String1);
		String2 = (yyvsp[0].stringval);
		tmp_extra = extra_needed(Titlefont, Titlesize, &String2);
		Extra = MAX(Extra, tmp_extra);

		proc_printcmd(J_LEFT, (struct INPCOORD *) 0, String1,
				Titlefont, Titlesize, YES, NO, PU_NORMAL,
				NO, 0, Extra);
		proc_printcmd(J_RIGHT, (struct INPCOORD *) 0, String2,
				Titlefont, Titlesize, NO, NO, PU_NORMAL,
				NO, 0, (double) 0.0);
	}
#line 6024 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 3373 "src/mup/gram.y" /* yacc.c:1646  */
    {
		double tmp_extra;
		char *string3;

		String1 = (yyvsp[-2].stringval);
		Extra = extra_needed(Titlefont, Titlesize, &String1);
		String2 = (yyvsp[-1].stringval);
		tmp_extra = extra_needed(Titlefont, Titlesize, &String2);
		Extra = MAX(Extra, tmp_extra);
		string3 = (yyvsp[0].stringval);
		tmp_extra = extra_needed(Titlefont, Titlesize, &string3);
		Extra = MAX(Extra, tmp_extra);

		proc_printcmd(J_LEFT, (struct INPCOORD *) 0, String1,
				Titlefont, Titlesize, YES, NO, PU_NORMAL,
				NO, 0, Extra);
		proc_printcmd(J_CENTER, (struct INPCOORD *) 0, String2,
				Titlefont, Titlesize, NO, NO, PU_NORMAL,
				NO, 0, (double) 0.0);
		proc_printcmd(J_RIGHT, (struct INPCOORD *) 0, string3,
				Titlefont, Titlesize, NO, NO, PU_NORMAL,
				NO, 0, (double) 0.0);
	}
#line 6052 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 3398 "src/mup/gram.y" /* yacc.c:1646  */
    {
		char *p;		/* pointer through the string */
		int backslash_count;	/* how many backslashes in a row */
		int font, size;		/* at end of \n-delimited segment */
		char *string_start;	/* where current segment begins */

		/* Convert unescaped input newlines to spaces.
		 * The +2 in the 'for' initialization is to skip font/size.
		 */
		backslash_count = 0;
		string_start = (yyvsp[-2].stringval);
		/* If we are running on a file using \r or \r\n for
		 * line separator, normalize to \n instead */
		for (p = string_start + 2; *p != 0; p++) {
			if (*p == '\r') {
				if ( *(p+1) != '\n') {
					/* \r by itself. Use \n instead */
					*p = '\n';
				}
				else {
					/* delete the \r */
					char *src, *dest;
					for (src = p + 1, dest = p;  ; src++, dest++) { 
						*dest = *src;
						if (*src == '\0') {
							break;
						}
					}
				}
			}
		}

		font = Titlefont;
		size = Titlesize;
		for (p = string_start + 2; *p != 0; p++) {
			/* Real newlines not preceded by an odd number
			 * of backslashes are converted to spaces. */
			if (*p == '\n' && (backslash_count & 0x1) == 0) {
				*p = ' ';
			}

			/* Count up number of consecutive backslashes.
			 * Also, if user explicitly uses \n, split into
			 * a new paragraph
			 */
			if (*p == '\\') {
				backslash_count++;
				if (((backslash_count & 0x1) == 1)
						&& ( *(p+1) == 'n') ) {
					/* Need to split.
					 * Terminate the current string
					 * where we are in it, and process it,
					 * then arrange to continue processing
					 * on the rest of the string.
					 */
					*p = '\0';
					(void) fix_string(string_start,
						font, size,
						Curr_filename, yylineno);
					String1 = map_print_str(strdup(string_start), Curr_filename, yylineno);
					proc_printcmd((yyvsp[-6].intval), (struct INPCOORD*) 0,
						String1, font, size,
						YES, NO, PU_NORMAL, NO, 0, 0.0);

					/* The user could change font/size
					 * in mid-string with \f() and/or \s().
					 * so we have to determine what they
					 * are at the end of the current segment
					 * and use that for making the copy
					 * of the remainder of the string.
					 * The original copy of the remainder
					 * of the string gets "memory leaked,"
					 * but this is a rare case, so not
					 * worth worrying about.
					 */
					end_fontsize(String1, &font, &size);
					string_start = copy_string(p+2, font, size);
					p = string_start + 1;
					backslash_count = 0;
				}
			}
			else {
				backslash_count = 0;
			}
		}
		(void) fix_string(string_start, font, size,
					Curr_filename, yylineno);
		String1 = map_print_str(strdup(string_start), Curr_filename, yylineno);
		proc_printcmd((yyvsp[-6].intval), (struct INPCOORD*) 0, String1,
				font, size, YES, NO, PU_NORMAL, NO, 0, 0.0);
	}
#line 6148 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 3492 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Use same paragraph time as last time (or default if
		 * this is the first paragraph ever in this song.) */
		(yyval.intval) = Curr_paratype;
	}
#line 6158 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 3500 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_paratype = (yyvsp[0].intval);
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 6167 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 3639 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* make a copy */
		if (Curr_family == FAMILY_DFLT) {
			Curr_family = Score.fontfamily;
		}
		(yyval.stringval) = copy_string((yyvsp[0].stringval), Curr_family + Curr_font, Curr_size);
	}
#line 6179 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 3649 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* append new string part to existing string */
		MALLOCA(char, (yyval.stringval), strlen((yyvsp[-2].stringval)) + strlen((yyvsp[0].stringval)) + 1);
		sprintf((yyval.stringval), "%s%s", (yyvsp[-2].stringval), (yyvsp[0].stringval));
		FREE((yyvsp[-2].stringval));
	}
#line 6190 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 3659 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = stripquotes(yytext);
	}
#line 6198 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 3665 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = string_func((yyvsp[-3].intval), (yyvsp[-1].stringval) + 2);
	}
#line 6206 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 3671 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(void) contextcheck(C_MUSIC, "music information");
		tssv_line();
		/* reset flags for next voice */
		Defining_multiple = NO;
		Curr_grpsyl_p = (struct GRPSYL *) 0;
		Good_till_canceled = NO;
		free_extra_time();
		Prev_grpsyl_p = 0;
		Meas_rpt_type = MRT_NONE;
	}
#line 6222 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 3684 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Here's the deal: the staff/voice specification
		 * could be lists of staff ranges and/or voices.
		 * We need a separate copy of the groupinfo
		 * for each staff/voice. So as we parse the sv_spec,
		 * we remember which staffs and voices are specified,
		 * and keep a pointer to the first STAFF in the measure.
		 * Then after collecting the groupinfo,
		 * we make copies of the group info for each staff/voice given.
		 * It has to be copies rather than just a pointer to the
		 * same stuff, because the coordinates will be different
		 * for each staff/voice. */

		/* attach the groupinfo to each of the STAFF structs */
		link_groups();
	}
#line 6243 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 3703 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_multirest((yyvsp[-1].intval));
		/* If there are alternating time signatures, figure out
		 * which one should be in effect at the end of the multirest */
		if (Alt_timesig_list != 0) {
			int m;

			/* The Next_alt_timesig is already pointing to
			 * the value for after the first measure in the
			 * multirest, so have to subtract 1 here */
			for (m = 0; m < (yyvsp[-1].intval) - 1; m++) {
				if (Next_alt_timesig == 0) {
					/* Shouldn't really ever get here,
					 * since other code should do the
					 * wrap-around, but just in case... */
					Next_alt_timesig = Alt_timesig_list;
					continue;
				}
				do {
					Next_alt_timesig++;
					if (*Next_alt_timesig == TSR_END) {
						Next_alt_timesig = Alt_timesig_list;
						break;
					}
				} while (*Next_alt_timesig != TSR_ALTERNATING);
			}
			if (*Next_alt_timesig == TSR_ALTERNATING) {
				Next_alt_timesig++;
			}
		}
		Currstruct_p = (struct MAINLL *) 0;
	}
#line 6280 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 3738 "src/mup/gram.y" /* yacc.c:1646  */
    {
		free_staffrange();
	}
#line 6288 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 3743 "src/mup/gram.y" /* yacc.c:1646  */
    {
		begin_range(PL_UNKNOWN);
	}
#line 6296 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 3748 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Chord_at_a_time = NO;
	}
#line 6304 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 3754 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Chord_at_a_time = YES;
	}
#line 6312 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 3769 "src/mup/gram.y" /* yacc.c:1646  */
    {
		begin_map();
	}
#line 6320 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 3774 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_map();
	}
#line 6328 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 3779 "src/mup/gram.y" /* yacc.c:1646  */
    {
		map_item();
	}
#line 6336 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 3785 "src/mup/gram.y" /* yacc.c:1646  */
    {
		map_item();
		Defining_multiple = YES;
	}
#line 6345 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 3791 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* initialize grpsyl info */
		Curr_grpsyl_p = Last_grpsyl_p = (struct GRPSYL *) 0;
	}
#line 6354 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 3801 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* prepare for a new set of ranges */
		begin_range(Place);
		Defining_multiple = YES;
	}
#line 6364 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 3808 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* data is for staff with only one voice */
		save_vno_range(1, 1);
		add_to_sv_list();
	}
#line 6374 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 3816 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == YES) {
			add_to_sv_list();
		}
	}
#line 6384 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 3825 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* set flag as to whether we are processing tab staff
		 * information or normal staff info */
		Doing_tab_staff = is_tab_range();
	}
#line 6394 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 3835 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* several staffs have the same note data */
		Defining_multiple = YES;
	}
#line 6403 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 3841 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* remember which staffs we are currently getting data for */
		/* if only a single number, not a range, staff_range will be
		 * 0, so use staffnum as high and low of range */
		save_staff_range((yyvsp[-1].intval), ((yyvsp[0].intval) == 0 ? (yyvsp[-1].intval) : (yyvsp[0].intval)));
	}
#line 6414 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 3849 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* empty - no range, just a single number */
		(yyval.intval) = 0;
	}
#line 6423 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 3856 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Defining_multiple = YES;
		(yyval.intval) = (yyvsp[0].intval);
		if ((yyvsp[0].intval) == 0) {
			yyerror("staff of 0 is illegal");
		}
	}
#line 6435 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 3866 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* note data applies to a single voice */
		if (rangecheck((yyvsp[-1].intval), MINVOICES, MAXVOICES, "voice") == YES) {
			if (Doing_vcombine == YES) {
				save_vcombine_range((yyvsp[-1].intval), (yyvsp[-1].intval));
			}
			else {
				save_vno_range((yyvsp[-1].intval), (yyvsp[-1].intval));
			}
			(yyval.intval) = YES;
		}
		else {
			(yyval.intval) = NO;
		}
	}
#line 6455 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 3884 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* note data applies to range of voices */
		if (rangecheck((yyvsp[-3].intval), MINVOICES, MAXVOICES, "voice") == YES &&
				rangecheck((yyvsp[-1].intval), MINVOICES, MAXVOICES, "voice") == YES) {
			if ((yyvsp[-1].intval) < (yyvsp[-3].intval)) {
				l_yyerror(Curr_filename, yylineno,
					"end of voice range is smaller than beginning");
				(yyval.intval) = NO;
			}
			else {
				if (Doing_vcombine == YES) {
					save_vcombine_range((yyvsp[-3].intval), (yyvsp[-1].intval));
				}
				else {
					save_vno_range((yyvsp[-3].intval), (yyvsp[-1].intval));
					Defining_multiple = YES;
				}
				(yyval.intval) = YES;
			}
		}
		else {
			(yyval.intval) = NO;
		}
	}
#line 6484 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 3914 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_vcombine == NO) {
			Defining_multiple = YES;
		}
	}
#line 6494 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 3931 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Associate any TIMEDSSVs with this group */
		if (Curr_tssv_p != 0) {
			tssv_setgrpsyl(Curr_grpsyl_p);
			Curr_tssv_p = 0;
		}

		/* if no custom beaming indicated, fill in based on previous. */
		if ( Curr_grpsyl_p->beamloc == NOITEM) {
			setbeamloc(Curr_grpsyl_p, Last_grpsyl_p);
		}

		/* later we check that if there is an 'm', it is
		 * the only thing in the measure */

		link_notegroup(Curr_grpsyl_p, Last_grpsyl_p);
		Curr_marklist = 0;
		/* Save pointer to this group, in case there are additive
		 * times, and the next group gets its time value from this
		 * group. In that case, we need this group, not the last one
		 * of the added groups. */
		Prev_grpsyl_p = Curr_grpsyl_p;
		/* Add groups if there were additive time values. */
		if (Extra_time_p != 0) {
			Curr_grpsyl_p = expandgrp(Curr_grpsyl_p, Extra_time_p);
			/* If there was a custom beam ebm on something with
			 * additive time, we need make sure ENDITEM is on only
			 * the last of the expanded groups. */
			if (Curr_grpsyl_p != Prev_grpsyl_p
					&& Prev_grpsyl_p->beamloc == ENDITEM) {
				struct GRPSYL *g_p;
				for (g_p = Prev_grpsyl_p; g_p != Curr_grpsyl_p;
							g_p = g_p->next) {
					g_p->beamloc = INITEM;
				}
				Curr_grpsyl_p->beamloc = ENDITEM;
			}
			Last_grpsyl_p = Curr_grpsyl_p->prev;
		}
		Curr_timelist_p = 0;
	}
#line 6540 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 3989 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Chord_at_a_time == YES) {
			yyerror("mid-measure changes not allowed on chord-at-a-time input");
		}
	}
#line 6550 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 3998 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_tssv_p = tssv_create(C_SCORE);
	}
#line 6558 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 4004 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_tssv_p = tssv_create(C_STAFF);
	}
#line 6566 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 4010 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_tssv_p = tssv_create(C_VOICE);
	}
#line 6574 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 4024 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p != 0 && Curr_grpsyl_p->grpsyl == GS_GROUP
				&& Curr_grpsyl_p->grpvalue == GV_ZERO) {
			yyerror("mid-measure clef change not allowed after grace note\n");
		}
		tssv_update(Curr_tssv_p, (yyvsp[-2].intval), (yyvsp[0].intval));
	}
#line 6586 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 4034 "src/mup/gram.y" /* yacc.c:1646  */
    {
		switch ((yyvsp[-2].intval)) {

		case DEFOCT:
		case RELEASE:
			tssv_update(Curr_tssv_p, (yyvsp[-2].intval), (yyvsp[0].intval));
			break;

		default:
			l_warning(Curr_filename, yylineno,
				"parameter type cannot be changed mid-measure; ignoring");
			break;
		}
	}
#line 6605 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 4051 "src/mup/gram.y" /* yacc.c:1646  */
    {
		switch ((yyvsp[-2].intval)) {

		case ALIGNRESTS:
			tssv_update(Curr_tssv_p, (yyvsp[-2].intval), (yyvsp[0].intval));
			break;

		default:
			l_warning(Curr_filename, yylineno,
				"parameter type cannot be changed mid-measure; ignoring");
			break;
		}
	}
#line 6623 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 4067 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 6630 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 4076 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Good_till_canceled == NO) {
			/* use default attributes */
			Curr_grpsyl_p->grpvalue = GV_NORMAL;
			Curr_grpsyl_p->grpsize = GS_NORMAL;
			Curr_grpsyl_p->headshape = HS_UNKNOWN;
		}
		else {
			/* re-use previous style */
			copy_attributes(Curr_grpsyl_p, Last_grpsyl_p);
			Curr_grpsyl_p->with_was_gtc = YES;
		}
	}
#line 6648 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 4092 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Good_till_canceled = NO;
	}
#line 6656 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 4098 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 6663 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 4102 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Good_till_canceled = NO;
	}
#line 6671 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 4108 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Good_till_canceled = YES;
	}
#line 6679 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 4113 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 6686 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 4118 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Good_till_canceled == YES) {
			yyerror("can't use ... and more than one [] on same chord");
		}
	}
#line 6696 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 4125 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* NULL token to cause allocation of a GRPSYL struct */
		Last_grpsyl_p = Curr_grpsyl_p;
		Curr_grpsyl_p = newGRPSYL(GS_GROUP);
	}
#line 6706 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 4132 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* an empty marklist means we should use
		 * the same attributes as the last time */
		copy_attributes(Curr_grpsyl_p, Last_grpsyl_p);
	}
#line 6716 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 4149 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_grpsyl_p->nwith = (short) Item_count;
		Curr_grpsyl_p->withlist = Curr_marklist;
		if ((yyvsp[0].intval) != PL_UNKNOWN) {
			int m;

			/* User specified a side, so remember that */
			for (m = Mark_start; m < Item_count; m++) {
				Curr_marklist[m].place = (yyvsp[0].intval);
			}
		}
	}
#line 6733 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 4173 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->stemdir != UNKNOWN &&
					Curr_grpsyl_p->stemdir != (yyvsp[0].intval)) {
			l_warning(Curr_filename, yylineno,
				"both stem directions specified; using last instance");
		}
		if (Doing_tab_staff == YES) {
			l_warning(Curr_filename, yylineno,
				"stem direction specification is pointless on tab staff; ignoring");
		}
		else {
			Curr_grpsyl_p->stemdir = (yyvsp[0].intval);
		}
	}
#line 6752 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 4190 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].intval) != DIST) {
			l_warning(Curr_filename, yylineno,
				"unexpected parameter name; ignoring");
		}
		else {
			if (Curr_grpsyl_p->restdist != NORESTDIST &&
					Curr_grpsyl_p->restdist != (yyvsp[-1].intval) * (yyvsp[0].intval)) {
				l_warning(Curr_filename, yylineno,
						"more than one dist value specified; using last instance");
			}
			Curr_grpsyl_p->restdist = (yyvsp[-1].intval) * (yyvsp[0].intval);
		}
	}
#line 6771 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 4207 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->ho_usage != HO_NONE &&
				Curr_grpsyl_p->ho_usage != (yyvsp[0].intval)) {
			l_warning(Curr_filename, yylineno,
				"More than one ho type specified; last instance used");
		}
		Curr_grpsyl_p->ho_usage = (yyvsp[0].intval);
	}
#line 6784 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 4218 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p != 0) {
			if (Curr_grpsyl_p->headshape != HS_UNKNOWN) {
				l_warning(Curr_filename, yylineno,
					"multiple head shapes specified, using last");
			}
			/* +2 to skip past extraneous font/size */
			if (Doing_tab_staff == YES && strcmp((yyvsp[0].stringval) + 2, "allx") != 0) {
				yyerror("allx is the only headshape allowed on tab staffs");
			}
			if ((Curr_grpsyl_p->headshape = get_shape_num((yyvsp[0].stringval) + 2))
					== HS_UNKNOWN) {
				l_yyerror(Curr_filename, yylineno,
					"'%s' is not a valid head shape name",
					ascii_str((yyvsp[0].stringval), YES, NO, TM_NONE));
			}
		}
		else {
			pfatal("Curr_grpsyl_p was null for setting hs");
		}
		/* We don't need the name anymore; we have its corresponding
		 * number that we use internally. */
		FREE((yyvsp[0].stringval));
	}
#line 6813 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 4245 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->stemlen != STEMLEN_UNKNOWN &&
				fabs(Curr_grpsyl_p->stemlen - (yyvsp[0].floatval) * STEPSIZE) > 0.0001) {
			l_warning(Curr_filename, yylineno,
				"more than one len specified; using last instance");
		}
		Curr_grpsyl_p->stemlen = (yyvsp[0].floatval) * STEPSIZE;
	}
#line 6826 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 4256 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) <= 0) {
			yyerror("slash number must be > 0");
		}
		else if ((yyvsp[0].intval) > 8) {
			/* we decided 8 slashes would be at least 256th note
			 * or shorter, and 256th is the shortest note we
			 * support, 8 slashes is plenty */
			l_warning(Curr_filename, yylineno,
				"number of slashes only allowed to be <= 8; limiting to 8");
			(yyvsp[0].intval) = 8;
		}
		if (Curr_grpsyl_p->slash_alt > 0 &&
					Curr_grpsyl_p->slash_alt != (yyvsp[0].intval)) {
			l_warning(Curr_filename, yylineno,
				"more than one slash value specified; using last instance");
		}
		if (Curr_grpsyl_p->slash_alt < 0) {
			yyerror("only one slash/alt allowed per group");
		}
		Curr_grpsyl_p->slash_alt = (yyvsp[0].intval);
	}
#line 6853 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 4281 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = HO_RIGHT;
	}
#line 6861 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 4287 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = HO_LEFT;
	}
#line 6869 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 4293 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* We want to silently accept identical values specified
		 * more than once, so use fuzzy compare to deal with roundoff */
		if (Curr_grpsyl_p->ho_usage == HO_VALUE &&
				fabs(Curr_grpsyl_p->ho_value - (yyvsp[-1].intval) * (yyvsp[0].floatval)) > 0.0001) {
			l_warning(Curr_filename, yylineno,
				"More than one ho value specified; last instance used");
		}
		if ((yyvsp[-1].intval) == 0) {
			Curr_grpsyl_p->ho_value = (yyvsp[0].floatval);
		}
		else {
			Curr_grpsyl_p->ho_value = (yyvsp[-1].intval) * (yyvsp[0].floatval);
		}
		(yyval.intval) = HO_VALUE;
	}
#line 6890 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 4312 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 0;
	}
#line 6898 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 4318 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 6906 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 4340 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyvsp[0].floatval) *= (yyvsp[-1].intval);
		if (fabs(Curr_grpsyl_p->beamslope - NOBEAMANGLE) > 0.01) {
			l_warning(Curr_filename, yylineno,
				"multiple slope values specified; using last one");
		}
		if (frangecheck((yyvsp[0].floatval), MINBEAMANGLE, MAXBEAMANGLE, "slope") == YES) {
			Curr_grpsyl_p->beamslope = (yyvsp[0].floatval);
		}
	}
#line 6921 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 4353 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) <= 0) {
			yyerror("alt number must be > 0");
		}
		if (Curr_grpsyl_p->slash_alt != 0) {
			yyerror("only one slash/alt allowed per group");
		}
		if (Doing_tab_staff == YES) {
			l_warning(Curr_filename, yylineno,
				"alt not allowed on tablature staff; ignoring");
		}
		else {
			/* Should at least keep small enough
			 * that 1 shifted left by this still fits
			 * in a 16-bit int. For a while we limited to 15,
			 * but for slashes, we limit to 8, and
			 * that seems like more than enough for here too. */
			if ((yyvsp[0].intval) > 8) {
				l_warning(Curr_filename, yylineno,
					"alt value too large; limiting to 8");
				(yyvsp[0].intval) = 8;
			}
			Curr_grpsyl_p->slash_alt = -(yyvsp[0].intval);
		}
	}
#line 6951 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 4381 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->phcount < PH_COUNT) {
			Curr_grpsyl_p->phplace[Curr_grpsyl_p->phcount++] = (yyvsp[0].intval);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"too many ph marks on the same chord; limiting to %d", PH_COUNT);
		}
	}
#line 6965 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 4393 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->ephcount < PH_COUNT) {
			Curr_grpsyl_p->ephcount++;
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"too many eph marks on the same chord; limiting to %d", PH_COUNT);
		}
	}
#line 6979 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 4404 "src/mup/gram.y" /* yacc.c:1646  */
    {
		int n;

		/* add a slur to each note in the chord. Don't know
		 * which pitch to slur to yet, just that it will be to
		 * the "matching" note in the next chord, so use
		 * special magic pitch of 'M' to convey this */
		for (n = 0; n < Curr_grpsyl_p->nnotes; n++) {
			add_slurto(Curr_grpsyl_p, 'M', USE_DFLT_OCTAVE, n, (yyvsp[-2].intval));
			set_slurdir(Curr_grpsyl_p, -1, (yyvsp[-1].intval), (yyvsp[0].intval));
		}
	}
#line 6996 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 4419 "src/mup/gram.y" /* yacc.c:1646  */
    {
		int n;

		Curr_grpsyl_p->tie = YES;
		for (n = 0; n < Curr_grpsyl_p->nnotes; n++) {
			Curr_grpsyl_p->notelist[n].tie = YES;
			Curr_grpsyl_p->notelist[n].tiestyle = (yyvsp[-2].intval);
			Curr_grpsyl_p->notelist[n].tiedir = (yyvsp[-1].intval);
			Curr_grpsyl_p->notelist[n].tied_to_voice = (yyvsp[0].intval);
		}
	}
#line 7012 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 4432 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_marklist == 0) {
			/* allocate space for a list of marks */
			MALLOC(WITH_ITEM, Curr_marklist, ITEMS);
			Item_count = 0;
			Max_items = ITEMS;
		}
		Mark_start = Item_count;
	}
#line 7026 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 4443 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = PL_UNKNOWN;
	}
#line 7034 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 4449 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 7042 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 4454 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = UNKNOWN;
	}
#line 7050 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 4460 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 7058 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 4466 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO_TO_VOICE;
	}
#line 7066 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 4472 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) >= MINVOICES && (yyvsp[0].intval) <= MAXVOICES) {
			/* Note that if the current staff doesn't have this
			 * to voice, that error will be caught later,
			 * by find_to_group() in tie.c */
			(yyval.intval) = (yyvsp[0].intval);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"to voice must be between %d and %d",
					MINVOICES, MAXVOICES);
			(yyval.intval) = NO_TO_VOICE;
		}
	}
#line 7085 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 4495 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* if too many items, get some more space */
		if (Item_count >= Max_items) {
			Max_items += ITEMS;
			if ((Curr_marklist = (struct WITH_ITEM *) realloc(Curr_marklist,
						Max_items * sizeof(struct WITH_ITEM)))
						==  0) {
				l_no_mem(__FILE__, __LINE__);
			}
		}
		Curr_marklist[Item_count].string = (yyvsp[0].stringval);
		Curr_marklist[Item_count].place = PL_UNKNOWN;
		Item_count++;
	}
#line 7104 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 4511 "src/mup/gram.y" /* yacc.c:1646  */
    {
		MALLOCA(char, (yyval.stringval), strlen((yyvsp[0].stringval)) + 3);
		(yyval.stringval)[0] = FONT_TR;
		(yyval.stringval)[1] = DFLT_SIZE;
		sprintf((yyval.stringval) + 2, "%s", (yyvsp[0].stringval));
	}
#line 7115 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 4524 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(dot)" : "\\(smdot)");
	}
#line 7124 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 4531 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(leg)" : "\\(smleg)");
	}
#line 7133 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 4538 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(acc_gt)" : "\\(smacc_gt)");
	}
#line 7142 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 4545 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(acc_hat)" : "\\(smacc_hat)");
	}
#line 7151 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 4551 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->grpvalue == GV_ZERO) {
			Curr_grpsyl_p->grpsize = GS_TINY;
		}
		else {
			Curr_grpsyl_p->grpvalue = GV_NORMAL;
			Curr_grpsyl_p->grpsize = GS_SMALL;
		}
	}
#line 7165 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 4563 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_grpsyl_p->grpvalue = GV_ZERO;
		if (Curr_grpsyl_p->grpsize == GS_SMALL) {
			Curr_grpsyl_p->grpsize = GS_TINY;
		}
		else {
			Curr_grpsyl_p->grpsize = GS_SMALL;
		}
	}
#line 7179 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 4575 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->headshape != HS_UNKNOWN) {
			l_warning(Curr_filename, yylineno,
				"diam is overriding previous headshapes specification");
		}
		Curr_grpsyl_p->headshape = get_shape_num("diam");
	}
#line 7191 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 4585 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->headshape != HS_UNKNOWN) {
			l_warning(Curr_filename, yylineno,
				"xnote is overriding previous headshapes specification");
		}
		Curr_grpsyl_p->headshape = get_shape_num(
					Doing_tab_staff == YES ? "allx" : "x");
	}
#line 7204 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 4596 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = UP;
	}
#line 7212 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 4602 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = DOWN;
	}
#line 7220 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 4608 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* custom beaming cannot be nested */
		struct GRPSYL *prev_like_gs_p;
		/* Find previous group with same grace-ness. Can't use
		 * prevsimilar() here, since it looks at grpcont too. */
		for (prev_like_gs_p = Last_grpsyl_p; prev_like_gs_p != 0 &&
			prev_like_gs_p->grpvalue != Curr_grpsyl_p->grpvalue;
			prev_like_gs_p = prev_like_gs_p->prev) {
			;
		}
		if (prev_like_gs_p != 0 &&
				((prev_like_gs_p->beamloc == STARTITEM)
				|| (prev_like_gs_p->beamloc == INITEM)) ) {
			yyerror("custom beaming may not be nested");
		}
		/* Non-custom beaming, if any, is done later, in do_bar() */
		else {
			/* begin custom beaming */
			Curr_grpsyl_p->beamloc = STARTITEM;
			if (Curr_grpsyl_p->basictime < 8 && (yyvsp[0].intval) == CS_SAME) {
				yyerror("beamed notes must be 8th or shorter");
			}
		}
		Curr_grpsyl_p->beamto = (yyvsp[0].intval);
	}
#line 7250 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 4636 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_grpsyl_p->autobeam = STARTITEM;
	}
#line 7258 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 4642 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_grpsyl_p->autobeam = ENDITEM;
	}
#line 7266 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 4648 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_grpsyl_p->breakbeam = YES;
	}
#line 7274 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 4654 "src/mup/gram.y" /* yacc.c:1646  */
    {
		struct GRPSYL *last_nongrace_p;

		/* find the previous group, skipping grace groups */
		for (last_nongrace_p = Last_grpsyl_p;
				last_nongrace_p != (struct GRPSYL *) 0
				&& last_nongrace_p->grpvalue == GV_ZERO;
				last_nongrace_p = last_nongrace_p->prev) {
			;
		}

		/* check that a custom beam is in progress */
		if ((last_nongrace_p == (struct GRPSYL *) 0)
				|| ((last_nongrace_p != (struct GRPSYL *) 0)
				&& (last_nongrace_p->beamloc != STARTITEM)
				&& (last_nongrace_p->beamloc != INITEM) )) {
			l_warning(Curr_filename, yylineno,
				"'ebm' unexpected: no custom beaming in progress; ignoring");
		}
		else {
			Curr_grpsyl_p->beamloc = ENDITEM;
			Curr_grpsyl_p->beamto = last_nongrace_p->beamto;
			if (Curr_grpsyl_p->basictime < 8
					&& Last_grpsyl_p->beamto == CS_SAME) {
				yyerror("beamed notes must be 8th or shorter");
			}
		}
	}
#line 7307 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 4684 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Use the same as last time or default timeunit.
		 * If that involves additive time values,
		 * save pointer to that info in Extra_time_p for later use. */
		Extra_time_p = copy_timeunit(Curr_grpsyl_p, Prev_grpsyl_p,
						Extra_time_p);
	}
#line 7319 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 4694 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->is_meas == YES) {
			Curr_grpsyl_p->fulltime = Score.time;
		}
		else {
			Curr_grpsyl_p->fulltime = (yyvsp[0].ratval);
		}
	}
#line 7332 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 4704 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = CS_SAME;
	}
#line 7340 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 4710 "src/mup/gram.y" /* yacc.c:1646  */
    {
		CSBused = YES;
		switch ((yyvsp[0].intval)) {
		case PL_ABOVE:
			(yyval.intval) = CS_ABOVE;
			break;
		case PL_BELOW:
			(yyval.intval) = CS_BELOW;
			break;
		default:
			yyerror("bm with staff must be 'above' or 'below'");
			(yyval.intval) = CS_SAME;
		}
	}
#line 7359 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 4726 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.ratval).n = (yyvsp[0].intval);
		(yyval.ratval).d = 1;

		/* if filling in a GRPSYL struct, need to fill in basic time,
		 * could also be here due to beamstyle, in which case the
		 * Curr_grpsyl_p will be NULL, or when getting tuplet duration,
		 * in which case flag will be set */
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			/* If we are gathering basictime as part of a list
			 * of additive times, we will save the value a few
			 * lines down from here. But in the normal case,
			 * we set basictime in the current GRPSYL. */
			if (Extra_time_p == 0) {
				 Curr_grpsyl_p->basictime = multiwhole2basictime((yyvsp[0].intval));
			}
		}
		/* If doing additive times, need to save value. */
		if (Extra_time_p != 0) {
			Extra_basictime = multiwhole2basictime((yyvsp[0].intval));
		}
	}
#line 7387 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 4752 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* check that a power of two from 1 to MAXBASICTIME */
		if (power_of2check((yyvsp[0].intval), "note basic time value") == NO) {
			/* force to a power to two, so that other code
			 * (like in expandgrp) that expect a sane value
			 * will not blow up. This may lead to a somewhat
			 * misleading "time does not add up to time
			 * signature" message, but we don't know what
			 * time they really meant, and this is better
			 * than pfataling. */
			(yyvsp[0].intval) = 2;
		}
		/* can't use rangecheck here because the error message would
		 * say 0 and -1 are valid times, which is only true internally--
		 * the user has to use 1/2, 1/4, 1/8, or m. */
		if ((yyvsp[0].intval) < MINBASICTIME || (yyvsp[0].intval) > MAXBASICTIME) {
			l_yyerror(Curr_filename, yylineno,
				"time value must be between 1 and %d, or 1/2 or 1/4 or 1/8 or m",
				MAXBASICTIME);
			/* If user entered outrageous value, clamp to
			 * something semi-reasonable, else we could get
			 * rational overflow, and pfatal, even though it
			 * it is really a user error. */
			if ((yyvsp[0].intval) > MAXBASICTIME * 4) {
				(yyvsp[0].intval) = MAXBASICTIME * 4;
			}
		}
		(yyval.ratval).n = 1;
		/* avoid division by zero */
		if ((yyvsp[0].intval) == 0) {
			(yyvsp[0].intval) = 1;
		}
		(yyval.ratval).d = (yyvsp[0].intval);
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			if (Curr_timelist_p == 0) {
				Curr_grpsyl_p->basictime = (yyvsp[0].intval);
			}
		}
		/* If doing additive times, need to save value */
		if (Extra_time_p != 0) {
			Extra_basictime = (yyvsp[0].intval);
		}
	}
#line 7436 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 4799 "src/mup/gram.y" /* yacc.c:1646  */
    {
		free_extra_time();
	}
#line 7444 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 4809 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Set basictime to what we saved in basic_time_val rule,
		 * then calculate fulltime from that and number of dots. */
		Curr_timelist_p->basictime = Extra_basictime;
		Curr_timelist_p->fulltime = calcfulltime((yyvsp[-1].ratval), (yyvsp[0].intval));
		/* handle subtracted times by negating the fulltime */
		if ((yyvsp[-3].intval) == -1) {
			Curr_timelist_p->fulltime = rneg(Curr_timelist_p->fulltime);
		}
	}
#line 7459 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 4823 "src/mup/gram.y" /* yacc.c:1646  */
    {
		struct TIMELIST *timelist_p;

		MALLOC(TIMELIST, timelist_p, 1);
		/* Add to end of linked list */
		timelist_p->next = 0;
		/* Init fulltime to something to avoid garbage if there
		 * is a user input error */
		timelist_p->fulltime = Zero;
		if (Extra_time_p == 0) {
			Last_alloced_timelist_p = Extra_time_p = timelist_p;
		}
		else {
			Curr_timelist_p->next = timelist_p;
		}
		/* Keep track of where to append next item to list, if any */
		Curr_timelist_p = timelist_p;
	}
#line 7482 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 4844 "src/mup/gram.y" /* yacc.c:1646  */
    {
		User_meas_time = NO;
	}
#line 7490 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 4850 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			Curr_grpsyl_p->is_meas = YES;
			User_meas_time = YES;
			Meas_rpt_type = MRT_SINGLE;
		}
		else {
			yyerror("'m' is not valid here");
		}
	}
#line 7506 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 4863 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MRT_SINGLE;
	}
#line 7514 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 4869 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MRT_DOUBLE;
	}
#line 7522 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 4875 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MRT_QUAD;
	}
#line 7530 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 4881 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 0;
	}
#line 7538 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 4887 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* count up the number of dots */
		(yyval.intval) = (yyvsp[-1].intval) + 1;
	}
#line 7547 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 4893 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* We can't distinguish between the default 0.0 and
		 * if user explicitly sets to 0.0, so if they set to 0.0
		 * then to something else, we won't catch that as setting
		 * twice, but that shouldn't be common. Besides, if they
		 * expect them to be additive, adding to zero will work
		 * as they expect... Because of roundoff, we can't do
		 * exact compare for specifying the same value more than once,
		 * so treat as identical if pretty close. */
		if (Curr_grpsyl_p->padding != 0.0 && 
				fabs(Curr_grpsyl_p->padding - ((yyvsp[0].floatval) * STEPSIZE))
				> 0.0001) {
			l_warning(Curr_filename, yylineno,
				"padding specified more than once; using last instance");
		}
		Curr_grpsyl_p->padding = (yyvsp[0].floatval) * STEPSIZE;
	}
#line 7569 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 4913 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (float) (yyvsp[-1].intval) * (yyvsp[0].floatval);
	}
#line 7577 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 4918 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no sign--must be a positive number */
		(yyval.intval) = 1;
	}
#line 7586 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 4925 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* user wants a negative number */
		(yyval.intval) = -1;
	}
#line 7595 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 4931 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_grpsyl_p->grpcont = GC_NOTES;
		if ((yyvsp[0].intval) == 0) {
			/* no notes listed, use same as previous group */
			copy_notes(Curr_grpsyl_p, Last_grpsyl_p);
		}
		else {
			resize_notelist(Curr_grpsyl_p);
		}
	}
#line 7610 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 4956 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* allocate GRPSYL for the case where everything is defaulted
		 * from the previous group, with just an extra attribute
		 * like ? or ~ specified. */
		if (Curr_grpsyl_p == (struct GRPSYL *) 0) {
			/* shouldn't ever happen, but just in case... */
			Curr_grpsyl_p = newGRPSYL(GS_GROUP);
		}
		if (Last_grpsyl_p != (struct GRPSYL *) 0 &&
					Last_grpsyl_p->nnotes >= 1) {
			copy_notes(Curr_grpsyl_p, Last_grpsyl_p);
		}
		else if (Last_grpsyl_p != (struct GRPSYL *) 0 && 
				Last_grpsyl_p->grpcont == GC_REST) {
			Curr_grpsyl_p->grpcont = GC_REST;
		}
	}
#line 7632 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 4976 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->grpcont == GC_NOTES &&
					Curr_grpsyl_p->nnotes > 0) {
			if (Curr_grpsyl_p->grpvalue == GV_ZERO) {
				Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]
						.notesize = GS_TINY;
			}
			else {
				Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]
						.notesize = GS_SMALL;
			}
		}
		else if (Curr_grpsyl_p->grpcont == GC_REST) {
			Curr_grpsyl_p->grpsize  = GS_SMALL;
		}
		else {
			yyerror("no note specified for '?'");
		}
	}
#line 7656 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 4998 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->grpcont != GC_NOTES) {
			yyerror("can't tie a rest or space");
		}
		else if (Curr_grpsyl_p->nnotes > 0) {
			struct NOTE *n_p;
			n_p = &(Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]);
			n_p->tie = YES;
			n_p->tiestyle = (yyvsp[-2].intval);
			n_p->tiedir = (yyvsp[-1].intval);
			n_p->tied_to_voice = (yyvsp[0].intval);
		}
		else {
			yyerror("no note specified for '~'");
		}
	}
#line 7677 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 5017 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->nnotes > 0) {
			switch (Curr_grpsyl_p->notelist
                                        [Curr_grpsyl_p->nnotes - 1].letter) {
			case PP_REST:
				/* If we haven't already allocated space for
				 * the restc array, so that now. It could
				 * already be allocated if user specified
				 * more than one tag. */
				if (Curr_grpsyl_p->restc == 0) {
					MALLOCA(float, Curr_grpsyl_p->restc, NUMCTYPE);
				}
				addsym((yyvsp[0].stringval), Curr_grpsyl_p->restc, CT_NOTE);
				break;
			case PP_SPACE:
			case PP_RPT:
			case PP_NO_PITCH:  /* this one not really possible */
				addsym((yyvsp[0].stringval), Curr_grpsyl_p->c, CT_GRPSYL);
				break;
			default:
				addsym((yyvsp[0].stringval), Curr_grpsyl_p->notelist
					[Curr_grpsyl_p->nnotes - 1].c, CT_NOTE);
				break;
			}
			var_valid();
		}
		else if (Curr_grpsyl_p->grpcont == GC_REST) {
			/* This should really never be hit anymore since
			 * chord-at-a-time code was added, but shouldn't
			 * hurt to leave it, just in case. */
			addsym((yyvsp[0].stringval), Curr_grpsyl_p->c, CT_GRPSYL);
			var_valid();
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"no note specified for location tag '%s'", (yyvsp[0].stringval));
		}
	}
#line 7720 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 5058 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* this is for bend on a non-tablature staff */
		if (Doing_tab_staff == YES) {
			yyerror("^ bend not allowed on tablature staff; use quoted bend string");
		}
		else {
			add_slurto(Curr_grpsyl_p, (yyvsp[-1].intval), (yyvsp[0].intval),
					Curr_grpsyl_p->nnotes - 1, L_NORMAL);
			if (Curr_grpsyl_p->nnotes > 0) {
				Curr_grpsyl_p->notelist
						[Curr_grpsyl_p->nnotes - 1]
						.is_bend = YES;
			}
		}
	}
#line 7740 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 5076 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* this is for a small bend (1/4 step) on a non-tab staff */
		if (Doing_tab_staff == YES) {
			yyerror("^/ not allowed on tablature staff; use quoted bend string");
		}
		else if (Curr_grpsyl_p != 0 && Curr_grpsyl_p->nnotes > 0) {
			Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]
					.smallbend = YES;
		}
	}
#line 7755 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 5089 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->grpcont == GC_NOTES &&
					Curr_grpsyl_p->nnotes > 0) {
			if ((Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]
					.headshape = get_shape_num((yyvsp[0].stringval) + 2))
					== HS_UNKNOWN) {
				l_yyerror(Curr_filename, yylineno,
					"'%s' is not a valid head shape name",
					ascii_str((yyvsp[0].stringval), YES, NO, TM_NONE));
			}
		}
		else {
			yyerror("no note specified for headshape");
		}
		FREE((yyvsp[0].stringval));
	}
#line 7776 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 5108 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->nnotes == 0) {
			l_yyerror(Curr_filename, yylineno,
				"noteleft must be specified after note");
		}
		/* This check relies on the fact that the PP_* values are > 'g' */
		else if (Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1].letter > 'g' ) {
			l_warning(Curr_filename, yylineno,
					"noteleft can only be specified on a note");
		}
		else {
			if (Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1].noteleft_string != 0) {
				l_warning(Curr_filename, yylineno,
					"noteleft specified more than once; using last");
  fprintf(stderr, "previous string was %s\n", Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes-1].noteleft_string);
			}
			Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1].noteleft_string = (yyvsp[0].stringval);
		}
	}
#line 7800 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 5141 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[-1].intval) + (yyvsp[0].intval);	/* total number of notes */
	}
#line 7808 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 5147 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 0;
	}
#line 7816 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 5153 "src/mup/gram.y" /* yacc.c:1646  */
    {
		switch ((yyvsp[0].intval)) {
		case PL_ABOVE:
			Curr_grpsyl_p->stemto = CS_ABOVE;
			break;
		case PL_BELOW:
			Curr_grpsyl_p->stemto = CS_BELOW;
			break;
		default:
			yyerror("cross staff stem must be with 'above' or 'below'");
			Curr_grpsyl_p->stemto = CS_SAME;
		}
		if ((yyvsp[-1].intval) == 0) {
			/* Maybe this wouldn't really hurt to allow,
			 * but it's rather silly--why would user bother to go
			 * to the trouble of saying there are cross staff stem
			 * notes, but then not list any?
			 */
			yyerror("cross-staff stem note list is empty");
		}

		/* It doesn't make sense to do "with r below" or "with s below"
		 * since we don't allow mixing rests and notes, and the only
		 * reason for CSS is for something that has a stem. */
		else if ((yyvsp[-1].intval) > 0) {
			int idx;
			int pitch;

			for (idx = FCNI(Curr_grpsyl_p);
					idx <= LCNI(Curr_grpsyl_p); idx++) {
				pitch = Curr_grpsyl_p->notelist[idx].letter;
				if (pitch == PP_REST || pitch == PP_SPACE) {
					yyerror("can't use with above/below on rest or space");
				}
			}
		}
		(yyval.intval) = (yyvsp[-1].intval);
	}
#line 7859 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 5193 "src/mup/gram.y" /* yacc.c:1646  */
    {
		CSSused = YES;
		Curr_grpsyl_p->stemto_idx = Curr_grpsyl_p->nnotes;
	}
#line 7868 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 5199 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* No notes.  If this is for the list of "normal" staff notes,
		 * and there are no "other" staff notes (for cross-staff stems),
		 * this means use the same notes as the last group. */
		(yyval.intval) = 0;
	}
#line 7879 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 5208 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* return number of notes in notelist */
		(yyval.intval) = (yyvsp[-2].intval) + 1;
	}
#line 7888 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 5217 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_note(Curr_grpsyl_p, (int) PP_REST, No_accs,
				USE_DFLT_OCTAVE, 0, NO, (char *) 0);
		if (Meas_rpt_type == MRT_DOUBLE || Meas_rpt_type == MRT_QUAD) {
			l_yyerror(Curr_filename, yylineno, "cannot use dbl/quad with mr");
		}
	}
#line 7900 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 5227 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* temporarily stash uncompressibility (NO in this case)
		 * in the octave field */
		add_note(Curr_grpsyl_p, (int) PP_SPACE, No_accs, NO,
							0, NO, (char *) 0);
		if (Curr_grpsyl_p->is_meas == YES && User_meas_time == YES) {
			l_warning(Curr_filename, yylineno,
				"specifying time value on measure space is pointless; ignoring");
		}
		if (Meas_rpt_type == MRT_DOUBLE || Meas_rpt_type == MRT_QUAD) {
			l_yyerror(Curr_filename, yylineno, "cannot use dbl/quad with ms");
		}
	}
#line 7918 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 5243 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* temporarily stash uncompressibility (YES in this case)
		 * in the octave field */
		add_note(Curr_grpsyl_p, (int) PP_SPACE, No_accs, YES,
							0, NO, (char *) 0);
		if (Curr_grpsyl_p->is_meas == YES && User_meas_time == YES) {
			l_warning(Curr_filename, yylineno,
				"specifying time value on measure uncollapsible space is pointless; ignoring");
		}
		if (Meas_rpt_type == MRT_DOUBLE || Meas_rpt_type == MRT_QUAD) {
			l_yyerror(Curr_filename, yylineno, "cannot use dbl/quad with mus");
		}
	}
#line 7936 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 5259 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->is_meas == YES) {
			if (User_meas_time == YES) {
				l_warning(Curr_filename, yylineno,
					"specifying time value on measure repeat is pointless; ignoring");
			}
		}
		else {
			yyerror("rpt can only be used with m");
		}
		add_note(Curr_grpsyl_p, (int) PP_RPT, No_accs, USE_DFLT_OCTAVE,
							0, NO, (char *) 0);
		Mrptused = YES;
		Curr_grpsyl_p->meas_rpt_type = Meas_rpt_type;
	}
#line 7956 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 5277 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == SINGLEBAR) {
			/* lexer thinks this is 'bar'
			 * but is really 'b' 'a' 'r' */
			keyword_notes(yytext);
		}
		else if ((yyvsp[0].intval) == ENDBAR) {
			/* lexer thinks this is 'endbar'
			 * but is really 'en' 'd' 'b' 'a' 'r' */
			add_acc("nat");
			add_note(Curr_grpsyl_p, (int) 'e', Curr_accs,
				USE_DFLT_OCTAVE, 0, NO, (char *) 0);
			keyword_notes(yytext + 2);
		}
		else {
			yyerror("bar type not valid here");
		}
	}
#line 7979 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 5298 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* lexer thinks this is 'grace' but really 'g' 'r' 'a' 'c' 'e' */
		keyword_notes(yytext);
	}
#line 7988 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 5305 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == ENDING_BARRED) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
#line 8002 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 5316 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == J_RAGPARA) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
#line 8016 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 5328 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == BRACELIST) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
#line 8030 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 5340 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == BASS) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
#line 8044 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 5352 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* in chord-at-time mode, lex could mistake useaccs
		 * for a 6-note chord: us e a c c s  */
		keyword_notes(yytext);
	}
#line 8054 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 5360 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1].note_has_paren = YES;
	}
#line 8062 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 5365 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_tab_staff == YES) {
			add_note(Curr_grpsyl_p, (yyvsp[-1].intval), No_accs, NOFRET, 0, NO, (yyvsp[0].stringval));
		}
		else {
			add_note(Curr_grpsyl_p, (yyvsp[-1].intval), No_accs, USE_DFLT_OCTAVE,
								0, NO, (yyvsp[0].stringval));
		}
	}
#line 8076 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 5377 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_tab_staff == YES) {
			l_warning(Curr_filename, yylineno,
				"parentheses around accidentals are extraneous on tab staffs; ignoring");
		}
		add_note(Curr_grpsyl_p, (yyvsp[-4].intval), Curr_accs, (yyvsp[0].intval), 0, YES, (char *) 0);
	}
#line 8088 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 5387 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_tab_staff == NO) {
			l_warning(Curr_filename, yylineno,
				"parentheses around octave are extraneous; ignoring");
		}
		add_note(Curr_grpsyl_p, (yyvsp[-4].intval), No_accs, (yyvsp[-2].intval), 0, YES, (yyvsp[0].stringval));
	}
#line 8100 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 5397 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Whoops! The left paren was really for a new note,
		 * which happens to be parenthesized. But beause yacc only
		 * looks ahead one token, it finds out too late. So we
		 * catch it here, push the parenthesis and pitch back into
		 * the input and return back to the parent grammar rule,
		 * since we now have complete note. */
		pushback(yytext[0]);
		pushback('(');
		add_note(Curr_grpsyl_p, (yyvsp[-2].intval), No_accs,
			(Doing_tab_staff ? NOFRET : USE_DFLT_OCTAVE),
			0, NO, (char *) 0);
	}
#line 8118 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 5413 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_note(Curr_grpsyl_p, (yyvsp[-4].intval), Curr_accs, (yyvsp[-1].intval), (yyvsp[-2].intval), NO, (yyvsp[0].stringval));
	}
#line 8126 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 5419 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_tab_staff == NO) {
			l_warning(Curr_filename, yylineno,
				"extraneous parentheses around octave; ignoring");
		}
		add_note(Curr_grpsyl_p, (yyvsp[-6].intval), Curr_accs, (yyvsp[-2].intval), (yyvsp[-4].intval), YES, (yyvsp[0].stringval));
	}
#line 8138 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 5429 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Whoops! The left paren was really for a new note,
		 * which happens to be parenthesized. But beause yacc only
		 * looks ahead one token, it finds out too late. So we
		 * catch it here, push the parenthesis and pitch back into
		 * the input and return back to the parent grammar rule,
		 * since we now have complete note. */
		pushback(yytext[0]);
		pushback('(');
		add_note(Curr_grpsyl_p, (yyvsp[-4].intval), Curr_accs,
			(Doing_tab_staff ? NOFRET : USE_DFLT_OCTAVE),
			(yyvsp[-2].intval), NO, (char *) 0);
	}
#line 8156 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 5445 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_note(Curr_grpsyl_p, (yyvsp[-3].intval), No_accs, (yyvsp[-1].intval), (yyvsp[-2].intval), NO, (yyvsp[0].stringval));
	}
#line 8164 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 5451 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_note(Curr_grpsyl_p, (yyvsp[-5].intval), No_accs, (yyvsp[-2].intval), (yyvsp[-4].intval), YES, (yyvsp[0].stringval));
	}
#line 8172 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 5457 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_tab_staff == YES && Curr_accs[0] != '\0') {
			yyerror("accidental must be before fret number");
		}
		add_note(Curr_grpsyl_p, (yyvsp[-3].intval), Curr_accs, (yyvsp[-2].intval), 0, NO, (yyvsp[0].stringval));
	}
#line 8183 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 5466 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_note(Curr_grpsyl_p, (yyvsp[-4].intval), Curr_accs, (yyvsp[-3].intval), 0, YES, (char *) 0);
	}
#line 8191 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 5472 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Whoops! The left paren was really for a new note,
		 * which happens to be parenthesized. But beause yacc only
		 * looks ahead one token, it finds out too late. So we
		 * catch it here, push the parenthesis and pitch back into
		 * the input and return back to the parent grammar rule,
		 * since we now have complete note. */
		pushback(yytext[0]);
		pushback('(');
		add_note(Curr_grpsyl_p, (yyvsp[-3].intval), No_accs, (yyvsp[-2].intval), 0, NO, (char *) 0);
	}
#line 8207 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 5485 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (char *) 0;
	}
#line 8215 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 5491 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_tab_staff == NO) {
			/* try to give helpful error message */
			if (get_shape_num((yyvsp[0].stringval) + 2) != HS_UNKNOWN) {
				yyerror("missing 'hs' before headshape string");
			}
			else if (strcmp((yyvsp[0].stringval) + 2, "full") == 0 || isdigit((yyvsp[0].stringval)[2])) {
				yyerror("bend string not allowed on non-tablature staff; use ^");
			}
			else {
				yyerror("unexpected string");
			}
			(yyval.stringval) = (char *) 0;
		}
	}
#line 8235 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 5508 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* return 'a' to 'g' value */
		(yyval.intval) = (int) *yytext;
	}
#line 8244 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 5514 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no accidental */
		(yyval.intval) = 0;
	}
#line 8253 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 5521 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8260 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 5525 "src/mup/gram.y" /* yacc.c:1646  */
    {
		clear_curr_accs();
	}
#line 8268 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 5531 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8275 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 5534 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no octave or fret designation */
		(yyval.intval) = (Doing_tab_staff ? NOFRET : USE_DFLT_OCTAVE);
	}
#line 8284 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 5541 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8291 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 5546 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8298 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 5550 "src/mup/gram.y" /* yacc.c:1646  */
    {
		clear_curr_accs();
	}
#line 8306 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 5555 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8313 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 5560 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8320 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 5565 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc("sharp");
	}
#line 8328 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 5571 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc("flat");
	}
#line 8336 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 5577 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc("nat");
	}
#line 8344 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 5583 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc("dblsharp");
	}
#line 8352 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 5589 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc("dblflat");
	}
#line 8360 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 5595 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc((yyvsp[-1].stringval) + 2);
		Tuning_used = YES;
	}
#line 8369 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 5602 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = '#';
	}
#line 8377 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 5608 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = '&';
	}
#line 8385 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 5614 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* natural */
		(yyval.intval) = 'n';
	}
#line 8394 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 5621 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* double sharp */
		(yyval.intval) = 'x';
	}
#line 8403 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 5628 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 'B';
	}
#line 8411 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 5634 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 8419 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 5640 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* we can't really fill in the actual octave yet, because
		 * it may be different on different staffs or voices, so
		 * we store the relative octave and fill in actual value
		 * later.
		 */
		/* this will be a negative number */
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 8433 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 5652 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* we can't really fill in the actual octave yet, because
		 * it may be different on different staffs or voices, so
		 * we store the relative octave and fill in actual value
		 * later.
		 */
		(yyval.intval) = USE_DFLT_OCTAVE + (yyvsp[0].intval);
	}
#line 8446 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 5662 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = -1;
	}
#line 8454 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 5668 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* count up the number of minus signs */
		(yyval.intval) = (yyvsp[-1].intval) - 1;
	}
#line 8463 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 5674 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 1;
	}
#line 8471 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 5680 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* count up the number of plus signs */
		(yyval.intval) = (yyvsp[-1].intval) + 1;
	}
#line 8480 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 5687 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_slurdir(Curr_grpsyl_p, Curr_grpsyl_p->nnotes - 1, (yyvsp[-1].intval), (yyvsp[0].intval));
	}
#line 8488 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 5694 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Linetype = (yyvsp[0].intval);
		begin_slur(Curr_grpsyl_p, Curr_grpsyl_p->nnotes - 1);
	}
#line 8497 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 5700 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* empty list. Only allowed if only one note in following
		 * group. However, we don't know that yet, so marked pitch
		 * as 'U' for unknown */
		add_slurto(Curr_grpsyl_p, 'U', USE_DFLT_OCTAVE,
				Curr_grpsyl_p->nnotes - 1, Linetype);
	}
#line 8509 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 5710 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_slurto(Curr_grpsyl_p, 0, (yyvsp[0].intval), Curr_grpsyl_p->nnotes - 1,
						Linetype);
	}
#line 8518 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 5728 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_tab_staff == YES) {
			yyerror("cannot specify string inside <> on tab staffs");
		}
		else {
			add_slurto(Curr_grpsyl_p, (yyvsp[-1].intval), (yyvsp[0].intval),
					Curr_grpsyl_p->nnotes - 1, Linetype);
		}
	}
#line 8532 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 5740 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save address associated with entire group */
		if ( (yyvsp[0].stringval) != (char *) 0) {
			addsym((yyvsp[0].stringval), Curr_grpsyl_p->c, CT_GRPSYL);
			var_valid();
		}
	}
#line 8544 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 5749 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8552 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 5755 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* a-g are usually pitches, but in this context, they
		 * are 1-character variable names. */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8562 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 5763 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* usually m means measure, but here it is the variable m */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8571 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 5770 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* usually rest, here variable r */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8580 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 5777 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* usually space, here variable s */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8589 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 5784 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* usually uncompressible, here variable u */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8598 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 5791 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* usually natural, here variable n */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8607 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 5798 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* usually double sharp, here variable x */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8616 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 5805 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* tag name with more than one character */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8625 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 5812 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(void) sprintf(Stringbuff + strlen((yyvsp[-2].stringval)), ".%d", (yyvsp[0].intval));
		(yyval.stringval) = Stringbuff;
	}
#line 8634 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 5819 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* tag name with more than one character */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8643 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 5826 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_tuplet((yyvsp[-4].intval), (yyvsp[-2].ratval), (yyvsp[-3].intval), (yyvsp[-5].intval), (yyvsp[-1].floatval));
		Getting_tup_dur = NO;
	}
#line 8652 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 5832 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* nothing -- use default of when to print tuplet number/bracket */
		(yyval.intval) = PT_DEFAULT;
	}
#line 8661 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 5839 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* don't print tuplet or bracket */
		(yyval.intval) = PT_NEITHER;
	}
#line 8670 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 5846 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* print number only */
		(yyval.intval) = PT_NUMBER;
	}
#line 8679 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 5853 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (*yytext == 'y') {
			(yyval.intval) = PT_BOTH;
		}
		else {
			yyerror("tuplet number/bracket qualifier must be y or n or num");
		}
	}
#line 8692 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 5865 "src/mup/gram.y" /* yacc.c:1646  */
    {
		begin_tuplet();
	}
#line 8700 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 5870 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Getting_tup_dur = YES;
	}
#line 8708 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 5875 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = PL_UNKNOWN;
	}
#line 8716 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 5881 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (yylval.intval == PL_BETWEEN) {
			yyerror("between not allowed for tuplet side");
			(yyval.intval) = PL_UNKNOWN;
		}
	}
#line 8727 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 5889 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* optional time value is missing */
		(yyval.ratval).n = 0;
		(yyval.ratval).d = 1;
	}
#line 8737 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 5897 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.ratval) = (yyvsp[0].ratval);
	}
#line 8745 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 5903 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = NOTUPLETANGLE;
	}
#line 8753 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 5908 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyvsp[0].floatval) *= (yyvsp[-1].intval);
		if (frangecheck((yyvsp[0].floatval), MINTUPLETANGLE, MAXTUPLETANGLE, "slope") == YES) {
			(yyval.floatval) = (yyvsp[0].floatval);
		}
		else {
			(yyval.floatval) = NOTUPLETANGLE;
		}
	}
#line 8767 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 5920 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8774 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 5924 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Last_grpsyl_p = Curr_grpsyl_p = (struct GRPSYL *) 0;
	}
#line 8782 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 5929 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* If user does "all" without specifying a place,
		 * all() will call dflt_place() which was really intended
		 * to only handle STUFF. So we have to tell it we have lyrics,
		 * not a true STUFF. */
		set_stuff_type(-1);
	}
#line 8794 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 5938 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Using_staff = -1;
		Using_voice = -1;
	}
#line 8803 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 5945 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Using_staff = (yyvsp[0].intval);
		Using_voice = 1;
	}
#line 8812 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 5952 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Using_staff = (yyvsp[-1].intval);
		Using_voice = (yyvsp[0].intval);
	}
#line 8821 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 5958 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* empty, use default */
		begin_range(PL_UNKNOWN);
		(yyval.intval) = PL_UNKNOWN;
	}
#line 8831 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 5966 "src/mup/gram.y" /* yacc.c:1646  */
    {
		begin_range((yyvsp[0].intval));
	}
#line 8839 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 5971 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval)= PL_UNKNOWN;
	}
#line 8847 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 5977 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == PL_BETWEEN) {
			yyerror("place for ph, if specified, must be above or below, not between");
		}
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 8858 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 5988 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* means goes above or below all the staffs, regardless if
		 * some happen to be invisible at the moment, so find top
		 * or bottom visible staff as appropriate,and save that
		 * away as the staff range */
		all();
	}
#line 8870 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 6001 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* if staff_range == 0, then only one staff specified, so
		 * use first staff number for both beginning and end of range */
		save_staff_range((yyvsp[-1].intval), ((yyvsp[0].intval) == 0 ? (yyvsp[-1].intval) : (yyvsp[0].intval)) );
	}
#line 8880 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 6008 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* empty */
		chk_range_type(NO);
		(yyval.intval) = 0;
	}
#line 8890 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 6016 "src/mup/gram.y" /* yacc.c:1646  */
    {
		chk_range_type(NO);
		(yyval.intval) = (yyvsp[0].intval);
		if ((yyvsp[0].intval) == 0) {
			yyerror("staff of 0 is illegal");
		}
	}
#line 8902 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 6026 "src/mup/gram.y" /* yacc.c:1646  */
    {
		chk_range_type(YES);
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 8911 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 6035 "src/mup/gram.y" /* yacc.c:1646  */
    { Place = (yyvsp[0].intval); }
#line 8917 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 6040 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8924 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 6045 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (*yytext != 'c') {
			yyerror("verse must be 'c' or number(s)");
		}
		else {
			save_vno_range(0, 0);
		}
	}
#line 8937 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 6056 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8944 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 6061 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8951 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 6066 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* if end of range is 0, not really a range, use first number
		 * for both beginning and end */
		lyr_verse((yyvsp[-1].intval), ((yyvsp[0].intval) == 0 ? (yyvsp[-1].intval) : (yyvsp[0].intval)));
	}
#line 8961 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 6073 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* empty */
		(yyval.intval) = 0;
	}
#line 8970 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 6080 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 8978 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 6085 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* null token to allocate a GRPSYL for a lyric */
		Last_grpsyl_p = Curr_grpsyl_p;
		Curr_grpsyl_p = newGRPSYL(GS_SYLLABLE);
		if (Last_grpsyl_p == (struct GRPSYL *) 0) {
			Lyrics_p = Curr_grpsyl_p;
		}
	}
#line 8991 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 6095 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* If user didn't specify a place, fix that. */
		if (Place == PL_UNKNOWN) {
			Place = PL_BELOW;
		}
		/* copies of the lyrics info has been made for all staffs/verses
		 * at this point, so get rid of master copy */
		free_grpsyls(Lyrics_p);
	}
#line 9005 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 6106 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* empty -- need to derive times from music */
		Lyrics_p = derive_lyrtime();
	}
#line 9014 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 6113 "src/mup/gram.y" /* yacc.c:1646  */
    {
		not_derived();
	}
#line 9022 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 6128 "src/mup/gram.y" /* yacc.c:1646  */
    {
		link_notegroup(Curr_grpsyl_p, Last_grpsyl_p);
		/* Save pointer to current GRPSYL in case the next
		 * group gets its time value based on this one,
		 * and there are additive times on this one. */
		Prev_grpsyl_p = Curr_grpsyl_p;
		/* If there are additive times, add those in.
		 * We don't need to make extra groups for lyrics, because we
		 * don't need to tie groups together--the lyrics time
		 * can hold any legal RATIONAL, even those that aren't
		 * specifiable with a single time value. */
		if (Extra_time_p != 0) {
			struct TIMELIST *timelist_p;
			for (timelist_p = Extra_time_p; timelist_p != 0;
						timelist_p = timelist_p->next) {
				Curr_grpsyl_p->fulltime = radd(Curr_grpsyl_p->fulltime, timelist_p->fulltime);
			}
		}
	}
#line 9046 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 6150 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 9053 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 6154 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_tuplet((yyvsp[-1].intval), (yyvsp[0].ratval), NO, PL_UNKNOWN, NOTUPLETANGLE);
		Getting_tup_dur = NO;
	}
#line 9062 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 6160 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* empty, will fill in an actual syllable later */
		Curr_grpsyl_p->syl = (char *) 0;
	}
#line 9071 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 6167 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* space, not a lyric, so mark for later use */
		Curr_grpsyl_p->grpcont = GC_SPACE;
	}
#line 9080 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 6180 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* If no [verseno] is specified, use -1 as special flag
		 * to be resolved later to "one more than previous",
		 * or if there wasn't a previous, to verse 1.
		 */
		lyr_verse(-1, -1);
		proc_lyrics(Lyrics_p, (yyvsp[-1].stringval));
	}
#line 9093 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 6191 "src/mup/gram.y" /* yacc.c:1646  */
    {
		proc_lyrics(Lyrics_p, (yyvsp[-1].stringval));
	}
#line 9101 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 6196 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* If user set measnum=every N and did not already put some
		 * kind of reh mark on this bar, and this measure is a
		 * multiple of N, we add a mnum mark,
		 * but using measnumstyle */
		if (Currstruct_p != 0 && IS_EVERY(Score.measnum) &&
				Currstruct_p->u.bar_p->reh_type == REH_NONE &&
				Meas_num % Score.measnum == 0) {
			Currstruct_p->u.bar_p->reh_type = REH_BAR_MNUM;
			/* Do like the code in set_reh_string() except use the
			 * measnum* parameters for family, font, and size. */
			Currstruct_p->u.bar_p->reh_string =
					copy_string(num2str(Meas_num) + 2,
                        		Score.measnumfamily + Score.measnumfont,
                        		Score.measnumsize);
		}

		Currstruct_p = (struct MAINLL *) 0;
		/* If there are alternating time signature,
		 * add an implicit time signature SSV for the
		 * next time signature in the list.
		 */
		if (Alt_timesig_list != 0) {
			end_prev_context();
			Context = C_SCORE;
			Currstruct_p = newMAINLLstruct(S_SSV, -1);
			Currstruct_p->u.ssv_p->context = Context;
			if (Tsig_visibility == PTS_ALWAYS &&
					Next_alt_timesig != Alt_timesig_list) {
				/* If user wants alternating time signatures
				 * printed on every measure, if there is
				 * a multirest, we will print multiple
				 * time signatures there, and might have to
				 * wrap around to the beginning of the list.
				 * So make a copy of the entire list,
				 * starting from wherever we are now,
				 * wrapping around to the beginning,
				 * and ending just before where we are now.
				 * Most of the time,
				 * there probably won't be a multirest,
				 * so this will be a waste, but unfortunately,
				 * we don't know yet whether there will be
				 * one or not, so need to do the whole list
				 * just in case.
				 *
				 * Calculate length of the two pieces:
				 * from where we are to end, and from
				 * beginning to where we are.
				 */
				int remlength;
				int wraplength;
				remlength = strlen(Next_alt_timesig);
				wraplength = strlen(Alt_timesig_list)
						- remlength;
				/* need one more for terminator. */
				MALLOCA(char, Currstruct_p->u.ssv_p->timerep,
						remlength + wraplength + 1);

				/* copy remainder into beginning */
				strcpy(Currstruct_p->u.ssv_p->timerep,
						Next_alt_timesig);
				/* copy the wrap-around part of list,
				 * but move the TSR_ALTERNATING from the
				 * end of that part to between the two parts */
				Currstruct_p->u.ssv_p->timerep[remlength]
						= TSR_ALTERNATING;
				strncpy(Currstruct_p->u.ssv_p->timerep +
						remlength + 1, Alt_timesig_list,
						wraplength - 1);
				/* Add the terminator */
				Currstruct_p->u.ssv_p->timerep
						[remlength + wraplength]
						= TSR_END;

				assign_timesig(Currstruct_p, PTS_ALWAYS,
							&Next_alt_timesig);


				/* Make this new copy the new
				 * head of the list */
				Alt_timesig_list =
						Currstruct_p->u.ssv_p->timerep;
			}
			else {
				/* make a copy of the remaining alternating
				 * signatures and assign that */
				MALLOCA(char, Currstruct_p->u.ssv_p->timerep,
					strlen(Next_alt_timesig) + 1);
				strcpy(Currstruct_p->u.ssv_p->timerep,
							Next_alt_timesig);
				assign_timesig(Currstruct_p,
					(Tsig_visibility == PTS_ALWAYS ?
					PTS_ALWAYS : PTS_NEVER),
					&Next_alt_timesig);

				/* If we reached end of list, start over */
				if (Next_alt_timesig == 0) {
					Next_alt_timesig = Alt_timesig_list;
				}
			}

			asgnssv(Currstruct_p->u.ssv_p);
			end_prev_context();
			Context = C_MUSIC;
		}
	}
#line 9212 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 6311 "src/mup/gram.y" /* yacc.c:1646  */
    {
		struct MAINLL * mll_p;
		char *name;


		name = ((yyvsp[0].intval) == YES ? "newpage" : "newscore");

		(void) contextcheck(C_MUSIC | C_BLOCK, name);
		if (Mainlltc_p != 0 && Mainlltc_p->str == S_FEED) {
			/* Must be in block; Last thing on the list is a
			 * FEED, and it is illegal to have two FEEDs in a
			 * row, we just reuse the existing */
			Currstruct_p = Mainlltc_p;
			/* If this need feed is a pagefeed, set that in the
			 * existing struct. If not, leave it however it was.
			 * Otherwise if it was already a pagefeed, we would
			 * be downgrading, and we probably want to max */
			if ((yyvsp[0].intval) == YES) {
				Currstruct_p->u.feed_p->pagefeed = (yyvsp[0].intval);
			}
		}
		else {
			Currstruct_p = newMAINLLstruct(S_FEED, yylineno);
			Currstruct_p->u.feed_p->pagefeed = (yyvsp[0].intval);
		}

		/* make sure we're not in the middle of a measure. Go
		 * backwards in main list. If we hit STAFF before a BAR,
		 * then there is a problem.
		 */
		for (mll_p = Mainlltc_p; mll_p != (struct MAINLL *) 0;
					mll_p = mll_p->prev) {

			if (mll_p->str == S_BAR) {
				break;
			}
			else if (mll_p->str == S_STAFF) {
				l_yyerror(Curr_filename, yylineno,
					"%s not allowed in middle of measure",
					name);
				break;
			}
			else if (mll_p->str == S_FEED) {
				struct MAINLL *m_p;
				/* Need to look backwards for blocks, but need
				 * to ignore any SSVs that are in between */
				for (m_p = mll_p->prev;
						m_p != 0 && m_p->str == S_SSV;
						m_p = m_p->prev) {
					;
				}
				if (m_p != 0 && m_p->str == S_BLOCKHEAD) {
					/* This is a feed following a block.
					 * If it was an implicit feed,
					 * we can get rid of it, because
					 * user now put an explicit one.
					 */
					if (mll_p->inputlineno == -1) {
						unlinkMAINLL(mll_p);
						FREE(mll_p);
					}
					/* We must be in block context,
					 * so no need to check farther back.
					 */
					break;
				}
				else {
					l_yyerror(Curr_filename, yylineno,
						"consecutive newscore/newpage not allowed");
				}
				break;
			}
		}

		/* If inside a "samescore" zone, doing a feed is contradictory */
		if (Doing_samescore == YES) {
			l_yyerror(Curr_filename, yylineno,
				"cannot have a %s inside a samescore zone",
				name);
		}

		/* If inside a "samepage" zone, doing a page feed
		 * is contradictory, though a scorefeed is okay. */
		if ( (Doing_samepage == YES) && ((yyvsp[0].intval) == YES) ) {
			l_yyerror(Curr_filename, yylineno,
				"cannot have a pagefeed inside a samepage zone");
		}

		/* Add to main list, unless reusing the tail cell FEED */
		if (Currstruct_p != Mainlltc_p) {
			insertMAINLL(Currstruct_p, Mainlltc_p);
		}

		/* If this is inside a block, we need to create a new block
		 * and feed after it.
		 */
		if (Context == C_BLOCK) {
			CALLOC(BLOCKHEAD, Currblock_p, 1);
			set_win_coord(Currblock_p->c);
			Next_print_link_p_p = &(Currblock_p->printdata_p);
			insertMAINLL(newMAINLLstruct(S_BLOCKHEAD, yylineno),
						Mainlltc_p);
			Mainlltc_p->u.blockhead_p = Currblock_p;
			insertMAINLL(newMAINLLstruct(S_FEED, -1), Mainlltc_p);
		}

	}
#line 9324 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 6419 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Currstruct_p = (struct MAINLL *) 0;
	}
#line 9332 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 6425 "src/mup/gram.y" /* yacc.c:1646  */
    {
		char *name;

		name = ((yyvsp[0].intval) == YES ? "samescorebegin" : "samescoreend");
		(void) contextcheck(C_MUSIC, name);

		if ( ((yyvsp[0].intval) == YES) && (Doing_samescore == YES) ) {
			l_yyerror(Curr_filename, yylineno,
				"cannot nest samescorebegin zones");
		}
		if ((yyvsp[0].intval) == NO) {
			if (Doing_samescore == NO) {
				l_yyerror(Curr_filename, yylineno,
					"cannot have samescoreend without previous matching samescorebegin");
			}
			else {
				/* Need to undo the samescore setting on the
				 * most recent bar. */
				struct MAINLL *mll_p;

				for (mll_p = Mainlltc_p; mll_p != 0;
							mll_p = mll_p->prev) {
					if (mll_p->str == S_BAR) {
						mll_p->u.bar_p->samescore = NO;
						break;
					}
				}
			}
		}
		Doing_samescore = (yyvsp[0].intval);
	}
#line 9368 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 6459 "src/mup/gram.y" /* yacc.c:1646  */
    {
		char *name;

		name = ((yyvsp[0].intval) == YES ? "samepagebegin" : "samepageend");
		(void) contextcheck(C_MUSIC | C_BLOCK, name);

		if ( ((yyvsp[0].intval) == YES) && (Doing_samepage == YES) ) {
			l_yyerror(Curr_filename, yylineno,
				"cannot nest samepagebegin zones");
		}
		if ((yyvsp[0].intval) == NO) {
			if (Doing_samepage == NO) {
				l_yyerror(Curr_filename, yylineno,
					"cannot have samepageend without previous matching samespagebegin");
			}
			else {
				/* Need to undo the samescore setting on the
				 * most recent bar or block. */
				struct MAINLL *mll_p;

				for (mll_p = Mainlltc_p; mll_p != 0;
							mll_p = mll_p->prev) {
					if (mll_p->str == S_BAR) {
						mll_p->u.bar_p->samepage = NO;
						break;
					}
					else if (mll_p->str == S_BLOCKHEAD) {
						mll_p->u.blockhead_p->samepage = NO;
						break;
					}
				}
			}
		}
		Doing_samepage = (yyvsp[0].intval);
	}
#line 9408 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 6514 "src/mup/gram.y" /* yacc.c:1646  */
    {
		int mot;	/* margin override type */

		if ((yyvsp[-1].intval) == 0) {
			/* User didn't specify a sign, so this is an
			 * absolute, not relative value. Or auto. */
			if ((yyvsp[0].floatval) == MG_AUTO) {
				mot = MOT_AUTO;
			}
			else {
				mot = MOT_ABSOLUTE;
			}
		}
		else {
			mot = MOT_RELATIVE;
		}

		if ((yyvsp[0].floatval) > 0.0) {
			(yyvsp[-1].intval) = adjust2inches((yyvsp[-1].intval));	/* in case we are in centimeter mode */
		}
		if ((yyvsp[-3].intval) == RIGHTMARGIN) {
			if (Currstruct_p->u.feed_p->right_mot != MOT_UNUSED) {
				l_warning(Curr_filename, yylineno,
					"rightmargin specified more than once, using last instance");
				/* fall through to override the previous */
			}
			if (mot == MOT_ABSOLUTE) {
				Currstruct_p->u.feed_p->rightmargin = (yyvsp[0].floatval);
			}
			else if (mot == MOT_RELATIVE) {
				Currstruct_p->u.feed_p->rightmargin
						= Score.rightmargin + (yyvsp[-1].intval) * (yyvsp[0].floatval);
				/* Even if user specified as relative,
				 * we have now converted to absolute */
				mot = MOT_ABSOLUTE;
			}
			Currstruct_p->u.feed_p->right_mot = mot;
		}
		else if ((yyvsp[-3].intval) == LEFTMARGIN) {
			if (mot == MG_AUTO) {
				l_warning(Curr_filename, yylineno,
					"auto can only be used with rightmargin, not leftmargin; ignoring");
				mot = MOT_UNUSED;
			}
			if (Currstruct_p->u.feed_p->left_mot != MOT_UNUSED) {
				l_warning(Curr_filename, yylineno,
					"leftmargin specified more than once, using last instance");
				/* fall through to override the previous */
			}
			if (mot == MOT_ABSOLUTE) {
				Currstruct_p->u.feed_p->leftmargin = (yyvsp[0].floatval);
			}
			else if (mot == MOT_RELATIVE) {
				Currstruct_p->u.feed_p->leftmargin
						= Score.leftmargin + (yyvsp[-1].intval) * (yyvsp[0].floatval);
				/* Even if user specified as relative,
				 * we have now converted to absolute */
				mot = MOT_ABSOLUTE;
			}
			Currstruct_p->u.feed_p->left_mot = mot;
		}
		else {
			yyerror("unexpected parameter; only 'leftmargin' or 'rightmargin' allowed here");
		}
		chkmargin(Score.topmargin, Score.botmargin,
				Currstruct_p->u.feed_p->leftmargin,
				Currstruct_p->u.feed_p->rightmargin);
	}
#line 9481 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 6584 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (yyvsp[0].floatval);
	}
#line 9489 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 6590 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = MG_AUTO;
	}
#line 9497 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 6596 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ( SEP_IS_VALID(Currstruct_p->u.feed_p->scoresep) ) {
			l_warning(Curr_filename, yylineno, "scoresep specified more than once, last being used");
		}
		if ( Currstruct_p->u.feed_p->pagefeed == YES) {
			l_warning(Curr_filename, yylineno, "scoresep ignored on newpage; only used on newscore");
		}
		frangecheck((yyvsp[0].floatval), -MAXSEPVAL, MAXSEPVAL, "scoresep value");
		Currstruct_p->u.feed_p->scoresep = (yyvsp[-1].intval) *(yyvsp[0].floatval);
	}
#line 9512 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 6627 "src/mup/gram.y" /* yacc.c:1646  */
    {

		/* build a BAR struct and add it to the main list */
		if (contextcheck(C_MUSIC, "bar") == YES) {

			Currstruct_p = add_bar((yyvsp[0].intval), (yyvsp[-2].intval), Endingloc,
						Endending_type, Mainlltc_p);
			Got_ending = NO;
			Currstruct_p->u.bar_p->samescore = Doing_samescore;
			Currstruct_p->u.bar_p->samepage = Doing_samepage;
		}
		if ((yyvsp[0].intval) == RESTART && Endingloc != NOITEM) {
			yyerror("restart cannot be used inside an ending");
		}

		/* User can specify bar type to use on preceding staff when
		 * a repeatstart gets moved to the next scores's pseudo-bar */
		if ((yyvsp[-1].intval) != -1) {
			if ((yyvsp[0].intval) != REPEATSTART) {
				l_warning(Curr_filename, yylineno,
					"bar type for preceding score only allowed on repeatstart; ignoring");
			}
			else if (Currstruct_p != 0 && Currstruct_p->u.bar_p != 0) {
				Currstruct_p->u.bar_p->precbartype = (yyvsp[-1].intval);
				if ((yyvsp[-1].intval) != SINGLEBAR && (yyvsp[-1].intval) != DOUBLEBAR &&
						(Linetype == L_DASHED ||
						Linetype == L_DOTTED)) {
					l_warning(Curr_filename, yylineno,
						"dashed/dotted only allowed on bar or dblbar; ignoring");
					Linetype = L_NORMAL;
				}
				Currstruct_p->u.bar_p->linetype = Linetype;
			}
		}
		else {
			/* Default is single bar. It could be argued that in
			 * the case of a key change on this bar, it really
		 	 * should be a dblbar, but user can force that
			 * if they want it. */
			if (Currstruct_p != 0 && Currstruct_p->u.bar_p != 0) {
				Currstruct_p->u.bar_p->precbartype = SINGLEBAR;
			}
		}
		/* Placement phase indirectly uses Doing_tab_staff when it
		 * calls notecomp, so clear it in case we don't get a
		 * non-tab staff input before the end of file.
		 * We could probably get by just doing after parsing is done,
		 * but this seems cleaner, and cheap enough.
		 */
		Doing_tab_staff = NO;
	}
#line 9568 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 6681 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = -1;	/* special value to mean "none specified" */
		Linetype = L_NORMAL;
	}
#line 9577 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 6688 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Parens wouldn't be strictly necessary to be able to parse,
		 * but seem useful semantically to make it clear this is
		 * optional, only applying when repeatstart is moved to
		 * next score's pseudo bar. */
		(yyval.intval) = (yyvsp[-1].intval);
		if ((yyvsp[-2].intval) == L_DOTTED || (yyvsp[-2].intval) == L_DASHED) {
			if ((yyvsp[-1].intval) != SINGLEBAR && (yyvsp[-1].intval) != DOUBLEBAR) {
				l_warning(Curr_filename, yylineno,
					"Only bar or dblbar can be dashed or dotted; ignoring");
			}
			else {
				Linetype = (yyvsp[-2].intval);
			}
		}
		else if ((yyvsp[-2].intval) != L_NORMAL) {
			l_warning(Curr_filename, yylineno,
					"Bar line type modifier can only can be dashed or dotted; ignoring");
		}
	}
#line 9602 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 6710 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Call proc_emptymeas() to free up the last buffer, if any,
		 * and return back to normal input stream. */
		proc_emptymeas(MAXSTAFFS+1);
		(yyval.intval) = (yyvsp[-1].intval);
	}
#line 9613 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 6718 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* If there was any empty voices in the input for this
		 * measure which have emptymeas parameter set,
		 * proc_emptymeas() will arrange to create just-in-time
		 * virtual input for it that will get parsed via
		 * the emptymeas_input rule.
		 * We pass arg of 1 to tell it to start looking from
		 * staff 1. Subsequent calls to proc_emptymeas(), if any,
		 * will generate input for additional voices, until
		 * no more are needed for this measure.
		 */
		if ((yyvsp[0].intval) != RESTART) {
			EM_staff = proc_emptymeas(1);
		}
		else {
			/* don't create any music before a restart */
			EM_staff = MAXSTAFFS + 1;
		}
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 9638 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 6740 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 9645 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 6745 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* See if there is any more virtual input needed */
		EM_staff = proc_emptymeas(EM_staff);
	}
#line 9654 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 6758 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->padding += (yyvsp[0].floatval) * STEPSIZE;
		}
	}
#line 9664 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 6766 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			/* fill in location info */
			if ((yyvsp[0].stringval) != (char *) 0) {
				addsym((yyvsp[0].stringval), Currstruct_p->u.bar_p->c, CT_BAR);
			}
		}
	}
#line 9677 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 6777 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Got_ending == YES) {
			yyerror("Only one ending allowed per bar");
		}
		Got_ending = YES;

		if (Currstruct_p != (struct MAINLL *) 0) {
			if (Currstruct_p->u.bar_p->bartype == RESTART) {
				yyerror("ending not allowed on restart");
			}
			/* fill in ending label if any */
			Currstruct_p->u.bar_p->endinglabel = (yyvsp[0].stringval);
			Currstruct_p->u.bar_p->endingloc = Endingloc;
			Currstruct_p->u.bar_p->endending_type = Endending_type;
			ped_endings(Endingloc);

			/* for next time around, figure out what endingloc will
			 * be if user doesn't specify something different */
			switch (Endingloc) {
			case STARTITEM:
				Endingloc = INITEM;
				break;
			case ENDITEM:
				Endingloc = NOITEM;
				break;
			default:
				break;
			}
		}
	}
#line 9712 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 6810 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.bar_p->bartype == RESTART) {
				l_warning(Curr_filename, yylineno,
					"hidechanges not allowed on restart; ignoring");
			}
			else {
				Currstruct_p->u.bar_p->hidechanges = YES;
			}
		}
	}
#line 9728 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 6823 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			set_mnum(Currstruct_p->u.bar_p, (yyvsp[0].intval));
		}
	}
#line 9738 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 6830 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			int newval;

			newval = Meas_num + ((yyvsp[-1].intval) * (yyvsp[0].intval));
			if (newval < 1) {
				l_warning(Curr_filename, yylineno,
				"resulting measure number of %d is less than 1; using 1", newval);
				newval = 1;
			}
			set_mnum(Currstruct_p->u.bar_p, newval);
		}
	}
#line 9756 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 6845 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* +2 to skip font/size */
		init_reh(-1, (yyvsp[0].stringval) + 2, Currstruct_p);
	}
#line 9765 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 6851 "src/mup/gram.y" /* yacc.c:1646  */
    {
		init_reh((yyvsp[0].intval), (char *)0, Currstruct_p);
	}
#line 9773 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 6857 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0 && Currstruct_p->str == S_BAR) {
			if (Currstruct_p->u.bar_p->reh_string != 0) {
				/* This indicates user specified multiple
				 * rehearsal strings. We would have already
				 * given a warning message. */
				FREE(Currstruct_p->u.bar_p->reh_string);
				Currstruct_p->u.bar_p->reh_string = 0;
			}
			set_reh_string(Currstruct_p->u.bar_p, (yyvsp[-4].intval), (yyvsp[-3].intval), (yyvsp[-2].intval), (yyvsp[-1].stringval));
			Currstruct_p->u.bar_p->dist = Dist;
			Currstruct_p->u.bar_p->dist_usage = Dist_usage;
		}
	}
#line 9792 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 6874 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (yyvsp[0].stringval);
		(void) fix_string((yyvsp[0].stringval), FONT_TR, DFLT_SIZE, Curr_filename, yylineno);
		Endingloc = STARTITEM;
		Endending_type = EE_DEFAULT;
	}
#line 9803 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 6883 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Endingloc == NOITEM) {
			l_warning(Curr_filename, yylineno,
				"no ending in progress; extraneous 'endending' ignored");
			Endending_type = EE_DEFAULT;
		}
		else {
			Endingloc = ENDITEM;
			Endending_type = (yyvsp[0].intval);
		}
		(yyval.stringval) = (char *) 0;
	}
#line 9820 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 6897 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* null token to check for more than one rehearsal mark
		 * on one BAR */
		if (Currstruct_p != (struct MAINLL *) 0 &&
				Currstruct_p->u.bar_p->reh_type != REH_NONE) {
			l_warning(Curr_filename, yylineno,
				"only one rehearsal mark allowed per bar; using last");
		}
	}
#line 9834 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 6908 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_STRING;
		}
	}
#line 9844 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 6916 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_MNUM;
		}
		(yyval.stringval) = (char *) 0;
	}
#line 9855 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 6925 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_NUM;
		}
		(yyval.stringval) = (char *) 0;
	}
#line 9866 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 6934 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_LET;
		}
		(yyval.stringval) = (char *) 0;
	}
#line 9877 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 6942 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.inpcoord_p) = (yyvsp[-4].inpcoord_p);
		(yyvsp[-4].inpcoord_p)->hexpr_p = (yyvsp[-3].expr_p);
		(yyvsp[-4].inpcoord_p)->vexpr_p = (yyvsp[-1].expr_p);
	}
#line 9887 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 6949 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* null token to allocate an INPCOORD */
		CALLOC(INPCOORD, Curr_loc_info_p, 1);
		(yyval.inpcoord_p) = Curr_loc_info_p;
		/* set to positive in case input starts with an absolute
		 * x coordinate */
		Plus_minus = 1;
	}
#line 9900 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 6959 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = Plus_minus = 1;
	}
#line 9908 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 6965 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = Plus_minus = -1;
	}
#line 9916 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 6972 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = (yyvsp[0].expr_p);
		Curr_timeref_tag_p = 0;
	}
#line 9925 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 6980 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = (yyvsp[0].expr_p);

		/* Put lex back into normal (not coord arithemetic) mode */
		set_lex_mode(NO);
	}
#line 9936 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 6989 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Put lex into special mode to return different tokens
		 * for arithmetic operators. This is just in case the
		 * precedence rules might mess up other rules if we used
		 * the same tokens. The + - * / symbols are used for very
		 * different things elsewhere in the grammer, where
		 * precedence doesn't make sense. It probably wouldn't hurt,
		 * but it seems better to be safe, and only do the precedence
		 * when really needed.
		 */
		set_lex_mode(YES);
		Curr_timeref_tag_p = 0;
	}
#line 9954 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 7007 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = (yyvsp[-1].expr_p);
	}
#line 9962 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 7013 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = newnode((yyvsp[-1].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[-2].expr_p);
		(yyval.expr_p)->right.rchild_p = (yyvsp[0].expr_p);
	}
#line 9972 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 7021 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = newnode((yyvsp[-1].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[-2].expr_p);
		(yyval.expr_p)->right.rchild_p = (yyvsp[0].expr_p);
	}
#line 9982 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 7029 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].intval) == OP_SUB) {
			(yyval.expr_p) = newnode(OP_MUL);
			(yyval.expr_p)->left.lchild_p = newnode(OP_FLOAT_LITERAL);
			(yyval.expr_p)->left.lchild_p->left.value = -1.0;
			(yyval.expr_p)->right.rchild_p = (yyvsp[0].expr_p);
		}
		else {
			(yyval.expr_p) = (yyvsp[0].expr_p);
		}
	}
#line 9998 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 7043 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = newnode((yyvsp[-3].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[-1].expr_p);
	}
#line 10007 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 7051 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = newnode((yyvsp[-5].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[-3].expr_p);
		(yyval.expr_p)->right.rchild_p = (yyvsp[-1].expr_p);
	}
#line 10017 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 7059 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = newnode(OP_FLOAT_LITERAL);
		(yyval.expr_p)->left.value = (yyvsp[0].floatval);
	}
#line 10026 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 7066 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = newnode(OP_TAG_REF);

		/* Get space to save info about this tag reference */
		MALLOC(TAG_REF, (yyval.expr_p)->left.ltag_p, 1);

		/* Get the address of the c[] associated with this tag.
		 * We also save which index into the c[]
		 */
		if (((yyval.expr_p)->left.ltag_p->c = symval((yyvsp[-2].stringval), &((yyval.expr_p)->left.ltag_p->c))) != 0) {
			(yyval.expr_p)->left.ltag_p->c_index = (yyvsp[0].intval);
			save_tag_ref((yyval.expr_p)->left.ltag_p->c, &((yyval.expr_p)->left.ltag_p->c));
		}

		if (index_type((yyvsp[0].intval)) == AX) {
			/* Remember this tag, in case user
			 * wants to do a time offset relative to it.
			 * We always take time offsets relative
			 * to the most recent horizontal tag
			 * in the current expression.
			 * Since there may be expressions as arguments
			 * to functions, we keep a stack of these. */
			Curr_timeref_tag_p = (yyval.expr_p)->left.ltag_p;
		}

		/* If this is the first tag of the proper direction in the
		 * expression, that's the base tag used to determine
		 * which staff/score the tag is associated with, if any */
		if (index_type((yyvsp[0].intval)) == AX && Curr_loc_info_p->hor_p == 0) {
			Curr_loc_info_p->hor_p = (yyval.expr_p)->left.ltag_p->c;
			save_tag_ref(Curr_loc_info_p->hor_p,
						&(Curr_loc_info_p->hor_p));
		}
		else if (index_type((yyvsp[0].intval)) == AY && Curr_loc_info_p->vert_p == 0) {
			Curr_loc_info_p->vert_p = (yyval.expr_p)->left.ltag_p->c;
			save_tag_ref(Curr_loc_info_p->vert_p,
						&(Curr_loc_info_p->vert_p));
		}
	}
#line 10070 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 7108 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_timeref_tag_p == 0) {
			yyerror("time offset requires a prior horizontal tag reference");
			(yyval.expr_p) = 0;
		}
		else if (is_builtin_tag(Curr_timeref_tag_p->c)) {
			yyerror("cannot have a time offset relative to a builtin tag like _win or _page");
			(yyval.expr_p) = 0;
		}
		else {
			(yyval.expr_p) = newnode(OP_TIME_OFFSET);
			(yyval.expr_p)->left.value = (yyvsp[0].floatval);
			MALLOC(TAG_REF, (yyval.expr_p)->right.rtag_p, 1);
			(yyval.expr_p)->right.rtag_p = Curr_timeref_tag_p;
			save_tag_ref((yyval.expr_p)->right.rtag_p->c,
						&((yyval.expr_p)->right.rtag_p->c));
		}
	}
#line 10093 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 7130 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid letters are w and y */
		if (*yytext == 'w') {
			(yyval.intval) = AW;
		}
		else if (*yytext == 'y') {
			(yyval.intval) = AY;
		}
		else {
			yyerror("invalid direction: must be x, y, e, w, n or s");
			/* Return something valid, so if any code tries
			 * to use it later, it won't core dump */
			(yyval.intval) = AX;
		}
	}
#line 10113 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 7147 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = AX;
	}
#line 10121 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 7153 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid value is e */
		if (*yytext != 'e') {
			yyerror("invalid direction: must be x, y, e, w, n or s");
		}
		(yyval.intval) = AE;
	}
#line 10133 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 7163 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = AN;
	}
#line 10141 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 7169 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = AS;
	}
#line 10149 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 7175 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (float) (yyvsp[0].intval);
	}
#line 10157 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 7180 "src/mup/gram.y" /* yacc.c:1646  */
    {
		sprintf(Tmpbuff,"%d.%s", (yyvsp[-2].intval), (yyvsp[0].stringval));
		(yyval.floatval) = (float) atof(Tmpbuff);
	}
#line 10166 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 7186 "src/mup/gram.y" /* yacc.c:1646  */
    {
		sprintf(Tmpbuff,"0.%s", (yyvsp[0].stringval));
		(yyval.floatval) = (float) atof(Tmpbuff);
	}
#line 10175 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 7192 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no decimal fraction part of float number */
		(yyval.stringval) = "";
	}
#line 10184 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 7202 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = yytext;
	}
#line 10192 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 7210 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Currstruct_p->u.line_p->linetype = (yyvsp[-6].intval);
		Currstruct_p->u.line_p->start = *((yyvsp[-3].inpcoord_p));
		Currstruct_p->u.line_p->end = *((yyvsp[-1].inpcoord_p));
		rep_inpcoord((yyvsp[-3].inpcoord_p), &(Currstruct_p->u.line_p->start));
		rep_inpcoord((yyvsp[-1].inpcoord_p), &(Currstruct_p->u.line_p->end));
		Currstruct_p->u.line_p->string = (yyvsp[0].stringval);

		/* copies of the location info went into the LINE struct,
		 * so we can free the original copy of the information */
		if ((yyvsp[-3].inpcoord_p)) {
			FREE((yyvsp[-3].inpcoord_p));
		}
		if ((yyvsp[-1].inpcoord_p)) {
			FREE((yyvsp[-1].inpcoord_p));
		}
		insertMAINLL(Currstruct_p, Mainlltc_p);
		Currstruct_p = (struct MAINLL *) 0;
	}
#line 10216 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 7231 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* null token to cause allocation of LINE struct */
		(void) contextcheck(C_MUSIC, "line");
		Currstruct_p = newMAINLLstruct(S_LINE, yylineno);
	}
#line 10226 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 7238 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = L_NORMAL;
	}
#line 10234 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 7248 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = 0;
	}
#line 10242 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 7253 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = fix_string((yyvsp[0].stringval), Titlefont, Titlesize, Curr_filename, yylineno);
	}
#line 10250 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 7259 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-6].intval) == L_WAVY) {
			l_warning(Curr_filename, yylineno,
						"wavy curve not allowed; using normal curve");
			(yyvsp[-6].intval) = L_NORMAL;
		}
		Currstruct_p->u.curve_p->curvetype = (yyvsp[-6].intval);
		insertMAINLL(Currstruct_p, Mainlltc_p);
		Currstruct_p = (struct MAINLL *) 0;
	}
#line 10265 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 7271 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(void) contextcheck(C_MUSIC, "curve");
		Currstruct_p = newMAINLLstruct(S_CURVE, yylineno);

		/* get space for a list of locations and mark it as empty */
		Item_count = 0;
		Currstruct_p->u.curve_p->ncoord = (short) Item_count;
		Currstruct_p->u.curve_p->nbulge = (short) Item_count;
		MALLOC(INPCOORD, Currstruct_p->u.curve_p->coordlist, ITEMS);
		Max_items = ITEMS;
	}
#line 10281 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 7305 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* get enough space to store some values if don't have enough */
		if (Currstruct_p->u.curve_p->nbulge == 0) {
			MALLOCA(float, Currstruct_p->u.curve_p->bulgelist, ITEMS);
		}
		else if ( (Currstruct_p->u.curve_p->nbulge % ITEMS) == 0) {
			REALLOCA(float, Currstruct_p->u.curve_p->bulgelist,
				Currstruct_p->u.curve_p->nbulge + ITEMS);
		}

		/* fill in the value and increment the count of how many */
		Currstruct_p->u.curve_p->bulgelist[Currstruct_p->u.curve_p->nbulge] = (yyvsp[-1].intval) * (yyvsp[0].floatval);
		(Currstruct_p->u.curve_p->nbulge)++;
	}
#line 10300 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 7321 "src/mup/gram.y" /* yacc.c:1646  */
    {
		struct INPCOORD *curve_inpcoord_p;

		/* If ran off end of list, make list bigger.
		 * We cannot use REALLOC here, since we need to update
		 * the tag reference information on each individual array
		 * element, so we alloc all new space, copy the existing data,
		 * and update the tag references, then free the old space,
		 * and redirect the pointer to the new space. */
		if (Currstruct_p->u.curve_p->ncoord >= Max_items) {
			struct INPCOORD *newlist_p;
			int n;
			Max_items += ITEMS;
			MALLOC(INPCOORD, newlist_p, Max_items);
			for (n = 0; n < Currstruct_p->u.curve_p->ncoord; n++) {
				newlist_p[n] = Currstruct_p->u.curve_p->coordlist[n];
				rep_inpcoord(
				    &(Currstruct_p->u.curve_p->coordlist[n]),
				    &(newlist_p[n]));
			}
			FREE(Currstruct_p->u.curve_p->coordlist);
			Currstruct_p->u.curve_p->coordlist = newlist_p;
		}

		/* Add this entry to the end of the list, update the
		 * tag reference to point to this permanent copy rather
		 * the temporary one we will be deleting, and update the
		 * count of how many elements in the list. */
		curve_inpcoord_p = &(Currstruct_p->u.curve_p->coordlist
					[Currstruct_p->u.curve_p->ncoord]);
		*curve_inpcoord_p = *((yyvsp[0].inpcoord_p));
		rep_inpcoord((yyvsp[0].inpcoord_p), curve_inpcoord_p);
		(Currstruct_p->u.curve_p->ncoord)++;
		FREE((yyvsp[0].inpcoord_p));
	}
#line 10340 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 7358 "src/mup/gram.y" /* yacc.c:1646  */
    {
		attach_stuff();
		/* so reset flag */
		Defining_multiple = NO;
	}
#line 10350 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 7366 "src/mup/gram.y" /* yacc.c:1646  */
    {
		chk_stuff_header((yyvsp[-5].intval), (yyvsp[-4].intval), (yyvsp[-3].intval), Dist_usage);
		add_to_sv_list();
	}
#line 10359 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 7373 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Separate rule for phrase because it has the linetype
		 * modifier in front, unlike any other STUFF. The size,
		 * and dist are not really allowed, but we match them
		 * if they are there in order to give more clear error
		 * message than just "syntax error," since there was
		 * already code elsewhere to check for these errors.
		 */
		set_stuff_type(ST_PHRASE);
		chk_stuff_header((yyvsp[-3].intval), (yyvsp[-5].intval), (yyvsp[-2].intval), Dist_usage);
		add_to_sv_list();
		Aligntag = NOALIGNTAG;
	}
#line 10377 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 7388 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* need a separate rule for midi, because it can include
		 * a voice as well as staff. It also cannot have the chord,
		 * size or place, although those are checked elsewhere anyway */
		chk_stuff_header(-1, NO, PL_UNKNOWN, SD_NONE);
		Aligntag = NOALIGNTAG;
	}
#line 10389 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 7398 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_stuff_type(ST_MIDI);
		begin_range(PL_UNKNOWN);
	}
#line 10398 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 7408 "src/mup/gram.y" /* yacc.c:1646  */
    {
		all();
		add_to_sv_list();
	}
#line 10407 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 743:
#line 7415 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* dummy token for sole purpose of saving away current
		 * stuff type. We have to do this in order to have it in
		 * time to figure out the default place for "all" */
		set_stuff_type((yyvsp[0].intval));
	}
#line 10418 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 7424 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_family = (yyvsp[-1].intval);

		switch ((yyvsp[0].intval)) {
		case FONT_TR:
			(yyval.intval) = ST_ROM;
			break;
		case FONT_TI:
			(yyval.intval) = ST_ITAL;
			break;
		case FONT_TB:
			(yyval.intval) = ST_BOLD;
			break;
		case FONT_TX:
			(yyval.intval) = ST_BOLDITAL;
			break;
		default:
			pfatal("unknown font");
			break;
		}
	}
#line 10444 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 7448 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) != L_NORMAL) {
			/* user used 'dotted' or 'dashed' which applies only
			 * to use of T_L_ANGLE for slurs. Use generic error
			 * message so looks like any other similar error. */
			yyerror("syntax error");
		}
		(yyval.intval) = ST_CRESC;
	}
#line 10458 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 7460 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = ST_DECRESC;
	}
#line 10466 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 7466 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = ST_PEDAL;
	}
#line 10474 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 7472 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = ST_MUSSYM;
	}
#line 10482 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 7478 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = ST_OCTAVE;
	}
#line 10490 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 7484 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* use -1 to indicate user didn't specify so must use default */
		(yyval.intval) = -1;
	}
#line 10499 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 7491 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[-1].intval);
	}
#line 10507 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 7496 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = TM_NONE;
	}
#line 10515 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 7502 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 10523 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 754:
#line 7507 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Dist = 0.0;
		Dist_usage = SD_NONE;
	}
#line 10532 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 7514 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].intval) != DIST) {
			yyerror("unexpected parameter name instead of 'dist'");
		}
		else {
			if (frangecheck((yyvsp[0].floatval), -MAXDIST, MAXDIST, "dist") == YES) {
				Dist = (yyvsp[0].floatval);
			}
		}
	}
#line 10547 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 7527 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (yyvsp[-1].floatval);
	}
#line 10555 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 7533 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Dist_usage != SD_FORCE) {
			l_warning(Curr_filename, yylineno,
				"negative dist requires !, setting to 0");
			(yyval.floatval) = 0.0;
		}
		else {
			(yyval.floatval) = - (yyvsp[-1].floatval);
		}
	}
#line 10570 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 7545 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Dist_usage = SD_MIN;
	}
#line 10578 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 7551 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Dist_usage = SD_FORCE;
	}
#line 10586 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 7556 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Aligntag = NOALIGNTAG;
	}
#line 10594 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 7562 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (rangecheck((yyvsp[0].intval), MINALIGNTAG, MAXALIGNTAG, "align tag number") == YES) {
			Aligntag = (yyvsp[0].intval);
		}
		else {
			Aligntag = NOALIGNTAG;
		}
	}
#line 10607 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 7580 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_stuff_item((yyvsp[-4].floatval), (yyvsp[-3].floatval), Start_gracebackup, (yyvsp[-2].stringval),
			Til_bars, Til_offset, Til_steps, End_gracebackup,
			Dist, Dist_usage, Aligntag);
	}
#line 10617 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 7588 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Til_bars = 0;
		Til_offset = 0.0;
		Til_steps = 0.0;
		(yyval.floatval) = (yyvsp[-1].floatval);
		Start_gracebackup = (yyvsp[0].intval);
	}
#line 10629 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 7597 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 0;
	}
#line 10637 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 7603 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[-1].intval);
	}
#line 10645 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 7608 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = 0.0;
	}
#line 10653 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 7614 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (yyvsp[-1].floatval) * (float) (yyvsp[-2].intval);
	}
#line 10661 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 7619 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (char *) 0;
	}
#line 10669 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 7625 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (get_stuff_type() != ST_PEDAL) {
			yyerror("'*' only valid with pedal");
		}
		MALLOCA(char, (yyval.stringval), 12);
		(yyval.stringval)[0] = FONT_MUSIC;
		(yyval.stringval)[1] = DFLT_SIZE;
		sprintf((yyval.stringval) + 2, "\\(endped)");
	}
#line 10683 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 7637 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (yyvsp[0].stringval);
	}
#line 10691 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 7642 "src/mup/gram.y" /* yacc.c:1646  */
    {
		End_gracebackup = 0;
	}
#line 10699 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 7648 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 10706 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 7653 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/** if there is a non-empty til_suffix, the floatnum better
		 ** have been an integer, and is really the number
		 * of bars. **/
		if ((yyvsp[0].intval) == YES) {
			Til_bars = (int) (yyvsp[-1].floatval);
			if ((yyvsp[-1].floatval) - Til_bars != 0.0) {
				yyerror("number of measures in til clause must be a whole number");
			}
		}
		else {
			/* only a number, that means it was really a beat offset */
			Til_offset = (yyvsp[-1].floatval);
		}
	}
#line 10726 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 7671 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
		End_gracebackup = (yyvsp[-1].intval);
		Til_steps = (yyvsp[0].floatval);
	}
#line 10736 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 7679 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = YES;
	}
#line 10744 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 7685 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Til_offset = 0.0;
		Til_steps = (yyvsp[0].floatval);
		End_gracebackup = (yyvsp[-1].intval);
	}
#line 10754 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 7693 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Til_offset = (yyvsp[-2].floatval);
		Til_steps = (yyvsp[0].floatval);
		End_gracebackup = (yyvsp[-1].intval);
	}
#line 10764 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 781:
#line 7703 "src/mup/gram.y" /* yacc.c:1646  */
    {
		newROLLINFO();
	}
#line 10772 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 7709 "src/mup/gram.y" /* yacc.c:1646  */
    {
		newROLLINFO();
		setrolldir(UP);
	}
#line 10781 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 7716 "src/mup/gram.y" /* yacc.c:1646  */
    {
		newROLLINFO();
		setrolldir(DOWN);
	}
#line 10790 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 7727 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save staffnum and voice 1 for start of roll */
		rollparam((yyvsp[0].intval), 1, -1, -1);
	}
#line 10799 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 7734 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save staff and voice for start of roll */
		rollparam((yyvsp[-1].intval), (yyvsp[0].intval), -1, -1);
	}
#line 10808 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 788:
#line 7743 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save staffnum, voice 1 for end of roll */
		rollparam(-1, -1, (yyvsp[0].intval), 1);
	}
#line 10817 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 7750 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save staffnum and voice for end of roll */
		rollparam(-1, -1, (yyvsp[-1].intval), (yyvsp[0].intval));
	}
#line 10826 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 7757 "src/mup/gram.y" /* yacc.c:1646  */
    {
		rolloffset( (double) (yyvsp[-1].floatval));
	}
#line 10834 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 7763 "src/mup/gram.y" /* yacc.c:1646  */
    {	
		rolloffset( (double) (yyvsp[-1].floatval));
	}
#line 10842 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 7768 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_family == FAMILY_DFLT) {
			Curr_family = Score.fontfamily;
		}
		String1 = (yyvsp[0].stringval);
		Extra = extra_needed(Curr_family + Curr_font, Curr_size, &String1);
		proc_printcmd((yyvsp[-2].intval), Curr_loc_info_p, String1,
			Curr_family + Curr_font, Curr_size, (yyvsp[-1].intval),
			NO, PU_NORMAL, NO, 0,
			((yyvsp[-1].intval) == YES ? Extra : (double) 0.0));
	}
#line 10858 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 7782 "src/mup/gram.y" /* yacc.c:1646  */
    {
		proc_printcmd(J_NONE, Curr_loc_info_p, (yyvsp[0].stringval), FONT_UNKNOWN,
				DFLT_SIZE, NO, YES, (yyvsp[-3].intval), (yyvsp[-1].intval), (yyvsp[-2].export_p), (double) 0.0);
		if ((yyvsp[-1].intval) == NO) {
			end_raw();
		}
	}
#line 10870 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 7792 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 10877 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 7796 "src/mup/gram.y" /* yacc.c:1646  */
    {
		begin_raw();
		(yyval.intval) = NO;
	}
#line 10886 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 7803 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = YES;
	}
#line 10894 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 7809 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == YES) {
			warning("nl ignored for postscript");
		}
		(yyval.intval) = PU_NORMAL;
	}
#line 10905 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 7818 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_loc_info_p = (struct INPCOORD *) 0;
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 10914 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 7824 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.export_p) = 0;
	}
#line 10922 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 7830 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.export_p) = (yyvsp[0].export_p);
	}
#line 10930 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 7839 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* add onto list and return the list */
		struct VAR_EXPORT *exp_p;
		for (exp_p = (yyvsp[-2].export_p); exp_p->next != 0; exp_p = exp_p->next) {
			;
		}
		exp_p->next = (yyvsp[0].export_p);
		(yyval.export_p) = (yyvsp[-2].export_p);
	}
#line 10944 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 7851 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyvsp[0].export_p)->tag_addr = symval((yyvsp[0].export_p)->name, &((yyvsp[0].export_p)->tag_addr));
		(yyval.export_p) = (yyvsp[0].export_p);
	}
#line 10953 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 7858 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyvsp[0].export_p)->tag_addr = symval((yyvsp[0].export_p)->name, &((yyvsp[0].export_p)->tag_addr));
		(yyval.export_p) = (yyvsp[0].export_p);
	}
#line 10962 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 7865 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].export_p)->index == NUMCTYPE && (yyvsp[0].export_p)->index != NUMCTYPE && (yyvsp[0].export_p)->index != EXPORT_ALL_STAFFS) {
			l_yyerror(Curr_filename, yylineno,
			"if alias does not have a dot and direction, tag must not either");
		}
		if ((yyvsp[-2].export_p)->index != NUMCTYPE && (yyvsp[0].export_p)->index == NUMCTYPE) {
			l_yyerror(Curr_filename, yylineno,
			"if alias has dot and direction, tag must also");
		}
		(yyvsp[0].export_p)->alias = (yyvsp[-2].export_p);
		(yyval.export_p) = (yyvsp[0].export_p);
	}
#line 10979 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 7879 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.export_p) = (yyvsp[0].export_p);
	}
#line 10987 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 7885 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (strcmp((yyvsp[0].stringval), "_staff") != 0) {
			pfatal("got arraytag other than _staff");
		}
		(yyval.export_p) = add_export((yyvsp[0].stringval), EXPORT_ALL_STAFFS);
	}
#line 10998 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 7894 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.export_p) = (yyvsp[0].export_p);
	}
#line 11006 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 7900 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* export all six [nsewxy] values */
		(yyval.export_p) = add_export((yyvsp[0].stringval), NUMCTYPE);
	}
#line 11015 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 7907 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.export_p) = add_export((yyvsp[-2].stringval), (yyvsp[0].intval));
	}
#line 11023 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 7921 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* this means print at default location */
		Curr_loc_info_p = (struct INPCOORD *) 0;
		(yyval.intval) = NO;
	}
#line 11033 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 7929 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_loc_info_p = (struct INPCOORD *) 0;
		(yyval.intval) = YES;
	}
#line 11042 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 7936 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
	}
#line 11050 "src/mup/ytab.c" /* yacc.c:1646  */
    break;


#line 11054 "src/mup/ytab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 7941 "src/mup/gram.y" /* yacc.c:1906  */


#include <stdio.h>


/* print error message along with current filename and line number */

int
yyerror(msg)

char *msg;

{
	if (strncmp(msg, "syntax error", 12) == 0 ||
			strncmp(msg, "parse error", 11) == 0) {
		/* beef up yacc's default syntax error message */
		if (*yytext == '\n') {
			l_yyerror(Curr_filename, yylineno,
				"error detected at end of line (maybe missing semicolon or other required element?)");
		}
		else if (is_internal_token(yytext) == YES) { 
			/* We add some funny tokens for our internal use
			 * when doing emptymeas parameter expansion.
			 * It is conceivable that there could be
			 * some (rare) scenarios where a user error
			 * in their value for that parameter would cause the
			 * parser to detect the error when it got to our
			 * funny token, and it would be very confusing to the
			 * user if we printed that out as the offending token,
			 * since they didn't input it, and it is chosen
			 * specifically to be strange looking.
			 */
			l_yyerror(Curr_filename, yylineno,
				"error detected during internal emptymeas parameter processing");
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"error detected at '%s'", yytext);
		}
	}
	else {
		l_yyerror(Curr_filename, yylineno, "%s", msg);
	}

	/* return something to keep lint happy */
	return(0);
}


/* if argument is surrounded by double quotes, remove them and return the
 * unquoted string. Actually just NULL out the end quote and return a
 * pointer to beyond the leading quote */

static char *
stripquotes(string)

char *string;

{
	char *p;

	p = string + strlen(string) - 1;
	if (*p == '"') {
		*p = '\0';
	}
	return( *string == '"' ? string + 1 : string);
}


/* Check if the given header/footer type has already been specified,
 * and if so, issue a warning. In any case, set Currblock_p
 * to the passed in BLOCKHEAD pointer. */

static void
chkdup_headfoot(bit, which, block_p)

int bit;	/* which GOT_* bit is associated with this head/foot thing */
char *which;	/* header, footer, header2, footer2 or left/right versions */
struct BLOCKHEAD *block_p;	/* assign this to Currblock_p */

{
	if ((bit & Gotheadfoot) != 0) {
		l_yyerror(Curr_filename, yylineno,
				"%s context specified more than once", which);
	}
	Gotheadfoot |= bit;
	Currblock_p = block_p;
}


/* If the given top/bot block has already been set without having been used,
 * issue a warning. In any case, set it to the Currblock_p value.
 */

static void
chkdup_topbot(block_p_p, blocktype)

struct BLOCKHEAD **block_p_p;	/* address of a FEED field like top_p, bot2_p,
				 * lefttop_p, rightbot_p, etc. What it points
				 * to will be updated with the value of
				 * Currblock_p. */
char *blocktype;		/* Name to be used on error message if the
				 * field was already set before. */

{
	if (*block_p_p != 0) {
		warning("%s redefined before being used", blocktype);
	}
	*block_p_p = Currblock_p;

}


/* when entering new context, need to save away everything about current one */

static void
end_prev_context()

{
	struct MAINLL *place_p;		/* where to insert SSV in main list */


	/* assume we will place at the end of main list. Later we'll set
	 * the right value if that assumption is wrong */
	place_p = Mainlltc_p;

	/* If current main list item hasn't been added to list yet,
	 * do that now. */
	if (Currstruct_p != (struct MAINLL *) 0 && Currstruct_p != place_p) {

		if (Currstruct_p->str == S_SSV) {

			if (List_of_staffs_p != (struct MAINLL *) 0) {
				yyerror("can't change context inside a measure");
				Currstruct_p = (struct MAINLL *) 0;
				return;
			}

			check_beamstyle(Currstruct_p->u.ssv_p);

			/* if is an SSV struct, we also need to set the
			 * correct values at this point, because the
			 * parser needs to know current values of some
			 * things (like font and point size) */
			asgnssv(Currstruct_p->u.ssv_p);

			/* if this SSV is after a FEED, we have to move it
			 * before the FEED in order to follow the rules of
			 * what comes when on the main list */
			for (   ; place_p != (struct MAINLL *) 0 &&
					place_p->str == S_FEED;
					place_p = place_p->prev) {
			}
		}

		insertMAINLL(Currstruct_p, place_p);
	}

	if (Currstruct_p != 0 && Currstruct_p->str == S_SSV) {
		/* memorize or recall beamstyle and timeunit if appropriate */
		remember_tsig_params(Currstruct_p);

		/* If user specified multiple staffs/voices, clone the
		 * necessary SSV nows */
		if (Currstruct_p->u.ssv_p->context == C_STAFF) {
			clone_staff_ssvs(place_p);
			free_rlists();
		}
		else if (Currstruct_p->u.ssv_p->context == C_VOICE) {
			clone_voice_ssvs(place_p);
			free_rlists();
		}
		Defining_multiple = NO;
	}

	if (Curr_usym_p != 0) {
		define_usym();
		Curr_usym_p = 0;
	}

	if (Context == C_SHAPES) {
		/* Note that if the user puts a shapes context as the very
		 * last context in their input, end_prev_context would not
		 * get called, so this finish_shape_map call would not
		 * get hit,  but since since nothing could refer to it,
		 * that wouldn't actually hurt anything. */
		finish_shape_map();
	}

	Curr_grpsyl_p = (struct GRPSYL *) 0;
	Currblock_p = (struct BLOCKHEAD *) 0;
	Currstruct_p = (struct MAINLL *) 0;
	set_win_coord(0);
}


/* If user gave a list of staffs for a "staff" context, clone copies of
 * the SSV that we made for the first on the list for the rest of the list. */

static void
clone_staff_ssvs(insert_p)

struct MAINLL *insert_p;
{
	struct SVRANGELIST *svr_p;
	struct RANGELIST *sr_p;		/* list of staff ranges */
	struct SSV *clone_src_p;	/* the SSV to clone */
	int s;				/* staff number */

	clone_src_p = Currstruct_p->u.ssv_p;
	for (svr_p = Svrangelist_p; svr_p != 0; svr_p = svr_p->next) {
		for (sr_p = svr_p->stafflist_p; sr_p != 0; sr_p = sr_p->next) { 
			for (s = sr_p->begin; s <= sr_p->end && s <= Score.staffs; s++) {
				if (clone_src_p->staffno == s) {
					/* skip past the clone source */
					continue;
				}
				clone1ssv(clone_src_p, insert_p, s, clone_src_p->voiceno);
			}
		}
	}
}


/* If user gave a list of staffs and/or voices  for a "voice" context,
 * clone copies of the SSV that we made for the first on the list
 * for the rest of the list. */

static void
clone_voice_ssvs(insert_p)

struct MAINLL *insert_p;

{
	struct SVRANGELIST *svr_p;
	struct RANGELIST *sr_p;		/* list of staff ranges */
	struct RANGELIST *vr_p;		/* list of voice ranges */
	struct SSV *clone_src_p;	/* the SSV to clone */
	int s;				/* staff number */
	int v;				/* voice number */
	int numvoices;			/* how many voices on current staff */
	int have_non_v3 = NO;		/* If any voice other than voice 3 */


	clone_src_p = Currstruct_p->u.ssv_p;
	for (svr_p = Svrangelist_p; svr_p != 0; svr_p = svr_p->next) {
	    for (sr_p = svr_p->stafflist_p; sr_p != 0; sr_p = sr_p->next) { 
		for (s = sr_p->begin; s <= sr_p->end && s <= Score.staffs; s++) {
		    numvoices = vscheme_voices(svpath(s, VSCHEME)->vscheme);
		    for (vr_p = svr_p->vnolist_p; vr_p != 0; vr_p = vr_p->next) {
			for (v = vr_p->begin; v <= vr_p->end && v <= numvoices; v++) {
				if (v != 3) {
					have_non_v3 = YES;
				}
				if (clone_src_p->staffno == s
						&& clone_src_p->voiceno == v) {
					/* skip past the clone source */
					continue;
				}
				clone1ssv(clone_src_p, insert_p, s, v);
			}
		    }
		}
	    }
	}

	if (clone_src_p->used[ALIGNRESTS] == YES && have_non_v3 == NO) {
		l_warning(Curr_filename, yylineno,
				"alignrests not used for voice 3; ignoring");
	}
}

/* Clone the given SSV and insert it in the specified place in the main list.
 * Change the copied versions staffno/voiceno to the specified values,
 * and do any additional error checks and processsing as needed.
 */

static void
clone1ssv(clone_src_p, insert_p, staffno, voiceno)

struct SSV *clone_src_p;
struct MAINLL *insert_p;
int staffno;
int voiceno;

{
	struct MAINLL *newmllssv_p;	/* the cloned SSV */

	newmllssv_p = newMAINLLstruct(S_SSV, Currstruct_p->inputlineno);
	memcpy(newmllssv_p->u.ssv_p, clone_src_p, sizeof(struct SSV));
	newmllssv_p->u.ssv_p->staffno = staffno;
	newmllssv_p->u.ssv_p->voiceno = voiceno;
	/* Fix beamstyle/timeunit. It could be different for each clone */
	remember_tsig_params(newmllssv_p);
	insertMAINLL(newmllssv_p, insert_p);

	/* Make sure any tab staffs have non-tabs above them.
	 * One disadvantage of waiting till making the clone to check this is
	 * that if there is a user error, the line number will be the end
	 * of the context rather than the one with "stafflines" on it.
	 * But the error message will tell them which staff is the problem,
	 * and this should be pretty rare--they have to be setting stafflines
	 * in a staff context for multiple staffs where the combination of
	 * staffs is illegal--so it doesn't seem worth the extra work it would
	 * be to be more precise. */
	if (newmllssv_p->u.ssv_p->context == C_STAFF &&
				newmllssv_p->u.ssv_p->used[STAFFLINES] == YES) {
		chk_tab(newmllssv_p);
	}
	asgnssv(newmllssv_p->u.ssv_p);
}


/* Check that the staffs/voices specified for an SSV are valid.
 * We only give a warning if all values specified are out of range.
 * If at least one is valid, we assume user did something like
 * 	voice 1-40 3
 * to set something for voice 3 on all staffs without having to worry
 * about which staffs actually have a voice 3.
 */

static void
chk_ssv_ranges(context)

UINT32B context;	/* expected to only be either C_STAFF or C_VOICE */

{
	struct SVRANGELIST *svr_p;	/* list of staff/voice ranges */
	struct RANGELIST *sr_p;		/* list of staff ranges */
	struct RANGELIST *vr_p;		/* list of voice ranges */
	int s;				/* staff number */
	int v;				/* voice number */
	int numvoices;			/* how many voices on current staff */


	for (svr_p = Svrangelist_p; svr_p != 0; svr_p = svr_p->next) {
	    for (sr_p = svr_p->stafflist_p; sr_p != 0; sr_p = sr_p->next) { 
		for (s = sr_p->begin; s <= sr_p->end; s++) {
		    if (context == C_STAFF) {
			if (s >= MINSTAFFS && s <= Score.staffs) {
				/* Found a valid one. One is all we need. */
				return;
			}
			continue;
		    }

		    /* a voice context */
		    numvoices = vscheme_voices(svpath(s, VSCHEME)->vscheme);
		    for (vr_p = svr_p->vnolist_p; vr_p != 0; vr_p = vr_p->next) { 
			for (v = vr_p->begin; v <= vr_p->end; v++) {
			    if (s >= MINSTAFFS && s <= Score.staffs &&
					v >= MINVOICES && v <= numvoices) {
				/* Found a valid one. One is all we need. */
				return;
			    }
			}
		    }
		}
	    }
	}
	/* Fell through all the loops without finding a single valid case */
	if (context == C_STAFF) {
		l_warning(Curr_filename, yylineno,
			"staff out of range; must be between %d and %d",
			MINSTAFFS, Score.staffs);
	}
	else {
		l_warning(Curr_filename, yylineno,
			"staff/voice combination out of range; staff must be between %d and %d, voice between %d and %d and within vscheme limit for the staff",
			MINSTAFFS, MAXSTAFFS, MINVOICES, MAXVOICES);
	}
}


/* if defining more than one voice at the moment, not valid to set
 * a location variable. Print message and reset flag so we don't
 * give any more of the same message this measure */

static void
var_valid()

{
	if (Defining_multiple == YES) {
		yyerror("location tag is only allowed when defining a single voice");
		Defining_multiple = NO;
	}
	else if (Chord_at_a_time == YES) {
		yyerror("location tag not allowed with chord-at-a-time input");
	}
}


/* Save information about a Mup variable that the user wants to have
 * exported to their PostScript */

static struct VAR_EXPORT *
add_export(varname, index)

char *varname;	/* Name of variable to be exported */
int index;	/* AX, AW, etc or NUMCTYPE if all are to be exported,
		 * or EXPORT_ALL_STAFFS for all indexes of all staffs */

{
	struct VAR_EXPORT *var_p;

	MALLOC(VAR_EXPORT, var_p, 1);
	var_p->name = strdup(varname);
	/* For now we set the alias to ourself. If the user specifies an
	 * alias, then that will be set later. But by defaulting to pointing
	 * to ourself, code can assume there is always an alias. */
	var_p->alias = var_p;
	var_p->index = index;
	var_p->next = 0;
	return(var_p);
}


/* do a print command like left, right, or center. Allocate a PRINTDATA
 * struct and fill in all the information about what to print and where
 * to print it. */

static void
proc_printcmd(justifytype, inpc_p, str, font, size, got_nl, isPostScript, ps_usage, isfilename, export_p, extra)

int justifytype;	/* J_LEFT, etc */
struct INPCOORD *inpc_p;	/* where to print */
char *str;		/* the string to print */
int font;
int size;
int got_nl;	/* YES if should go to next line before printing */
int isPostScript;	/* YES if is raw PostScript rather than normal print */
int ps_usage;		/* PU_* value; tells how is PostScript is used */
int isfilename;		/* Yes if the string is the name of a file containing PostScript */
struct VAR_EXPORT *export_p; /* Mup vars to export to user PostScript */
double extra;	/* how much extra vertical padding to add */

{
	struct PRINTDATA *curr_print_p;
	struct EXPR_NODE *node_p;
	int htype;


	(void) contextcheck(C_MUSIC | C_BLOCKHEAD, "print");

	/* save all the info in a PRINTDATA struct */
	MALLOC(PRINTDATA, curr_print_p, 1);

	if (inpc_p == (struct INPCOORD *) 0) {

		/* print at default location */
		curr_print_p->location.vert_p = symval("_cur", (float **) 0);
		/* Create an expression that is _cur - extra */
		node_p = newnode(OP_SUB);
		curr_print_p->location.vexpr_p = node_p;

		node_p->left.lchild_p = newnode(OP_TAG_REF);
		MALLOC(TAG_REF, node_p->left.lchild_p->left.ltag_p, 1);
		node_p->left.lchild_p->left.ltag_p->c = curr_print_p->location.vert_p;
		node_p->left.lchild_p->left.ltag_p->c_index = AY;
		save_tag_ref(node_p->left.lchild_p->left.ltag_p->c,
					&(node_p->left.lchild_p->left.ltag_p->c));

		node_p->right.rchild_p = newnode(OP_FLOAT_LITERAL);
		node_p->right.rchild_p->left.value = extra;

		switch (justifytype) {
		case J_LEFT:
		case J_RAGPARA:
		case J_JUSTPARA:
			/* default x is relative to _win.w */
			curr_print_p->location.hor_p = symval("_win", (float **) 0);
			htype = AW;
			break;
		case J_RIGHT:
			/* default x is relative to _win.e */
			curr_print_p->location.hor_p = symval("_win", (float **) 0);
			htype = AE;
			break;
		case J_CENTER:
			/* default x is relative to _win.x */
			curr_print_p->location.hor_p = symval("_win", (float **) 0);
			htype = AX;
			break;
		case J_NONE:
		default:
			/* default is at current location */
			curr_print_p->location.hor_p = symval("_cur", (float **) 0);
			htype = AX;
			break;
		}

		curr_print_p->location.hexpr_p = newnode(OP_TAG_REF);
		MALLOC(TAG_REF, curr_print_p->location.hexpr_p->left.ltag_p, 1);
		curr_print_p->location.hexpr_p->left.ltag_p->c = curr_print_p->location.hor_p;
		curr_print_p->location.hexpr_p->left.ltag_p->c_index = htype;
		save_tag_ref(curr_print_p->location.hexpr_p->left.ltag_p->c,
			&(curr_print_p->location.hexpr_p->left.ltag_p->c));

		/* If this is the first print command in a block,
		 * we implicitly go down by the font ascent. */
		if (isPostScript == NO && Currblock_p != 0
					&& Next_print_link_p_p
					== &(Currblock_p->printdata_p) ) {
			/* Alter expression, to subtract the fontascent */
			node_p = newnode(OP_SUB);
			node_p->left.lchild_p = curr_print_p->location.vexpr_p;
			curr_print_p->location.vexpr_p = node_p;
			node_p->right.rchild_p = newnode(OP_FLOAT_LITERAL);
			node_p->right.rchild_p->left.value = fontascent(font, size) / STEPSIZE;

			got_nl = NO;
		}

	}
	else {
		curr_print_p->location = *(inpc_p);
		rep_inpcoord(inpc_p, &(curr_print_p->location) );
		FREE(inpc_p);
	}

	curr_print_p->isPostScript = isPostScript;
	curr_print_p->ps_usage = ps_usage;
	curr_print_p->export_p = export_p;
	if (isPostScript == YES) {
		curr_print_p->width = 0.0;
	}
	else {
		curr_print_p->width = strwidth(str);
	}
	curr_print_p->isfilename = isfilename;
	curr_print_p->justifytype = (short) justifytype;
	curr_print_p->string = str;
	curr_print_p->inputfile = Curr_filename;
	curr_print_p->inputlineno = (short) yylineno;

	/* For PostScript hooks that apply once to the entire file,
	 * store directly into hook table. */
	switch (ps_usage) {
	case PU_AFTERPROLOG:
	case PU_BEFORETRAILER:
		if (PostScript_hooks[ps_usage] != 0) {
		l_warning(Curr_filename, yylineno, "PostScript hook already set on line %d of %s; using last",
			PostScript_hooks[ps_usage]->inputlineno,
			PostScript_hooks[ps_usage]->inputfile);
		}
		PostScript_hooks[ps_usage]  = curr_print_p;
		return;
	default:
		break;
	}

	/* special case of user asking that this be printed
	 * on the next line. In this case we go down by the
	 * current point size */
	if (got_nl) {
		node_p = newnode(OP_SUB);
		node_p->left.lchild_p = curr_print_p->location.vexpr_p;
		curr_print_p->location.vexpr_p = node_p;
		node_p->right.rchild_p = newnode(OP_FLOAT_LITERAL);
		node_p->right.rchild_p->left.value = fontheight(font, size) / STEPSIZE;
	}

	/* Now link onto proper list -- could be in BLOCKHEAD
	 * context or doing a PRHEAD. If we are in BLOCKHEAD context, we
	 * definitely have something in the main list to attach to.
	 * If in C_MUSIC, we may or may not depending on whether
	 * this is the first in a series of print commands. */
	if ( ((Context & C_BLOCKHEAD) != 0)
		|| ((Currstruct_p != (struct MAINLL *) 0) &&
		(Currstruct_p->str == S_PRHEAD) ) ) {
			if (Next_print_link_p_p == (struct PRINTDATA **) 0) {
				pfatal("Next_print_link_p_p is null");
			}
			/* this means the value of Next_print_link_p_p
			 * is valid and will tell us where to link */
			*Next_print_link_p_p = curr_print_p;
	}
	else {
		/* We must be in music context, but the last
		 * thing we saw wasn't a print command, so
		 * we have to allocate a PRHEAD and put it
		 * in the main list and attach to that. */
		/* allocate a new struct, put on main list and attach
		 * the print command to it */
		Currstruct_p = newMAINLLstruct(S_PRHEAD, yylineno);
		insertMAINLL(Currstruct_p, Mainlltc_p);
		Currstruct_p->u.prhead_p->printdata_p = curr_print_p;
		Currstruct_p = (struct MAINLL *) 0;
	}

	/* in any case, if we get another print command right away, it
	 * should be linked onto this one, so remember where we are */
	Next_print_link_p_p = &(curr_print_p->next);
	curr_print_p->next = (struct PRINTDATA *) 0;
}


/* if the given string has a higher ascent than the given font/size, return
 * the amount is it higher, in stepsizes */

static double
extra_needed(font, size, string_p)

int font;	/* default font for this string */
int size;	/* default size for this string */
char **string_p;/* string, before being put in internal format,
		 * which might contain \s(xx) to make it bigger than normal.
		 * If it is key-mapped, the passed-in pointer will be
		 * updated to point to the mapped string. */

{
	double usual_ascent;
	double this_string_ascent;


	/* get expected ascent for this font/size and actual for string */
	usual_ascent = fontascent(font, size);
	(void) fix_string(*string_p, font, size, Curr_filename, yylineno);
	*string_p = map_print_str(*string_p, Curr_filename, yylineno);
	this_string_ascent = strascent(*string_p);

	/* if this string is too tall, return by how much it is too tall */
	if (this_string_ascent > usual_ascent) {
		return (this_string_ascent - usual_ascent) / STEPSIZE;
	}
	else {
		return(0.0);
	}
}


/* Sometimes lexer will recognize something as a keyword, but it's
 * really a bunch of note letters, due to context. This function turns
 * the mistaken keyword into notes. It handles a through g and r and s, and
 * us, but not n, which would also be troublesome, but which we don't (yet)
 * need to handle.
 */

static void
keyword_notes(str)

char *str;

{
	for (  ; *str != '\0'; str++) {
		if (*str == 'u' && *(str+1) == 's') {
			str++;
			continue;
		}

		/* On the last letter, if it's a true pitch, have to
		 * push it back into input, because it could be followed
		 * by an accidental or octave mark or tick or something. */
		if (*(str+1) == '\0' && *str >= 'a' && *str <= 'g') {
			pushback(*str);
		}
		else {
			add_note(Curr_grpsyl_p, (int) *str, No_accs,
					USE_DFLT_OCTAVE, 0, NO, (char *) 0);
		}
	}
}


/* Free up the current additive time list, if any */

static void
free_extra_time()
{
	struct TIMELIST *tl_p;

	/* If this was the most recently allocated list, we can free it.
	 * We can't free otherwise, since Extra_time_p might be
	 * pointing to one from an SSV, which must be kept around. */
	if (Extra_time_p == Last_alloced_timelist_p) {
		while (Extra_time_p != 0) {
			tl_p = Extra_time_p->next;
			FREE(Extra_time_p);
			Extra_time_p = tl_p;
		}
	}
	Extra_time_p = 0;
	Last_alloced_timelist_p = 0;
	Curr_timelist_p = 0;
}


/* Add an item to the internal representation of the time signature
 * currently being collected */

static void
tsig_item(item)

int item;	/* the byte to add to timerep */

{
	if (Tsig_offset >= MAXTSLEN  - 1) {
		l_ufatal(Curr_filename, yylineno,
				"time signature is too complicated");
	}
	Timerep[Tsig_offset++] = (char) item;
}


/* Allocate a new expression node, fill in its opearator field, and return it. */

static struct EXPR_NODE *
newnode(op)

int op;		/* OP_* value for the new node */

{
	struct EXPR_NODE * node_p;

	CALLOC(EXPR_NODE, node_p, 1);
	node_p->op = op;
	return(node_p);
}


/* Zero out the list of accidentals for the current note */

static void
clear_curr_accs()

{
	CLEAR_ACCS(Curr_accs);
	Acc_offset = 0;
}


/* Add given accidental to the list of accidental for the current note.
 * (if it is valid and there is room) */

static void
add_acc(acc_name)

char *acc_name;

{
	int code;
	int font;
	int is_small;

	if (Acc_offset >= 2 * MAX_ACCS) {
		l_yyerror(Curr_filename, yylineno,
				"Too many accidentals (%d max)", MAX_ACCS);
		return;
	}
	is_small = NO;
	if (is_bad_char((code = find_char(acc_name, &font, &is_small, NO))) == YES) {
		l_yyerror(Curr_filename, yylineno,
			"No symbol named %s to use as accidental", acc_name);
		return;
	}

	/* Note that probably the font should be either one of the music
	 * fonts or user defined font, but we go ahead and allow anything. */
	Curr_accs[Acc_offset++] = font;
	Curr_accs[Acc_offset++] = code;

	/* If we have a non standard accidental, or if the accidentals
	 * net out to something outside the range of double flat to
	 * double sharp, mark Tuning_used, because we can't use simple
	 * ordinary MIDI commands. */
	if (accs_offset(Curr_accs) == BAD_ACCS_OFFSET) {
		Tuning_used = YES;
	}
}


/* Add another entry to the list of accidentals in accidentals context.
 * It is passed the name of the accidental. It allocates an entry,
 * if necessary, sets Curr_acc_index to the index of the entry, fills in
 * the code and font, and sets offsets to a negative value to indicate
 * "not yet filled in."
 */

static void
new_acc_entry(acc_name)

char *acc_name;		/* like "sharp" or "dlbflat" or a user name */

{
	int i;
	int is_small;


	if (Acc_contexts_list_p == 0) {
		/* must have been an earlier error */
		return;
	}

	/* Check for already defined */
	for (i = 0; i < Acc_contexts_list_p->size; i++) {
		if (strcmp(acc_name, get_charname(
				Acc_contexts_list_p->info[i].code,
				Acc_contexts_list_p->info[i].font))
				== 0) {
			/* Use the existing entry */
			Curr_acc_index = i;
			return;
		}
	}

	/* If space is full, alloc another chunk */
	if (Acc_contexts_list_p->size % ITEMS == 0
				&& Acc_contexts_list_p->size > 0) {
		REALLOC(ACCINFO, Acc_contexts_list_p->info,
				Acc_contexts_list_p->size + ITEMS);
	}

	/* Use the next available slot */
	Curr_acc_index = Acc_contexts_list_p->size;

	/* One more slot being used */
	(Acc_contexts_list_p->size)++;

	/* Fill in all the offset slots with an illegal
	 * (i.e., negative) value, so we can tell later which the user
	 * has set. Normally I wouldn't hard-code a 7, but if the
	 * number of "white keys" a-g changes from 7, we have
	 * much bigger problems ;-). 
	 */
	for (i = 0; i < 7; i++) {
		CURR_ACC_ENTRY.offset[i] = -1.0;
	}

	/* Translate symbol name to code and font */
	CURR_ACC_ENTRY.code = find_char(acc_name,
					&(CURR_ACC_ENTRY.font), &is_small, YES);
}


/* Fill in an element of the offset[] array for a accidental,
 * in accidentals context. 
 */

static void
add_acc_offset(letter, offset)

int letter;	/* which index into offset[], 'a' is 0, 'b' is 1, etc */
double offset;	/* what value to fill in */

{
	int index;

	if (Context != C_ACCIDENTALS) {
		return;
	}
	if (Acc_contexts_list_p == 0) {
		/* Must have been earlier error */
		return;
	}

	index = letter - 'a';

	/* Check if already has been set */
	if (CURR_ACC_ENTRY.offset[index] >= 0 ) {
		l_warning(Curr_filename, yylineno,
			"offset for accidental '%s' specified more than once, using last", get_charname(CURR_ACC_ENTRY.code, CURR_ACC_ENTRY.font));
	}

	/* Warn about outrageous values. We consider an accidental
	 * that changes by more than a major third outrageous. */
	if (offset < 0.8 || offset > 1.25) {
		l_warning(Curr_filename, yylineno,
			"dubious accidental offset (factor of %f alters pitch by more than a major third)", offset);
	}

	/* Fill in the value */
	CURR_ACC_ENTRY.offset[index] = offset;
}


static int
comp_subbar(item1_p, item2_p)

#ifdef __STDC__
const void *item1_p;            /* the subbars to compare */
const void *item2_p;
#else
char *item1_p;          	/* the subbars to compare */
char *item2_p;
#endif

{
	struct SUBBAR_INSTANCE *sb1_p, *sb2_p;

	sb1_p = (struct SUBBAR_INSTANCE *) item1_p;
	sb2_p = (struct SUBBAR_INSTANCE *) item2_p;
	if (sb1_p->count < sb2_p->count) {
		return(-1);
	}
	else if (sb1_p->count > sb2_p->count) {
		return(1);
	}
	else {
		return(0);
	}
}


/* Given a MULTIWHOLE value (2, 4, or 8) return the corresponding BT_* value */
static int
multiwhole2basictime(value)

int value;

{
	if (value == 2) {
		return(BT_DBL);
	}
	else if (value == 4) {
		return(BT_QUAD);
	}
	else if (value == 8) {
		return(BT_OCT);
	}
	else {
		pfatal("invalid value %d passed to multiwhole2basictime", value);
		/*NOTREACHED*/
		return(0);
	}
}


/* Given a chordtranslation parameter "do/re/mi" string, split it into
 * the 7 syllables, and place them in the doremi_syls field of current SSV. */

static void
parse_doremi_string(str)

char *str;	/* Typically "do re mi fa sol la si" */

{
	int nsyl;	/* count of syllables */
	int syl_leng;
	char saved;


	if (Currstruct_p == 0 || Currstruct_p->u.ssv_p == 0) {
		/* Must have been a user error earlier */
		return;
	}

	CALLOCA(char *, Currstruct_p->u.ssv_p->doremi_syls, 7);
	/* This code is similar to that for noteheads parameter in assign.c */
	for (nsyl = 0; nsyl < 7; nsyl++) {
		/* skip any leading spaces */
		while (isspace(*str)) {
			str++;
		}
		if (*str == '\0') {
			break;
		}
		syl_leng = strcspn(str, " \t\r\n");
		saved = str[syl_leng];
		str[syl_leng] = '\0';
		Currstruct_p->u.ssv_p->doremi_syls[nsyl] =
				copy_string(str, FONT_TR, DFLT_SIZE);
		fix_string(Currstruct_p->u.ssv_p->doremi_syls[nsyl],
				FONT_TR, DFLT_SIZE,
				Curr_filename, yylineno);
		str[syl_leng] = saved;
		str += syl_leng;
	}
	while (isspace(*str)) {
		str++;
	}
	if (nsyl != 7 || *str != '\0') {
		l_yyerror(Curr_filename, yylineno,
			 "Wrong number of do/re/mi syllables; expecting 7");
		/* If there were less than 7, later code could attempt to
		 * access an uninitalized value, so fix that. */
		for (  ; nsyl < 7; nsyl++) {
			Currstruct_p->u.ssv_p->doremi_syls[nsyl] =
				copy_string(" ", FONT_TR, DFLT_SIZE);
		}
	}
}


/* Give warning if user forgot to add an end to match a samescorebegin
 * or samepagebeing. It doesn't really hurt anything, but might mean they
 * included more in the zone than intended, so seems worth a warning,
 * but not a error.
 */

void
check_same_ended()

{
	if (Doing_samescore == YES) {
		l_warning(Curr_filename, yylineno,
			"missing samescoreend");
	}
	if (Doing_samepage == YES) {
		l_warning(Curr_filename, yylineno,
			"missing samepageend");
	}
}
